unit colorgradientnew_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons, Menus, ComCtrls,
  Math, Types,
  Inifiles; //Fichier .ini;

type
  //RGB
  RgbHSL_ = record
    Cl: TColor;
    R, G, B: byte;
    H, S, L: integer;
  end;

  TabRec16x16_ = array[1..16, 1..16] of record
    Cl: TColor;
    Xp, Yp: integer;
    Rp, Gp, Bp: byte;
    Hp, Sp, Lp: integer;
    //0:Interieur, 1:Contours
    Contours: byte;
  end;
  TabRec16x16_2_ = array[1..16, 1..16] of record
    Cl: TColor;
    Hp, Sp, Lp: integer;
    Xp, Yp: integer;
    //0:Interieur, 1:Contours
    Contours: byte;
  end;
  //Tab real
  TabR256_ = array[1..16, 1..16] of real;
  //Tab Couleur
  TabTC3x3_ = array[1..3, 1..3] of TColor;
  TabTC256_ = array[1..256] of TColor;
  //Tab Integer
  TabI25_ = array[1..25] of integer;
  //Tab byte
  TriB256_ = array[1..256] of byte;

  //Matrices
  Matrice_r33_ = array[1..3, 1..3] of real;
  Matrice_I_5x5_ = array[1..5, 1..5] of integer;
  //Masque
  Masque3x3_ = record
    //Taile du masque 3x3, 5x5...
    M3x3: array[1..3, 1..3] of integer;
    //Max Negatif, Max Positif et Total
    N3: array[1..3] of integer;
  end;

  Masque5x5_ = record
    //Taile du masque 3x3, 5x5...
    M5x5: array[1..5, 1..5] of integer;
    //Max Negatif, Max Positif et Total
    N3: array[1..3] of integer;
  end;
  //Fenetre
  Fenetre_5x5_ = record
    //Matrice
    M: array[1..5, 1..5] of integer;
    //Réponse du filtre, Positif et Négatif, Max
    NPM: array[1..3] of integer;
  end;

  Fenetre3x3_ = record
    //Matrice 3x3
    M: array[1..3, 1..3] of integer;
    //Réponse du filtre, Positif et Négatif, Max
    NPM: array[1..3] of integer;
  end;

  Fenetre5x5_ = record
    //Matrice 5x5
    M: array[1..5, 1..5] of integer;
    //Réponse du filtre, Positif et Négatif, Max
    NPM: array[1..3] of integer;
  end;

  Fenetre_Bilan_ = record
    Rso, Gso, Bso: real;
    Hso, Sso, Lso: real;

    //RGB
    Rmin, Rmax: real;
    Gmin, Gmax: real;
    Bmin, Bmax: real;
    //Rm,Gm,Bm :integer;
    //Luminance
    LuMin, LuMax: real;
    Lu: real;
    //L
    Hmin, Hmax: real;
    Smin, Smax: real;
    Lmin, Lmax: real;
  end;

  MinMax_Img_ = record
    RmaxP, RmaxN: real;
    GmaxP, GmaxN: real;
    BmaxP, BmaxN: real;
  end;

  //Pour Point Blanc
  AR3_ = array[1..3] of real;

  //Matrices
  Matrice_ = array[1..3, 1..3] of real;

const
  //Fichier Ini
  IniNom_ = 'ColorGradientNew.ini';
  //Ecran XGA
  //1024 x 768- XGA
  //Fenêtre WdMain
  WinMaxX_ = 942;
  WinMaxY_ = 712;
  //-
  Zero_ = 0;
  CouleurMax_ = 256 * 256 * 256;
  //SVGA    :  800 x 600
  //XGA     : 1024 x 768
  //XGA +   : 1152 x 864
  //Full HD : 1920 x 1080

  //Separation des couleurs
  //                      S100                           S50
  //S100 L50              L50                            L50
  //                  H   R          G          B        H   R          G          B
  //ROUGE++++++++++++ 0   255        0          0        0
  //                      [0]        [0-110]    [0]
  //Orange début      25  255        110        0        10  192        85         64

  //ORANGE+++++++++++ 35                                 27  192        122        64
  //                      [0]        [100/190]  [0]
  //Jaune  début      45  255        190        0        45  192        160        64
  //                      [255-255]  [190-255]  [0]
  //JAUNE++++++++++++ 60  255        255        0        60  192        192        64
  //                      [255-190]  [0]        [0]
  //Vert   début      75  190        255        0        70  170        192        64
  //                      [190-0]    [0]        [0]
  //VERT++++++++++++ 120  0          255        0        120 64         192        64
  //                      [0]        [0]        [0-190]
  //Vert-bleu        ?                                   140  64         192        106

  //Bleu-clair début 165  0          255        190      170 64         192        170
  //                      [0]        [0]        [190-255]
  //BlEU CLAIR++++++ 180  0          255        255      180 64         192        192
  //                      [0]        [255-190]  [0]
  //Bleu début       195  0          190        255

  //Bleu début                                           220 64         106        192
  //                      [0]        [190-0]    [0]
  //BLEU++++++++++++ 240  0          0          255      240 64         64         192
  //                      [0-150]    [0]        [0]
  //Violet-Bleu                                          260 106        64         192

  //Violet début     275  150        0          255      290?170        64         192
  //                      [150-255]  [0]        [0]
  //VIOLET++++++++++ 300  255        0          255      300 190        64         192
  //                      [0]        [0]        [255-110]
  //Violet rouge début                                   320 192        64         149

  //Rouge début      335  255        0          110      350 192        64         85
  //                      [0]        [0]        [110-0]
  //ROUGE+++++++++++ 359  255        0          0

  //R       o       J       V    vb   b         B         v         R
  //0  25  35  45  60  75  120  165  180  195  240  275  300  335  360
  // 25  10  10  15  15  45   45   15   15   45   35   25   35   25

  //Précision
  Exp6_ = 6;
  Exp7_ = 7;
  MaxSpec_ = 24;
  //Img1
  ImgMaxX_ = 650;//0..600
  ImgMaxY_ = 650;//0..600
  //Histo
  //HistoMaxX_=360;
  //HistoMaxY_=100;
  //JPEG
  SizeSignature = $1100C0FF;
  JPEGSignature = $FFD8FF;
  //Col
  ColCream_ = $00E6F8FF;
  //Palette Wait
  Pal42Color_: array[1..42] of integer = (
    $008682C9,//5R
    $008082C9, $007184C7, $007484C6,
    $006D85C7,//5YR
    $006487C6, $005E8AC0, $00568CBB,
    $004C90B3,//5Y
    $004B92AD, $004B95A7, $004897A0,
    $004D9A97,//5GY
    $00559C8C, $00629E7F, $006F9F75,
    $007BA165,//5G
    $0086A25D, $008EA358, $0094A352,
    $009BA44D,//5BG
    $00A3A349,//5BG
    $00AAA245, $00B3A148, $00B9A04A,
    $00BD9D54,//5B
    $00C09C5C, $00C39A69, $00C99577,
    $00C69480,//5PB
    $00C69090, $00C38E98, $00C18BA2,
    $00BC8AA8,//5P
    $00B587B1, $00B287B4, $00A984BC,
    $00A084C0,//5RP
    $009882C3, $009381C6, $008A82C9,
    $008682C9//5R
    );
  //----- Arce en ciel -----
  //Arc en ciel +1   = 256 * 6 = 1536 couleurs
  //    ..      +2   = 128 * 6 =  768 couleurs
  //Arc en ciel +4   =  64 * 6 =  384 couleurs
  //    .;      +8   =  32 * 6 =  256 couleurs
  //    ..      +16  =  16 * 6 =   96 couleurs
  //    ..      +32  =   8 * 6 =   48 couleurs
  //    ..      +64  =   4 * 6 =   24 couleurs
  //    ..      +128 =   2 * 6 =   12 couleurs
  //    ..      +256 =   1 * 6 =    6 couleurs
  AeCmax256_ = 1535;
  AeCmax128_ = 767;
  AeCmax64_ = 383;
  AeCmax32_ = 255;
  AeCmax16_ = 95;
  AeCmax8_ = 47;

  //----- Point Blanc -----
  //Point Blanc,illuminant :
  //  Coordonnées RGB(x,y) et °K
  //----- Point blanc 1931 2° -----
  //Incandescent
  Point_Blanc_1931_02d_A_: AR3_ = (0.44757, 0.40745, 2856);
  //TC:Abandonné. Lumière au zénith
  Point_Blanc_1931_02d_B_: AR3_ = (0.34842, 0.35161, 4874);
  //TC:Abandonné. Lumière du jour moyenne
  Point_Blanc_1931_02d_C_: AR3_ = (0.310063, 0.31616, 6774);
  //Point_Blanc_D40_        :AR3_=(0,0,4000);
  //Point_Blanc_D45_        :AR3_=(0,0,4500);
  //TC:Lumière du jour
  Point_Blanc_1931_02d_D50_: AR3_ = (0.34567, 0.35850, 5003);
  //Point_Blanc_D50_        :AR3_=(0.3460,0.3532,5000);
  //RGB-XYZ matrix ???
  //0.6454357  0.1810338  0.1378262
  //0.3328028  0.6120668  0.0551305
  //0.0302548  0.0689653  0.7258845
  //Inverse
  // 1.8240711 -0.5048095 -0.3080027
  //-0.9934670  1.9228518  0.0425936
  //0.0183608 -0.1616470  1.3864203
  //TC:Lumière du jour
  Point_Blanc_1931_02d_D55_: AR3_ = (0.33242, 0.34743, 5503);
  //Point_Blanc_02d_D55_   :AR3_=(0.333,0.3421,5500);
  //RGB-XYZ matrix ???
  //0.6174333  0.1831228  0.1562660
  //0.3183640  0.6191296  0.0625064
  //0.0289422  0.0697611  0.8230008
  //Inverse
  // 1.9067979 -0.5277040 -0.3219715
  //-0.9821339  1.9009166  0.0421077
  // 0.0161942 -0.1425723  1.2228190
  //Point_Blanc_D60_   :AR3_=(0.3224,0.3324,6000);
  //TC:Lumière du jour
  Point_Blanc_1931_02d_D65_: AR3_ = (0.312713, 0.329016, 6504);
  //Point_Blanc_D65_   :AR3_=(0.3137,0.3239,6500);
  //RGB-XYZ matrix ???
  //0.5766690  0.1855582  0.1882286
  //0.2973450  0.6273636  0.0752915
  //0.0270314  0.0706889  0.9913375
  //Inverse
  // 2.0415879 -0.5650070 -0.3447314
  //-0.9692436  1.8759675  0.0415551
  // 0.0134443 -0.1183624  1.0151750
  //Point_Blanc_D70_   :AR3_=(0.3063,0.3164,7000);
  //TC:Lumière du jour
  Point_Blanc_1931_02d_D75_: AR3_ = (0.29902, 0.31485, 7504);
  //TC:Spectre plat d'égale énergie
  Point_Blanc_1931_02d_E_: AR3_ = (0.33333, 0.33333, 0);
  //TC:Fluorescent lumière du jour
  Point_Blanc_1931_02d_F1_: AR3_ = (0.31310, 0.33727, 6430);
  //TC:Fluorescent blanc froid
  Point_Blanc_1931_02d_F2_: AR3_ = (0.37208, 0.37529, 4230);
  //TC:Fluorescent
  Point_Blanc_1931_02d_F3_: AR3_ = (0.40910, 0.39430, 3450);
  //TC:Fluorescent blanc chaud
  Point_Blanc_1931_02d_F4_: AR3_ = (0.44018, 0.40329, 2940);
  //TC:Fluorescent lumière du jour
  Point_Blanc_1931_02d_F5_: AR3_ = (0.31379, 0.34530, 6350);
  //TC:Fluorescent blanc neutre
  Point_Blanc_1931_02d_F6_: AR3_ = (0.37790, 0.38835, 4150);
  //TC:   Simulateur D65
  Point_Blanc_1931_02d_F7_: AR3_ = (0.31292, 0.32933, 6500);
  //TC:   Simulateur D50
  Point_Blanc_1931_02d_F8_: AR3_ = (0.34588, 0.35875, 5000);
  //TC:   Fluorescent blanc froid
  Point_Blanc_1931_02d_F9_: AR3_ = (0.37417, 0.37281, 4150);
  //TC:   Philips TL85, Ultralume 50
  Point_Blanc_1931_02d_F10_: AR3_ = (0.34609, 0.35986, 5000);
  //TC:Philips TL84, Ultralume 40
  Point_Blanc_1931_02d_F11_: AR3_ = (0.38052, 0.37713, 4000);
  //TC:Philips TL83, Ultralume 30
  Point_Blanc_1931_02d_F12_: AR3_ = (0.43695, 0.40441, 3000);

  //----- Point blanc 1964 10° -----
  //Point_Blanc_1931_10d_A_     :AR3_=(0.45117,0.40594,2856);
  //Point_Blanc_1931_10d_B_     :AR3_=(0.34980,0.35270,4874);
  //Point_Blanc_1931_10d_C_     :AR3_=(0.31039,0.31905,6774);
  //Point_Blanc_1931_10d_D50_   :AR3_=(0.34773,0.35952,5003);
  //Point_Blanc_1931_10d_D55_   :AR3_=(0.33411,0.34877,5003);
  //Point_Blanc_1931_10d_D65_   :AR3_=(0.31382,0.33100,6504);
  //Point_Blanc_1931_10d_D75_   :AR3_=(0.29968,0.31740,7504);
  //Point_Blanc_1931_10d_E_     :AR3_=(0.33333,0.33333,0);
  //Point_Blanc_1931_10d_F1_    :AR3_=(0.31811,0.33559,6430);
  //Point_Blanc_1931_10d_F2_    :AR3_=(0.37925,0.36733,4230);
  //Point_Blanc_1931_10d_F3_    :AR3_=(0.41761,0.38324,3450);
  //Point_Blanc_1931_10d_F4_    :AR3_=(0.44920,0.39074,2940);
  //Point_Blanc_1931_10d_F5_    :AR3_=(0.31975,0.34246,6350);
  //Point_Blanc_1931_10d_F6_    :AR3_=(0.38660,0.37847,4150);
  //Point_Blanc_1931_10d_F7_    :AR3_=(0.31569,0.32960,6500);
  //Point_Blanc_1931_10d_F8_    :AR3_=(0.34902,0.35939,5000);
  //Point_Blanc_1931_10d_F9_    :AR3_=(0.37829,0.37045,4150);
  //Point_Blanc_1931_10d_F10_   :AR3_=(0.35090,0.35444,5000);
  //Point_Blanc_1931_10d_F11_   :AR3_=(0.38541,0.37123,4000);
  //Point_Blanc_1931_10d_F12_   :AR3_=(0.44256,0.39717,3000);

  //----- Matrices 3 x 3 -----
  //Passe-Bas
  //1-1
  //Matrice_3x3_Passe_Bas_1_:Matrice_I_3x3_=(
  // ( 1, 1, 1),
  // ( 1, 4, 1),
  // ( 1, 1, 1)
  //);
  //Matrice_3x3_Passe_Bas_1_NPT_:array[1..3] of integer=(0,12,12);
  //Filtre Sobel 2
  //Matrice_3x3_Sobel_2_:Matrice_I_3x3_=(
  // ( 1, 0,-1),
  // ( 2, 0,-2),
  // ( 1, 0,-1)
  //);

  //Filtre Sobel 3
  //Matrice_3x3_Sobel_3_:Matrice_I_3x3_=(
  // ( 1, 2, 1),
  // ( 0, 0, 0),
  // (-1,-2,-1)
  //);

  //Filtre Sobel 4 H1
  //Matrice_3x3_Sobel_4_H1_:Matrice_I_3x3_=(
  // ( 1, 2, 1),
  // ( 0, 0, 0),
  // (-1,-2,-1)
  //);

  //Filtre Sobel 4 H2
  //Matrice_3x3_Sobel_4_H2_:Matrice_I_3x3_=(
  // ( 1, 2, 1),
  // (-2,-4,-2),
  // ( 1, 2, 1)
  //);

  //Filtre Sobel 5
  //Matrice_3x3_Sobel_5_:Matrice_I_3x3_=(
  // (-1, 0, 1),
  // (-2, 0, 2),
  // (-1, 0, 1)
  //);

  //Filtre Sobel 6 v1
  //Matrice_3x3_Sobel_6_v1_:Matrice_I_3x3_=(
  // ( 1, -2,  1),
  // ( 2, -4,  2),
  // ( 1, -2,  1)
  //);
  //Filtre Sobel 7 Neg
  //Matrice_3x3_Sobel_7_Neg_:Matrice_I_3x3_=(
  // ( 1, 0, -1),
  // ( 2, 0, -2),
  // ( 1, 0, -1)
  //);
  //Filtre Sobel 8 Cross
  //Matrice_3x3_Sobel_8_Cross_:Matrice_I_3x3_=(
  // (-1, 0,  1),
  // ( 0, 0,  0),
  // ( 1, 0, -1)
  //);
  //Filtre Laplacien 5
  //Matrice_3x3_laplacien_5_:Matrice_I_3x3_=(
  // (-1, -1, -1),
  // (-1,  8, -1),
  // (-1, -1, -1)
  //);
  //Filtre Laplacien 6
  //Matrice_3x3_Laplacien_6_:Matrice_I_3x3_=(
  // (2,  0,  2),
  // (0, -8,  0),
  // (2,  0,  2)
  //);
  //Filtre PreWitt Horizontal
  //Matrice_3x3_PreWitt_H_:Matrice_I_3x3_=(
  // ( 1,  1,  1),
  // ( 0,  0,  0),
  // (-1, -1, -1)
  //);
  //Filtre PreWitt Vertical
  //Matrice_3x3_PreWitt_V_:Matrice_I_3x3_=(
  // (-1,  0,  1),
  // (-1,  0,  1),
  // (-1,  0,  1)
  //);
  //Filtre Roberts Up
  //Matrice_3x3_Roberts_Up_:Matrice_I_3x3_=(
  // ( 0, 0, 0),
  // ( 0, 1, 0),
  // (-1, 0, 0)
  //);
  //Filtre Roberts Down
  //Matrice_3x3_Roberts_Down_:Matrice_I_3x3_=(
  // ( 0,  0,  0),
  // ( 0,  1,  0),
  // ( 0,  0, -1)
  //);
  //Filtre Scharr Horizontal
  //Matrice_3x3_Scharr_H_:Matrice_I_3x3_=(
  // ( 3,  10,  3),
  // ( 0,   0,  0),
  // (-3, -10, -3)
  //);
  //Filtre Scharr Vertical
  //Matrice_3x3_Scharr_V_:Matrice_I_3x3_=(
  // (-3,   0,   3),
  // (-10,  0,  10),
  // (-3,   0,   3)
  //);
  //Filtre Sharpen
  //Matrice_3x3_Sharpen_:Matrice_I_3x3_=(
  //-1/8  -1/8  -1/8
  //-1/8  16/8  -1/8
  //-1/8  -1/8  -1/8
  //-
  //----- Matrices 5 x 5 -----
  //-
  //Matrice création
  Matrice_5x5_Creation_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [ 0, 0]
  Matrice_5x5_Creation_1_NPT_: array[1..3] of integer = (0, 0, 0);
  //-
  //Repoussage
  //2-1
  Matrice_5x5_Repoussage_1_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, -2, -1, 0, 0),
    (0, -1, 1, 1, 0),
    (0, 0, 1, 2, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [ -4, 5]
  Matrice_5x5_Repoussage_1_NPT_: array[1..3] of integer = (-4, 5, 9);
  //-
  //laplacien 2
  //2-2
  Matrice_5x5_Laplacien_2_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, -1, -1, -1, 0),
    (0, -1, 8, -1, 0),
    (0, -1, -1, 1, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [ -7, 9]
  Matrice_5x5_Laplacien_2_NPT_: array[1..3] of integer = (-7, 9, 16);
  //-
  //Sobel 4 H01
  //2-3
  Matrice_5x5_Sobel_4_H01_: Matrice_I_5x5_ = (
    (1, 4, 6, 4, 1),
    (2, 8, 12, 8, 2),
    (0, 0, 0, 0, 0),
    (-2, -8, -12, -8, -2),
    (-1, -4, -6, -4, -1)
    );
  //Réponse du filtre [-48,48]
  Matrice_5x5_Sobel_4_H01_NPT_: array[1..3] of integer = (-48, 48, 96);
  //-
  //Sobel 4 V02
  //2-4
  Matrice_5x5_Sobel_4_H02_: Matrice_I_5x5_ = (
    (1, 4, 6, 4, 1),
    (0, 0, 0, 0, 0),
    (-2, -8, -12, -8, -2),
    (0, 0, 0, 0, 0),
    (1, 4, 6, 4, 1)
    );
  //Réponse du filtre [-32,32]
  Matrice_5x5_Sobel_4_H02_NPT_: array[1..3] of integer = (-32, 32, 64);
  //-
  //Sobel 6 V1
  //2-5
  Matrice_5x5_Sobel_6_V1_: Matrice_I_5x5_ = (
    (1, 0, -2, 0, 1),
    (4, 0, -8, 0, 4),
    (6, 0, -12, 0, 6),
    (4, 0, -8, 8, 4),
    (1, 0, -2, 0, 1)
    );
  //Réponse du filtre [-32,32]
  Matrice_5x5_Sobel_6_V1_NPT_: array[1..3] of integer = (-32, 32, 64);
  //-
  //Bords 2 V
  //2-6
  Matrice_5x5_Bords_V2_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, -1, 1, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [- 1, 1]
  Matrice_5x5_Bords_V2_NPT_: array[1..3] of integer = (-1, 1, 2);
  //-
  //laplacien 4
  //2-7
  Matrice_5x5_Laplacien_3_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 1, -2, 1, 0),
    (0, -2, 4, -2, 0),
    (0, 1, -2, 1, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [- 8,8]
  Matrice_5x5_Laplacien_3_NPT_: array[1..3] of integer = (-8, 8, 16);
  //-
  //Bords 1
  //2-8
  Matrice_5x5_Bords_1_: Matrice_I_5x5_ = (
    (1, 1, 1, 1, 1),
    (1, 0, 1, 0, 1),
    (1, 1, -4, 1, 1),
    (1, 0, 1, 0, 1),
    (1, 1, 1, 1, 1)
    );
  //Réponse du filtre [ -4,20]
  Matrice_5x5_Bords_1_NPT_: array[1..3] of integer = (-4, 20, 24);
  //-
  //Gradient vertical 2
  //2-9
  Matrice_5x5_Gradient_V2a_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, -1, 1, 0, 0),
    (0, -1, 1, 0, 0),
    (0, -1, 1, 0, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [- 3, 3]
  Matrice_5x5_Gradient_V2a_NPT_: array[1..3] of integer = (-3, 3, 6);
  //-
  //Gradient Horizontal 2a
  //2-10
  Matrice_5x5_Gradient_H2a_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, -1, -1, -1, 0),
    (0, 1, 1, 1, 0),
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [- 3, 3]
  Matrice_5x5_Gradient_H2a_NPT_: array[1..3] of integer = (-3, 3, 6);
  //-
  //Sobel V1 (Contours)
  //2-11
  Matrice_5x5_Sobel_V1_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 1, 0, -1, 0),
    (0, 2, 0, -2, 0),
    (0, 1, 0, -1, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [ -4, 4]
  Matrice_5x5_Sobel_V1_NPT_: array[1..3] of integer = (-4, 4, 8);
  //Matrice_5x5_Sobel_1_MaxN_=-1020;
  //-
  //Sobel H2
  //2-12
  Matrice_5x5_Sobel_H2_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 1, 2, 1, 0),
    (0, 0, 0, 0, 0),
    (0, -1, -2, -1, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [ -4, 4]
  Matrice_5x5_Sobel_H2_NPT_: array[1..3] of integer = (-4, 4, 8);
  //-
  //Sobel V3
  //2-13
  Matrice_5x5_Sobel_V3_: Matrice_I_5x5_ = (
    (1, 2, 0, -2, -1),
    (4, 8, 0, -8, -4),
    (6, 12, 0, -12, -6),
    (4, 8, 0, -8, -4),
    (1, 2, 0, -2, -1)
    );
  //Réponse du filtre [ -48,48]
  Matrice_5x5_Sobel_V3_NPT_: array[1..3] of integer = (-48, 48, 96);
  //-
  //Sobel V5
  //2-14
  Matrice_5x5_Sobel_V5_: Matrice_I_5x5_ = (
    (-1, -2, 0, 2, 1),
    (-4, -8, 0, 8, 4),
    (-6, -12, 0, 12, 6),
    (-4, -8, 0, 8, 4),
    (-1, -2, 0, 2, 1)
    );
  //Réponse du filtre [-48,48]
  Matrice_5x5_Sobel_V5_NPT_: array[1..3] of integer = (-48, 48, 96);
  //-
  //Sobel V7 Neg
  //2-15
  Matrice_5x5_Sobel_V7_Neg_: Matrice_I_5x5_ = (
    (1, 2, 0, -2, -1),
    (4, 8, 0, -8, -4),
    (6, 12, 0, -12, -6),
    (4, 8, 0, -8, -4),
    (1, 2, 0, -2, -1)
    );
  //Réponse du filtre [-48,48]
  Matrice_5x5_Sobel_V7_Neg_NPT_: array[1..3] of integer = (-48, 48, 96);
  //-
  //Sobel 8 Cross
  //2-16
  Matrice_5x5_Sobel_8_Cross_: Matrice_I_5x5_ = (
    (-1, -2, 0, 2, 1),
    (-2, -4, 0, 4, 2),
    (0, 0, 0, 0, 0),
    (2, 4, 0, -4, -2),
    (1, 2, 0, -2, -1)
    );
  //Réponse du filtre [-18,18]
  Matrice_5x5_Sobel_8_Cross_NPT_: array[1..3] of integer = (-18, 18, 36);
  //-
  //laplacien 1
  //2-17
  Matrice_5x5_Laplacien_1_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 0, -1, 0, 0),
    (0, -1, 4, -1, 0),
    (0, 0, -1, 0, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [- 4, 4]
  Matrice_5x5_Laplacien_1_NPT_: array[1..3] of integer = (-4, 4, 8);
  //-
  //Laplacien 5
  //2-18
  Matrice_5x5_Laplacien_5_: Matrice_I_5x5_ = (
    (2, 4, 4, 4, 2),
    (4, 0, -8, 0, 4),
    (4, -8, -24, -8, 4),
    (4, 0, -8, 0, 4),
    (2, 4, 4, 4, 2)
    );
  //Réponse du filtre [-56,-56]
  Matrice_5x5_Laplacien_5_NPT_: array[1..3] of integer = (-56, 56, 112);
  //-
  //Laplacien 3
  //2-19
  Matrice_5x5_Laplacien_4_: Matrice_I_5x5_ = (
    (-1, -3, -4, -3, -1),
    (-3, 0, 6, 0, -3),
    (-4, 6, 20, 6, -4),
    (-3, 0, 6, 0, -3),
    (-1, -3, -4, -3, -1)
    );
  //Réponse du filtre [-44,44]
  Matrice_5x5_Laplacien_4_NPT_: array[1..3] of integer = (-44, 44, 88);
  //-
  //Gradient Vertical 1a
  //2-20
  Matrice_5x5_Gradient_V1a_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 0, 1, -1, 0),
    (0, 0, 1, -1, 0),
    (0, 0, 1, -1, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [- 3, 3]
  Matrice_5x5_Gradient_V1a_NPT_: array[1..3] of integer = (-3, 3, 6);
  //-
  //Bords 3
  //2-21
  Matrice_5x5_Bords_3_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 0, -2, 0, 0),
    (0, -1, -6, -1, 0),
    (0, 0, -2, 0, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [-12, 0]
  Matrice_5x5_Bords_3_NPT_: array[1..3] of integer = (-12, 0, 12);
  //-
  //Gradient Horizontal 5
  //2-22
  Matrice_5x5_Gradient_H5_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 0, 0, 0, 0),
    (0, 1, 1, 1, 0),
    (0, -1, -1, -1, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [- 3, 3]
  Matrice_5x5_Gradient_H5_NPT_: array[1..3] of integer = (-3, 3, 6);
  //-
  //Passe-Haut 1
  //2-23
  Matrice_5x5_Passe_Haut_1_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 0, -1, 0, 0),
    (0, -1, 5, -1, 0),
    (0, 0, -1, 0, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [ -4, 5]
  Matrice_5x5_Passe_Haut_1_NPT_: array[1..3] of integer = (-4, 5, 9);
  //-
  //Passe-Haut 2
  //2-24
  Matrice_5x5_Passe_Haut_2_: Matrice_I_5x5_ = (
    (1, 1, 1, 1, 1),
    (1, 0, -1, 0, 1),
    (1, -1, 5, -1, 1),
    (1, 0, -1, 0, 1),
    (1, 1, 1, 1, 1)
    );
  //Réponse du filtre [ -4,21]
  Matrice_5x5_Passe_Haut_2_NPT_: array[1..3] of integer = (-4, 21, 25);
  //-
  //Lissage 1 (fort)
  //2-25
  Matrice_5x5_Lissage_1_: Matrice_I_5x5_ = (
    (1, 1, 1, 1, 1),
    (1, 1, 1, 1, 1),
    (1, 1, 1, 1, 1),
    (1, 1, 1, 1, 1),
    (1, 1, 1, 1, 1)
    );
  //Réponse du filtre [ 0,25]
  Matrice_5x5_Lissage_1_NPT_: array[1..3] of integer = (0, 25, 25);
  //-
  //Lissage 2 (moyen)
  Matrice_5x5_Lissage_2_: Matrice_I_5x5_ = (
    (1, 1, 1, 1, 1),
    (1, 1, 2, 1, 1),
    (1, 2, 4, 2, 1),
    (1, 1, 2, 1, 1),
    (1, 1, 1, 1, 1)
    );
  //Réponse du filtre [ 0,32]
  Matrice_5x5_Lissage_2_NPT_: array[1..3] of integer = (0, 32, 32);
  //-
  //Moyenne
  //2-27
  Matrice_5x5_Moyenne_1_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 1, 1, 1, 0),
    (0, 1, 1, 1, 0),
    (0, 1, 1, 1, 0),
    (0, 0, 0, 0, 0)
    );
  //Réponse du filtre [ 0, 9]
  Matrice_5x5_Moyenne_1_NPT_: array[1..3] of integer = (0, 9, 9);

  //Filtre Passe-Bas
  //3x3
  //1/9 1/9 1/9
  //1/9 1/9 1/9
  //1/9 1/9 1/9
  //5x5
  //1/25 1/25 1/25 1/25 1/25
  //1/25 1/25 1/25 1/25 1/25
  //1/25 1/25 1/25 1/25 1/25
  //1/25 1/25 1/25 1/25 1/25
  //1/25 1/25 1/25 1/25 1/25
  //Coordonnées trichromatiques x,y du lieu spectral
  DiagChroma2_: array[1..36, 1..2] of real = (
    //x,y          //Lambda
    (0.16, 0),     //450 nm
    (0.14, 0.025), //460 nm
    (0.125, 0.06), //470 nm
    (0.09, 0.16),  //480 nm
    (0.07, 0.2),   //490 nm
    (0.05, 0.29),  //500 nm
    (0.025, 0.42),
    (0.02, 0.54),
    (0.002, 0.66),
    (0.02, 0.75),
    (0.03, 0.82),
    (0.075, 0.835),
    (0.13, 0.83),
    (0.155, 0.8),
    (0.19, 0.785),
    (0.23, 0.751),
    (0.27, 0.725),
    (0.3, 0.69),
    (0.34, 0.615),
    (0.375, 0.625),
    (0.41, 0.59),
    (0.44, 0.56),
    (0.48, 0.525),
    (0.51, 0.49),
    (0.555, 0.545),
    (0.575, 0.455),  //590
    (0.6, 0.4),      //95
    (0.625, 0.375),
    (0.65, 0.35),
    (0.67, 0.33),
    (0.685, 0.32),
    (0.68, 0.31),
    (0.71, 0.29),
    (0.72, 0.275),
    (0.725, 0.27),
    (0.74, 0.27)
    );
  DiagChroma_: array[1..36, 1..2] of real = (
    //x,y          //Lambda
    //(0.17411, 0.00496),//380 nm
    (0.17380, 0.00492),//390 nm
    (0.17334, 0.00480),//400 nm
    (0.17258, 0.00480),//410 nm
    (0.17141, 0.00510),//420 nm
    (0.16888, 0.00690),//430 nm
    (0.16441, 0.01086),//440 nm
    (0.15664, 0.01771),//450 nm
    (0.14396, 0.02970),//460 nm
    (0.12412, 0.05780),//470 nm
    (0.10960, 0.08684),//475 nm
    (0.09129, 0.13270),//480 nm
    (0.06871, 0.20072),//485 nm
    (0.04539, 0.29498),//490 nm
    (0.02346, 0.41270),//495 nm
    (0.00817, 0.53842),//500 nm
    (0.00386, 0.65482),//505 nm
    (0.01387, 0.75019),//510 nm
    (0.07430, 0.83380),//520 nm
    (0.15472, 0.80586),//530 nm
    (0.22962, 0.75433),//540 nm
    (0.30160, 0.69231),//550 nm
    (0.37310, 0.62445),//560 nm
    (0.44406, 0.55472),//570 nm
    (0.51249, 0.48659),//580 nm
    (0.57515, 0.42423),//590 nm
    (0.62704, 0.37249),//600 nm
    (0.66576, 0.33401),//610 nm
    (0.69151, 0.30834),//620 nm
    (0.70792, 0.29203),//630 nm
    (0.71903, 0.28094),//640 nm
    (0.72599, 0.27401),//650 nm
    (0.72997, 0.27003),//660 nm
    (0.73199, 0.26801),//670 nm
    (0.73342, 0.26658),//680 nm
    (0.73439, 0.26561),//690 nm
    (0.73769, 0.26531) //700 nm
    );
  //Matrices
  //Adobe 1998 D50
  Matrice_Adobe_RGB_XYZ_1998_D50_RgbToXyz_: Matrice_ = (
    (0.6097559, 0.2052401, 0.1492240),
    (0.3111242, 0.6256560, 0.0632197),
    (0.0194811, 0.0608902, 0.7448387)
    );
  Matrice_Adobe_RGB_XYZ_1998_D50_XyzToRgb_: Matrice_ = (
    (1.9624274, -0.6105343, -0.3413404),
    (-0.9787684, 1.9161415, 0.0334540),
    (0.0286869, -0.1406752, 1.3487655)
    );
  //Adobe 1998 D65
  Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz_: Matrice_ = (
    (0.5767309, 0.1855540, 0.1881852),
    (0.2973769, 0.6273491, 0.0752741),
    (0.0270343, 0.0706872, 0.9911085)
    );
  //Site Adobe RGB -> XYZ 1998 D65
  //0.57667 0.18556 0.18823
  //0.29734 0.62736 0.07529
  //0.02703 0.07069 0.99134
  Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRgb_: Matrice_ = (
    (2.0413690, -0.5649464, -0.3446944),
    (-0.9692660, 1.8760108, 0.0415560),
    (0.0134474, -0.1183897, 1.0154096)
    );
  //Best RGB D50
  Matrice_Best_RGB_XYZ_D50_RgbToXyz_: Matrice_ = (
    (0.6326696, 0.2045558, 0.1269946),
    (0.2284569, 0.7373523, 0.0341908),
    (0.0000000, 0.0095142, 0.8156958)
    );
  Matrice_Best_RGB_XYZ_D50_XyzToRgb_: Matrice_ = (
    (1.7552599, -0.4836786, -0.2530000),
    (-0.5441336, 1.5068789, 0.0215528),
    (0.0063467, -0.0175761, 1.2256959)
    );
  //Beta RGB D50
  Matrice_Beta_RGB_XYZ_D50_RgbToXyz_: Matrice_ = (
    (0.6712537, 0.1745834, 0.1183829),
    (0.3032726, 0.6637861, 0.0329413),
    (0.0000000, 0.0407010, 0.7845090)
    );
  Matrice_Beta_RGB_XYZ_D50_XyzToRgb_: Matrice_ = (
    (1.6832270, -0.4282363, -0.2360185),
    (-0.7710229, 1.7065571, 0.0446900),
    (0.0400013, -0.0885376, 1.2723640)
    );
  //Bruce RGB D65
  Matrice_Bruce_RGB_XYZ_D65_RgbToXyz_: Matrice_ = (
    (0.4674162, 0.2944512, 0.1886026),
    (0.2410115, 0.6835475, 0.0754410),
    (0.0219101, 0.0736128, 0.9933071)
    );
  Matrice_Bruce_RGB_XYZ_D65_XyzToRgb_: Matrice_ = (
    (2.7454669, -1.1358136, -0.4350269),
    (-0.9692660, 1.8760108, 0.0415560),
    (0.0112723, -0.1139754, 1.01325)
    );
  //CIE RGB E
  Matrice_CIE_RGB_XYZ_E_RgbToXyz_: Matrice_ = (
    (0.4887180, 0.3106803, 0.2006017),   //0,062326  0,039621  0,025583
    (0.1762044, 0.8129847, 0.0108109),   //0,022471  0,10368   0,001379
    (0.0000000, 0.0102048, 0.9897952)    //0         0,001301  0,126228
    );
  Matrice_CIE_RGB_XYZ_E_XyzToRgb_: Matrice_ = (
    (2.3706743, -0.9000405, -0.4706338),
    (-0.5138850, 1.4253036, 0.0885814),
    (0.0052982, -0.0146949, 1.0093968)
    );
  //ColorMatch D50
  Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz_: Matrice_ = (
    (0.5093439, 0.3209071, 0.1339691),
    (0.2748840, 0.6581315, 0.0669845),
    (0.0242545, 0.1087821, 0.6921735)
    );
  Matrice_ColorMatch_RGB_XYZ_D50_XyzToRgb_: Matrice_ = (
    (2.6422874, -1.2234270, -0.3930143),
    (-1.1119763, 2.0590183, 0.0159614),
    (0.0821699, -0.2807254, 1.4559877)
    );
  //Don RGB 4 D50
  Matrice_Don_4_RGB_XYZ_D50_RgbToXyz_: Matrice_ = (
    (0.6457711, 0.1933511, 0.1250978),
    (0.2783496, 0.6879702, 0.0336802),
    (0.0037113, 0.0179861, 0.8035125)
    );
  Matrice_Don_4_RGB_XYZ_D50_XyzToRgb_: Matrice_ = (
    (1.7603902, -0.4881198, -0.2536126),
    (-0.7126288, 1.6527432, 0.0416715),
    (0.0078207, -0.0347411, 1.2447743)
    );
  //ECI RGB V2 D50
  Matrice_ECI_RGB_XYZ_D50_RgbToXyz_: Matrice_ = (
    (0.6502043, 0.1780774, 0.1359384),
    (0.3202499, 0.6020711, 0.0776791),
    (0.0000000, 0.0678390, 0.7573710)
    );
  Matrice_ECI_RGB_XYZ_D50_XyzToRgb_: Matrice_ = (
    (1.7827618, -0.4969847, -0.2690101),
    (-0.9593623, 1.9477962, -0.0275807),
    (0.0859317, -0.1744674, 1.3228273)
    );
  //Ekta Space PS5 D50
  Matrice_Ekta_Space_PS5_RGB_XYZ_D50_RgbToXyz_: Matrice_ = (
    (0.5938914, 0.2729801, 0.0973485),
    (0.2606286, 0.7349465, 0.0044249),
    (0.0000000, 0.0419969, 0.7832131)
    );
  Matrice_Ekta_Space_PS5_RGB_XYZ_D50_XyzToRgb_: Matrice_ = (
    (2.0043819, -0.7304844, -0.2450052),
    (-0.7110285, 1.6202126, 0.0792227),
    (0.0381263, -0.0868780, 1.2725438)
    );
  //NTSC RGB C
  //1 1 1 : 0.029768 0.030353 0.035887
  Matrice_NTSC_RGB_XYZ_C_RgbToXyz_: Matrice_ = (
    (0.6068909, 0.1735011, 0.2003480),
    (0.2989164, 0.5865990, 0.1144845),
    (0.0000000, 0.0660957, 1.1162243)
    );
  Matrice_NTSC_RGB_XYZ_C_XyzToRgb_: Matrice_ = (
    (1.9099961, -0.5324542, -0.2882091),
    (-0.9846663, 1.9991710, -0.0283082),
    (0.0583056, -0.1183781, 0.8975535)
    );
  //Pal-Secam D65
  //1 1 1 : 0.028849 0.030353 0.033049
  Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz_: Matrice_ = (
    (0.4306190, 0.3415419, 0.1783091),
    (0.2220379, 0.7066384, 0.0713236),
    (0.0201853, 0.1295504, 0.9390944)
    );
  Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRgb_: Matrice_ = (
    (3.0628971, -1.3931791, -0.4757517),
    (-0.9692660, 1.8760108, 0.0415560),
    (0.0678775, -0.2288548, 1.0693490)
    );
  //ProPhoto
  Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz_: Matrice_ = (
    (0.7976749, 0.1351917, 0.0313534),
    (0.2880402, 0.7118741, 0.0000857),
    (0.0000000, 0.0000000, 0.8252100)
    );
  Matrice_ProPhoto_RGB_XYZ_D50_XyzToRgb_: Matrice_ = (
    (1.3459433, -0.2556075, -0.0511118),
    (-0.5445989, 1.5081673, 0.0205351),
    (0.0000000, 0.0000000, 1.2118128)
    );
  //SMPTE-C RGB D65
  Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz_: Matrice_ = (
    (0.3935891, 0.3652497, 0.1916313),
    (0.2124132, 0.7010437, 0.0865432),
    (0.0187423, 0.1119313, 0.9581563)
    );
  Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRgb_: Matrice_ = (
    (3.5053960, -1.7394894, -0.5439640),
    (-1.0690722, 1.9778245, 0.0351722),
    (0.0563200, -0.1970226, 1.0502026)
    );
  //sRGB D65
  Matrice_sRGB_RGB_XYZ_D65_RgbToXyz_: Matrice_ = (
    //2,7690 + 1,7518 + 1,1300 = 5,6508
    //1,0000 + 4,5907 + 0,0601 = 5,6508
    //0,0000 + 0,0565 + 5,5943 = 5,6508
    (0.4124564, 0.3575761, 0.1804375),
    (0.2126729, 0.7151522, 0.0721750),
    (0.0193339, 0.1191920, 0.9503041)
    );
  Matrice_sRGB_RGB_XYZ_D65_XyzToRgb_: Matrice_ = (
    (3.2404542, -1.5371385, -0.4985314),
    (-0.9692660, 1.8760108, 0.0415560),
    (0.0556434, -0.2040259, 1.0572252)
    );

type

  { TWdMain }

  TWdMain = class(TForm)
    CheckBox1: TCheckBox;
    CkMem: TCheckBox;
    ComboBox1: TComboBox;
    CbMatrices: TComboBox;
    ComboBox2: TComboBox;
    ComboBox4: TComboBox;
    ComboBox6: TComboBox;
    EdB: TEdit;
    EdC11: TEdit;
    EdC21: TEdit;
    EdC31: TEdit;
    EdC41: TEdit;
    EdC51: TEdit;
    EdC12: TEdit;
    EdC22: TEdit;
    EdC32: TEdit;
    EdC42: TEdit;
    EdC52: TEdit;
    EdC13: TEdit;
    EdC23: TEdit;
    EdC33: TEdit;
    EdC43: TEdit;
    EdC53: TEdit;
    EdC14: TEdit;
    EdC24: TEdit;
    EdC34: TEdit;
    EdC44: TEdit;
    EdC54: TEdit;
    EdC15: TEdit;
    EdC25: TEdit;
    EdC35: TEdit;
    EdC45: TEdit;
    EdC55: TEdit;
    EdG: TEdit;
    EdH: TEdit;
    Edit1: TEdit;
    Edit4: TEdit;
    EdLe: TEdit;
    EdAe: TEdit;
    EdBe: TEdit;
    EdXx: TEdit;
    EdYx: TEdit;
    EdZx: TEdit;
    EdLum: TEdit;
    EdL: TEdit;
    EdR: TEdit;
    EdS: TEdit;
    EdX: TEdit;
    EdY: TEdit;
    Img1: TImage;
    LaB: TLabel;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label2: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    LaG: TLabel;
    LaH: TLabel;
    LaL: TLabel;
    LaR: TLabel;
    LaS: TLabel;
    LaSdM: TLabel;
    LaX: TLabel;
    LaY: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    MenuItem17: TMenuItem;
    MenuItem18: TMenuItem;
    MenuItem19: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem20: TMenuItem;
    MenuItem21: TMenuItem;
    MenuItem22: TMenuItem;
    MenuItem23: TMenuItem;
    MenuItem24: TMenuItem;
    MenuItem25: TMenuItem;
    MenuItem26: TMenuItem;
    MenuItem27: TMenuItem;
    MenuItem28: TMenuItem;
    MenuItem29: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem30: TMenuItem;
    MenuItem31: TMenuItem;
    MenuItem32: TMenuItem;
    MenuItem33: TMenuItem;
    MenuItem34: TMenuItem;
    MenuItem35: TMenuItem;
    MenuItem36: TMenuItem;
    MenuItem39: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem40: TMenuItem;
    MenuItem41: TMenuItem;
    MenuItem42: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    OpenDialog1: TOpenDialog;
    Pa1: TPanel;
    PaImg1: TPanel;
    PaLa: TPanel;
    PaHa: TPanel;
    PaLumRGB: TPanel;
    PaLumHSL: TPanel;
    PaMoyR: TPanel;
    PaMoyG: TPanel;
    PaMoyB: TPanel;
    PaMoyY: TPanel;
    PaNbre: TPanel;
    PaSdM: TPanel;
    PaZoom: TPanel;
    PaSelect: TPanel;
    Panel12: TPanel;
    PaImg0: TPanel;
    Pa02: TPanel;
    Pa03: TPanel;
    Panel2: TPanel;
    PaFile: TPanel;
    PaMatrice: TPanel;
    Pn11: TPanel;
    Pn12: TPanel;
    Pn13: TPanel;
    Pn14: TPanel;
    Pn15: TPanel;
    Pn16: TPanel;
    Pn17: TPanel;
    Pn18: TPanel;
    Pn19: TPanel;
    Pn21: TPanel;
    Pn22: TPanel;
    Pn23: TPanel;
    Pn24: TPanel;
    Pn25: TPanel;
    Pn26: TPanel;
    Pn27: TPanel;
    Pn28: TPanel;
    Pn29: TPanel;
    Pn31: TPanel;
    PaXY: TPanel;
    Pn32: TPanel;
    Pn33: TPanel;
    Pn34: TPanel;
    Pn35: TPanel;
    Pn36: TPanel;
    Pn37: TPanel;
    Pn38: TPanel;
    Pn39: TPanel;
    Pn41: TPanel;
    Pn42: TPanel;
    Pn43: TPanel;
    Pn44: TPanel;
    Pn45: TPanel;
    Pn46: TPanel;
    Pn47: TPanel;
    Pn49: TPanel;
    Pn48: TPanel;
    Pn51: TPanel;
    Pn52: TPanel;
    Pn53: TPanel;
    Pn54: TPanel;
    Pn55: TPanel;
    Pn56: TPanel;
    Pn57: TPanel;
    Pn59: TPanel;
    Pn58: TPanel;
    Pn61: TPanel;
    Pn62: TPanel;
    Pn63: TPanel;
    Pn64: TPanel;
    Pn65: TPanel;
    Pn66: TPanel;
    Pn67: TPanel;
    Pn69: TPanel;
    Pn68: TPanel;
    Pn71: TPanel;
    Pn72: TPanel;
    Pn73: TPanel;
    Pn74: TPanel;
    Pn75: TPanel;
    Pn76: TPanel;
    Pn77: TPanel;
    Pn78: TPanel;
    Pn79: TPanel;
    Pn81: TPanel;
    Pn82: TPanel;
    Pn83: TPanel;
    Pn84: TPanel;
    Pn85: TPanel;
    Pn86: TPanel;
    Pn87: TPanel;
    Pn88: TPanel;
    Pn89: TPanel;
    Pn91: TPanel;
    Pn92: TPanel;
    Pn93: TPanel;
    Pn94: TPanel;
    Pn95: TPanel;
    Pn96: TPanel;
    Pn97: TPanel;
    Pa10: TPanel;
    Pn98: TPanel;
    Pn99: TPanel;
    SaveDialog1: TSaveDialog;
    SpBLoad: TSpeedButton;
    Spdn1: TSpeedButton;
    SpdImg0: TSpeedButton;
    SpdMem: TSpeedButton;
    SpdNv1: TSpeedButton;
    SpdNv2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpdImg2: TSpeedButton;
    SpeedButton17: TSpeedButton;
    Spdn9: TSpeedButton;
    Spdn2: TSpeedButton;
    Spdn12: TSpeedButton;
    Spdn15: TSpeedButton;
    Spdn24: TSpeedButton;
    Spdn48: TSpeedButton;
    Spdn96: TSpeedButton;
    SpeedButton18: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton26: TSpeedButton;
    SpeedButton27: TSpeedButton;
    SpeedButton28: TSpeedButton;
    SpeedButton29: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton30: TSpeedButton;
    SpeedButton31: TSpeedButton;
    SpeedButton32: TSpeedButton;
    SpeedButton33: TSpeedButton;
    SpeedButton34: TSpeedButton;
    SpeedButton35: TSpeedButton;
    SpeedButton36: TSpeedButton;
    SpeedButton37: TSpeedButton;
    SpeedButton38: TSpeedButton;
    SpeedButton39: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton40: TSpeedButton;
    SpeedButton41: TSpeedButton;
    SpeedButton42: TSpeedButton;
    SpeedButton43: TSpeedButton;
    SpeedButton44: TSpeedButton;
    SpeedButton45: TSpeedButton;
    SpeedButton46: TSpeedButton;
    SpeedButton47: TSpeedButton;
    SpeedButton48: TSpeedButton;
    SpeedButton49: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton50: TSpeedButton;
    SpeedButton51: TSpeedButton;
    SpdPlus: TSpeedButton;
    SpdMoins: TSpeedButton;
    Spd00: TSpeedButton;
    SpdHisto: TSpeedButton;
    SpeedButton52: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    Timer1: TTimer;
    procedure CheckBox1Change(Sender: TObject);
    procedure CkMemChange(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure CbMatricesChange(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ComboBox6Change(Sender: TObject);
    procedure EdC11Change(Sender: TObject);
    procedure EdC11Click(Sender: TObject);
    procedure EdC11MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: boolean);
    procedure EdC11MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: boolean);
    procedure EdC12Change(Sender: TObject);
    procedure EdC13Change(Sender: TObject);
    procedure EdC14Change(Sender: TObject);
    procedure EdC15Change(Sender: TObject);
    procedure EdC21Change(Sender: TObject);
    procedure EdC21Click(Sender: TObject);
    procedure EdC22Change(Sender: TObject);
    procedure EdC23Change(Sender: TObject);
    procedure EdC24Change(Sender: TObject);
    procedure EdC25Change(Sender: TObject);
    procedure EdC31Change(Sender: TObject);
    procedure EdC31Click(Sender: TObject);
    procedure EdC32Change(Sender: TObject);
    procedure EdC33Change(Sender: TObject);
    procedure EdC34Change(Sender: TObject);
    procedure EdC35Change(Sender: TObject);
    procedure EdC41Change(Sender: TObject);
    procedure EdC41Click(Sender: TObject);
    procedure EdC42Change(Sender: TObject);
    procedure EdC43Change(Sender: TObject);
    procedure EdC44Change(Sender: TObject);
    procedure EdC45Change(Sender: TObject);
    procedure EdC51Change(Sender: TObject);
    procedure EdC51Click(Sender: TObject);
    procedure EdC12Click(Sender: TObject);
    procedure EdC22Click(Sender: TObject);
    procedure EdC32Click(Sender: TObject);
    procedure EdC42Click(Sender: TObject);
    procedure EdC52Change(Sender: TObject);
    procedure EdC52Click(Sender: TObject);
    procedure EdC13Click(Sender: TObject);
    procedure EdC23Click(Sender: TObject);
    procedure EdC33Click(Sender: TObject);
    procedure EdC43Click(Sender: TObject);
    procedure EdC53Change(Sender: TObject);
    procedure EdC53Click(Sender: TObject);
    procedure EdC14Click(Sender: TObject);
    procedure EdC24Click(Sender: TObject);
    procedure EdC34Click(Sender: TObject);
    procedure EdC44Click(Sender: TObject);
    procedure EdC54Change(Sender: TObject);
    procedure EdC54Click(Sender: TObject);
    procedure EdC15Click(Sender: TObject);
    procedure EdC25Click(Sender: TObject);
    procedure EdC35Click(Sender: TObject);
    procedure EdC45Click(Sender: TObject);
    procedure EdC55Change(Sender: TObject);
    procedure EdC55Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ImgHistoHMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: integer);
    procedure Img1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
    procedure MenuItem10Click(Sender: TObject);
    procedure MenuItem11Click(Sender: TObject);
    procedure MenuItem12Click(Sender: TObject);
    procedure MenuItem13Click(Sender: TObject);
    procedure MenuItem14Click(Sender: TObject);
    procedure MenuItem16Click(Sender: TObject);
    procedure MenuItem17Click(Sender: TObject);
    procedure MenuItem18Click(Sender: TObject);
    procedure MenuItem19Click(Sender: TObject);
    procedure MenuItem20Click(Sender: TObject);
    procedure MenuItem21Click(Sender: TObject);
    procedure MenuItem23Click(Sender: TObject);
    procedure MenuItem24Click(Sender: TObject);
    procedure MenuItem25Click(Sender: TObject);
    procedure MenuItem26Click(Sender: TObject);
    procedure MenuItem27Click(Sender: TObject);
    procedure MenuItem28Click(Sender: TObject);
    procedure MenuItem29Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem30Click(Sender: TObject);
    procedure MenuItem31Click(Sender: TObject);
    procedure MenuItem32Click(Sender: TObject);
    procedure MenuItem34Click(Sender: TObject);
    procedure MenuItem35Click(Sender: TObject);
    procedure MenuItem36Click(Sender: TObject);
    procedure MenuItem39Click(Sender: TObject);
    procedure MenuItem40Click(Sender: TObject);
    procedure MenuItem41Click(Sender: TObject);
    procedure MenuItem42Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem8Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
    procedure PaSelectClick(Sender: TObject);
    procedure Pn63Click(Sender: TObject);
    procedure SpBLoadClick(Sender: TObject);
    procedure SpdMemClick(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton15Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure SpdImg2Click(Sender: TObject);
    procedure SpeedButton17Click(Sender: TObject);
    procedure SpeedButton18Click(Sender: TObject);
    procedure Spdn9Click(Sender: TObject);
    procedure Spdn1Click(Sender: TObject);
    procedure Spdn12Click(Sender: TObject);
    procedure Spdn15Click(Sender: TObject);
    procedure Spd02Click(Sender: TObject);
    procedure Spdn24Click(Sender: TObject);
    procedure Spdn48Click(Sender: TObject);
    procedure Spdn96Click(Sender: TObject);
    procedure SpdImg0Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton26Click(Sender: TObject);
    procedure SpeedButton27Click(Sender: TObject);
    procedure SpeedButton28Click(Sender: TObject);
    procedure SpeedButton29Click(Sender: TObject);
    procedure Spdn2Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton30Click(Sender: TObject);
    procedure SpeedButton31Click(Sender: TObject);
    procedure SpeedButton32Click(Sender: TObject);
    procedure SpeedButton33Click(Sender: TObject);
    procedure SpeedButton34Click(Sender: TObject);
    procedure SpeedButton35Click(Sender: TObject);
    procedure SpeedButton36Click(Sender: TObject);
    procedure SpeedButton37Click(Sender: TObject);
    procedure SpeedButton38Click(Sender: TObject);
    procedure SpeedButton39Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton40Click(Sender: TObject);
    procedure SpeedButton41Click(Sender: TObject);
    procedure SpeedButton42Click(Sender: TObject);
    procedure SpeedButton43Click(Sender: TObject);
    procedure SpeedButton44Click(Sender: TObject);
    procedure SpeedButton45Click(Sender: TObject);
    procedure SpeedButton46Click(Sender: TObject);
    procedure SpeedButton47Click(Sender: TObject);
    procedure SpeedButton48Click(Sender: TObject);
    procedure SpeedButton49Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton50Click(Sender: TObject);
    procedure SpeedButton51Click(Sender: TObject);
    procedure SpdNv1Click(Sender: TObject);
    procedure SpdNv2Click(Sender: TObject);
    procedure SpdPlusClick(Sender: TObject);
    procedure SpdMoinsClick(Sender: TObject);
    procedure SpeedButton52Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure Spd00Click(Sender: TObject);
    procedure SpdHistoClick(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    MT_Matrice: integer;
    function RealToStr(Reel: real; Decimal: byte): string;
    function if_Integer(s: string): boolean;
    function Correction_Gamma_Inverse_2_4_sRGBToRGB(RGB: real): real;
    function Correction_Gamma_Inverse_G_sRGBToRGB(RGB, Gamma: real): real;
    procedure HSLtoRGB_H360_S1_L1_RGB255(H, S, L: real; Out R, G, B: byte);
    procedure Convert_RGB_Calculs;
    procedure Convert_Aff_Couleurs;
    procedure Convert_Aff_Barre_de_Niveau(Re, Ge, Be: byte);
    procedure Zoom_Affiche(Select, Xp, Yp: integer);
    procedure Img_XY_RGB_HSL(Select, x, y: integer);
  end;

var
  WdMain: TWdMain;
  DirOuvrir, DirSauver: string;
  Stop: boolean = False;
  //JPEG
  FoundAt: array[0..1] of int64;
  //Images
  ImgBmp: TBitmap;
  ImgJpg: TJPEGImage;
  Re: Trect;
  Img_Nom: string;
  //Arc en ciel
  //Arc en ciel +1   = 256 * 6 = 1536 couleurs
  //    ..      +2   = 128 * 6 =  768 couleurs
  //Arc en ciel +4   =  64 * 6 =  384 couleurs
  //    .;      +8   =  32 * 6 =  256 couleurs
  //    ..      +16  =  16 * 6 =   96 couleurs
  //    ..      +32  =   8 * 6 =   48 couleurs
  //    ..      +64  =   4 * 6 =   24 couleurs
  //    ..      +128 =   2 * 6 =   12 couleurs
  //    ..      +256 =   1 * 6 =    6 couleurs
  AeC256: array[0..AeCmax256_, 1..3] of byte;
  AeC64: array[0..AeCmax64_, 1..3] of byte;
  //Data des couleurs
  RgbHsl0: array[0..ImgMaxX_ - 1, 0..ImgMaxY_ - 1] of RgbHsl_;
  //Data2
  RgbHsl2: array[0..ImgMaxX_ - 1, 0..ImgMaxY_ - 1] of RgbHsl_;
  //Data3
  RgbHsl3: array[0..ImgMaxX_ - 1, 0..ImgMaxY_ - 1] of RgbHsl_;
  //Matrice création
  Matrice_Edition: Matrice_I_5x5_;
  //Moyenne Img1 RGN
  MoyY: integer;
  MoyR, MoyG, MoyB: byte;
  //Histogramme
  //Pour le décalage de l'Histo.
  HistoH, HistoS, HistoL: integer;
  Ptx: array[0..26000] of Tpoint;
  //Masques 5x5
  Matrice5x5: Masque5x5_;
  //Fenetre
  FenetreBilan: Fenetre_Bilan_;
  MinMaxImg: MinMax_Img_;
  //Min et Max de l'Image
  //Img_MinMax          :MinMax_;
  //Matrices : 1:5x5  2:3x3
  //MT_xy              :byte;
  MT_Niveau: integer;
  //Amplitude calculée à partir de la Matrice
  MT_Amplitude: real;
  //Pour la Matrice manuelle
  MT_Focus: integer;
  //Luminance
  LumiRGB, LumiHSL: integer;
  //Sauvegarde
  Sauve_Nb: integer;
  //Suppression des pixels isolés
  SupIso: integer;

implementation

uses colorgradientnew_wait, colorgradientnew_convert, colorgradientnew_histo,
  colorgradientnew_aide;

{$R *.lfm}

{ TWdMain }

function TWdMain.RealToStr(Reel: real; Decimal: byte): string;
var
  s: string;
begin
  Str(Reel: 0: Decimal, s); //avec 2 décimales
  Result := s;
end;

function StrToReal(Chaine: string): real;
var
  r: real;
  Pos: integer;
begin
  Val(Chaine, r, Pos);
  if Pos > 0 then
    Val(Copy(Chaine, 1, Pos - 1), r, Pos);
  Result := r;
end;

function TWdMain.if_Integer(s: string): boolean;
var
  n, Nb: integer;
  Ok: boolean;
begin
  Ok := False;
  if s <> '' then
  begin
    Nb := 0;
    for n := 1 to Length(s) do
      if s[n] in ['0'..'9'] then
        Inc(Nb);
    if Nb = Length(s) then
      Ok := True;
  end;
  Result := Ok;
end;

function if_Integer_PN(s: string): boolean;
var
  n, Nb, Ns: integer;
  Ok: boolean;
begin
  Ok := False;
  if s <> '' then
  begin
    Nb := 0;
    Ns := 0;
    for n := 1 to Length(s) do
      if s[n] = '-' then
      begin
        Inc(Ns);
      end
      else
      begin
        if s[n] in ['0'..'9'] then
          Inc(Nb);
      end;
    if Ns in [0, 1] then
    begin
      Nb := Nb + Ns;
      if Nb = Length(s) then
        Ok := True;
    end;
  end;
  Result := Ok;
end;

function Moyenne_Arithmetique_TC256(Tab: TabTC256_; Max: integer): real;
var
  Ma: real;
  n: integer;
begin
  Ma := 0;
  if Max <= 256 then
  begin
    for n := 1 to Max do
    begin
      Ma := Ma + Tab[n];
    end;
    Ma := Ma / Max;
  end;
  Result := Ma;
end;

function Ecart_Type_TC256(Tab: TabTC256_; MoyArith: TColor; Max: integer): real;
var
  Ec, Variance: real;
  n: integer;
begin
  Ec := 0;
  Variance := 0;
  if Max <= 256 then
  begin
    for n := 1 to Max do
    begin
      Variance := Variance + Sqr(MoyArith - Tab[n]);
    end;
    Variance := Variance / Max;
    Ec := Sqrt(Variance);
  end;
  Result := Ec;
end;

function Codage_24_bits(Poidsbas, PoidsMedian, PoidsHaut: integer): longword;
var
  lw: longword;
begin
  lw := PoidsBas + (PoidsMedian * 256) + (PoidsHaut * 256 * 256);
  Result := lw;
end;

procedure Decodage_24_bits(v: longword; Out Poidsbas, PoidsMedian, PoidsHaut: byte);
begin
  PoidsHaut := v shr 16;
  v := v - (PoidsHaut * 256 * 256);
  PoidsMedian := v shr 8;
  v := byte(v - (PoidsMedian * 256));
  PoidsBas := v;
end;

//----- Correction Gamma -----
function TWdMain.Correction_Gamma_Inverse_2_4_sRGBToRGB(RGB: real): real;
const
  Alpha_ = 0.055;
  Gamma_ = 2.4;
  //Gamma_=2.38300;
  //Gamma_=2.38794;
var
  Vc, Vs: real;
begin
  //----- Correction Gamma Inverse -----
  //Autre correction possible
  //G=255*(Capteur/256)^0.45; ^1/2.5=^0.4
  //G=255*(Capteur/256)^(1/gamma); Si Gamma=1/2.5=0.4
  //Correction Gamma-Inverse sRGB Companding
  //sRGB=k2*((RGB^(1/Gamma))/k1)
  //Vs=Tension source
  //Vc=Tension corrigée
  if RGB > 0.04045 then
  begin
    Vs := (RGB + Alpha_) / (1 + Alpha_);
    Vc := Power(Vs, Gamma_);
  end
  else
  begin
    if RGB > 0 then
      Vc := RGB / 12.92
    else
      Vc := 0;
  end;
  Result := Vc;
end;

function Correction_Gamma_3(RGB: integer; Gamma: real): integer;
var
  v: real;
begin
  if Gamma > 0 then
  begin
    v := RGB / 255;
    v := Power(v, Gamma) + 0.0001;
    Result := Round(v * 255);
  end
  else
  begin
    Result := 0;
  end;
end;

function Correction_Gamma_RGBtosRGB(RGBe: integer): integer;
const
  Gamma_ = 2.4;
var
  RGB, Vc: real;
begin
  RGB := RGBe / 255;
  if RGB > 0.0031308 then
  begin
    Vc := (1.055 * Power(RGB, Gamma_)) - 0.055;
  end
  else
  begin
    Vc := 12.92 * RGB;
  end;
  Vc := Vc * 255;
  Result := Round(Vc);
end;

//Lab
function Delta_E(L1, L2, a1, a2, b1, b2: real): real;
begin
  //Delta E=Racine((L1-L2)²+(a1-a2)²+(b1-b2)²)
  Result := Sqrt(Sqr(L1 - L2) + Sqr(a1 - a2) + Sqr(b1 - b2));
end;

function TWdMain.Correction_Gamma_Inverse_G_sRGBToRGB(RGB, Gamma: real): real;
begin
  //----- Correction Gamma Inverse -----
  //Vs=Tension source
  //Vc=Tension corrigée
  with WdConvert do
  begin
    EdxyX.Text := WdMain.RealToStr(RGB, 6);
    EdxyY.Text := '>';
  end;
  Result := Power(RGB, Gamma);
end;

//----- INI File -----
procedure Ini_Sauve;
var
  FIni: TiniFile;
begin
  with WdMain do
  begin
    FIni := TiniFile.Create(DirOuvrir + IniNom_);
    FIni.WriteBool('Init', 'Aide', WdAide.CheckAide.Checked);
    Fini.Free;
  end;
end;

procedure Ini_Lire;
var
  FIni: TiniFile;
  Fichier: string;
begin
  with WdMain do
  begin
    Fichier := DirOuvrir + IniNom_;
    if FileExists(Fichier) then
      with WdMain do
      begin
        FIni := TiniFile.Create(Fichier);
        WdAide.CheckAide.Checked := FIni.ReadBool('Init', 'Aide', False);
        Fini.Free;
      end;
  end;
end;

//----- Matrices Adobe 1998 D65 -----
procedure Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz_[1, 1] * R) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz_[1, 2] * G) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz_[1, 3] * B);
  Y := (Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz_[2, 1] * R) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz_[2, 2] * G) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz_[2, 3] * B);
  Z := (Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz_[3, 1] * R) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz_[3, 2] * G) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRgb_[1, 1] * X) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRgb_[1, 2] * Y) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRgb_[1, 3] * Z);
  G := (Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRgb_[2, 1] * X) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRgb_[2, 2] * Y) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRgb_[2, 3] * Z);
  B := (Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRgb_[3, 1] * X) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRgb_[3, 2] * Y) +
    (Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRgb_[3, 3] * Z);
end;

//----- Matrices Best RGB D50 -----
procedure Matrice_Best_RGB_XYZ_D50_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  //0.49+0.31+0.2=1
  //0.17696+0.8124+0.01063=1
  //0+0.01+0.99=1
  X := (Matrice_Best_RGB_XYZ_D50_RgbToXyz_[1, 1] * R) +
    (Matrice_Best_RGB_XYZ_D50_RgbToXyz_[1, 2] * G) +
    (Matrice_Best_RGB_XYZ_D50_RgbToXyz_[1, 3] * B);
  Y := (Matrice_Best_RGB_XYZ_D50_RgbToXyz_[2, 1] * R) +
    (Matrice_Best_RGB_XYZ_D50_RgbToXyz_[2, 2] * G) +
    (Matrice_Best_RGB_XYZ_D50_RgbToXyz_[2, 3] * B);
  Z := (Matrice_Best_RGB_XYZ_D50_RgbToXyz_[3, 1] * R) +
    (Matrice_Best_RGB_XYZ_D50_RgbToXyz_[3, 2] * G) +
    (Matrice_Best_RGB_XYZ_D50_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_Best_RGB_XYZ_D50_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_Best_RGB_XYZ_D50_XyzToRgb_[1, 1] * X) +
    (Matrice_Best_RGB_XYZ_D50_XyzToRgb_[1, 2] * Y) +
    (Matrice_Best_RGB_XYZ_D50_XyzToRgb_[1, 3] * Z);
  G := (Matrice_Best_RGB_XYZ_D50_XyzToRgb_[2, 1] * X) +
    (Matrice_Best_RGB_XYZ_D50_XyzToRgb_[2, 2] * Y) +
    (Matrice_Best_RGB_XYZ_D50_XyzToRgb_[2, 3] * Z);
  B := (Matrice_Best_RGB_XYZ_D50_XyzToRgb_[3, 1] * X) +
    (Matrice_Best_RGB_XYZ_D50_XyzToRgb_[3, 2] * Y) +
    (Matrice_Best_RGB_XYZ_D50_XyzToRgb_[3, 3] * Z);
end;

//----- Matrices Beta RGB D50 -----
procedure Matrice_Beta_RGB_XYZ_D50_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_Beta_RGB_XYZ_D50_RgbToXyz_[1, 1] * R) +
    (Matrice_Beta_RGB_XYZ_D50_RgbToXyz_[1, 2] * G) +
    (Matrice_Beta_RGB_XYZ_D50_RgbToXyz_[1, 3] * B);
  Y := (Matrice_Beta_RGB_XYZ_D50_RgbToXyz_[2, 1] * R) +
    (Matrice_Beta_RGB_XYZ_D50_RgbToXyz_[2, 2] * G) +
    (Matrice_Beta_RGB_XYZ_D50_RgbToXyz_[2, 3] * B);
  Z := (Matrice_Beta_RGB_XYZ_D50_RgbToXyz_[3, 1] * R) +
    (Matrice_Beta_RGB_XYZ_D50_RgbToXyz_[3, 2] * G) +
    (Matrice_Beta_RGB_XYZ_D50_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_Beta_RGB_XYZ_D50_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_Beta_RGB_XYZ_D50_XyzToRgb_[1, 1] * X) +
    (Matrice_Beta_RGB_XYZ_D50_XyzToRgb_[1, 2] * Y) +
    (Matrice_Beta_RGB_XYZ_D50_XyzToRgb_[1, 3] * Z);
  G := (Matrice_Beta_RGB_XYZ_D50_XyzToRgb_[2, 1] * X) +
    (Matrice_Beta_RGB_XYZ_D50_XyzToRgb_[2, 2] * Y) +
    (Matrice_Beta_RGB_XYZ_D50_XyzToRgb_[2, 3] * Z);
  B := (Matrice_Beta_RGB_XYZ_D50_XyzToRgb_[3, 1] * X) +
    (Matrice_Beta_RGB_XYZ_D50_XyzToRgb_[3, 2] * Y) +
    (Matrice_Beta_RGB_XYZ_D50_XyzToRgb_[3, 3] * Z);
end;

//----- Matrices Bruce RGB D65 -----
procedure Matrice_Bruce_RGB_XYZ_D65_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_Bruce_RGB_XYZ_D65_RgbToXyz_[1, 1] * R) +
    (Matrice_Bruce_RGB_XYZ_D65_RgbToXyz_[1, 2] * G) +
    (Matrice_Bruce_RGB_XYZ_D65_RgbToXyz_[1, 3] * B);
  Y := (Matrice_Bruce_RGB_XYZ_D65_RgbToXyz_[2, 1] * R) +
    (Matrice_Bruce_RGB_XYZ_D65_RgbToXyz_[2, 2] * G) +
    (Matrice_Bruce_RGB_XYZ_D65_RgbToXyz_[2, 3] * B);
  Z := (Matrice_Bruce_RGB_XYZ_D65_RgbToXyz_[3, 1] * R) +
    (Matrice_Bruce_RGB_XYZ_D65_RgbToXyz_[3, 2] * G) +
    (Matrice_Bruce_RGB_XYZ_D65_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_Bruce_RGB_XYZ_D65_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_Bruce_RGB_XYZ_D65_XyzToRgb_[1, 1] * X) +
    (Matrice_Bruce_RGB_XYZ_D65_XyzToRgb_[1, 2] * Y) +
    (Matrice_Bruce_RGB_XYZ_D65_XyzToRgb_[1, 3] * Z);
  G := (Matrice_Bruce_RGB_XYZ_D65_XyzToRgb_[2, 1] * X) +
    (Matrice_Bruce_RGB_XYZ_D65_XyzToRgb_[2, 2] * Y) +
    (Matrice_Bruce_RGB_XYZ_D65_XyzToRgb_[2, 3] * Z);
  B := (Matrice_Bruce_RGB_XYZ_D65_XyzToRgb_[3, 1] * X) +
    (Matrice_Bruce_RGB_XYZ_D65_XyzToRgb_[3, 2] * Y) +
    (Matrice_Bruce_RGB_XYZ_D65_XyzToRgb_[3, 3] * Z);
end;

//----- Matrices CIE RGB E -----
procedure Matrice_CIE_RGB_XYZ_E_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_CIE_RGB_XYZ_E_RgbToXyz_[1, 1] * R) +
    (Matrice_CIE_RGB_XYZ_E_RgbToXyz_[1, 2] * G) +
    (Matrice_CIE_RGB_XYZ_E_RgbToXyz_[1, 3] * B);
  Y := (Matrice_CIE_RGB_XYZ_E_RgbToXyz_[2, 1] * R) +
    (Matrice_CIE_RGB_XYZ_E_RgbToXyz_[2, 2] * G) +
    (Matrice_CIE_RGB_XYZ_E_RgbToXyz_[2, 3] * B);
  Z := (Matrice_CIE_RGB_XYZ_E_RgbToXyz_[3, 1] * R) +
    (Matrice_CIE_RGB_XYZ_E_RgbToXyz_[3, 2] * G) +
    (Matrice_CIE_RGB_XYZ_E_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_CIE_RGB_XYZ_E_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_CIE_RGB_XYZ_E_XyzToRgb_[1, 1] * X) +
    (Matrice_CIE_RGB_XYZ_E_XyzToRgb_[1, 2] * Y) +
    (Matrice_CIE_RGB_XYZ_E_XyzToRgb_[1, 3] * Z);
  G := (Matrice_CIE_RGB_XYZ_E_XyzToRgb_[2, 1] * X) +
    (Matrice_CIE_RGB_XYZ_E_XyzToRgb_[2, 2] * Y) +
    (Matrice_CIE_RGB_XYZ_E_XyzToRgb_[2, 3] * Z);
  B := (Matrice_CIE_RGB_XYZ_E_XyzToRgb_[3, 1] * X) +
    (Matrice_CIE_RGB_XYZ_E_XyzToRgb_[3, 2] * Y) +
    (Matrice_CIE_RGB_XYZ_E_XyzToRgb_[3, 3] * Z);
end;

//----- Matrices ColorMatch RGB D50 -----
procedure Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz_[1, 1] * R) +
    (Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz_[1, 2] * G) +
    (Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz_[1, 3] * B);
  Y := (Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz_[2, 1] * R) +
    (Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz_[2, 2] * G) +
    (Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz_[2, 3] * B);
  Z := (Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz_[3, 1] * R) +
    (Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz_[3, 2] * G) +
    (Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz_[3, 3] * B);
end;

//----- Matrices Don RGB 4 D50 -----
procedure Matrice_Don_4_RGB_XYZ_D50_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_Don_4_RGB_XYZ_D50_RgbToXyz_[1, 1] * R) +
    (Matrice_Don_4_RGB_XYZ_D50_RgbToXyz_[1, 2] * G) +
    (Matrice_Don_4_RGB_XYZ_D50_RgbToXyz_[1, 3] * B);
  Y := (Matrice_Don_4_RGB_XYZ_D50_RgbToXyz_[2, 1] * R) +
    (Matrice_Don_4_RGB_XYZ_D50_RgbToXyz_[2, 2] * G) +
    (Matrice_Don_4_RGB_XYZ_D50_RgbToXyz_[2, 3] * B);
  Z := (Matrice_Don_4_RGB_XYZ_D50_RgbToXyz_[3, 1] * R) +
    (Matrice_Don_4_RGB_XYZ_D50_RgbToXyz_[3, 2] * G) +
    (Matrice_Don_4_RGB_XYZ_D50_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_Don_4_RGB_XYZ_D50_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_Don_4_RGB_XYZ_D50_XyzToRgb_[1, 1] * X) +
    (Matrice_Don_4_RGB_XYZ_D50_XyzToRgb_[1, 2] * Y) +
    (Matrice_Don_4_RGB_XYZ_D50_XyzToRgb_[1, 3] * Z);
  G := (Matrice_Don_4_RGB_XYZ_D50_XyzToRgb_[2, 1] * X) +
    (Matrice_Don_4_RGB_XYZ_D50_XyzToRgb_[2, 2] * Y) +
    (Matrice_Don_4_RGB_XYZ_D50_XyzToRgb_[2, 3] * Z);
  B := (Matrice_Don_4_RGB_XYZ_D50_XyzToRgb_[3, 1] * X) +
    (Matrice_Don_4_RGB_XYZ_D50_XyzToRgb_[3, 2] * Y) +
    (Matrice_Don_4_RGB_XYZ_D50_XyzToRgb_[3, 3] * Z);
end;

//----- ECI RGB V2 D50 -----
procedure Matrice_ECI_RGB_XYZ_D50_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_ECI_RGB_XYZ_D50_RgbToXyz_[1, 1] * R) +
    (Matrice_ECI_RGB_XYZ_D50_RgbToXyz_[1, 2] * G) +
    (Matrice_ECI_RGB_XYZ_D50_RgbToXyz_[1, 3] * B);
  Y := (Matrice_ECI_RGB_XYZ_D50_RgbToXyz_[2, 1] * R) +
    (Matrice_ECI_RGB_XYZ_D50_RgbToXyz_[2, 2] * G) +
    (Matrice_ECI_RGB_XYZ_D50_RgbToXyz_[2, 3] * B);
  Z := (Matrice_ECI_RGB_XYZ_D50_RgbToXyz_[3, 1] * R) +
    (Matrice_ECI_RGB_XYZ_D50_RgbToXyz_[3, 2] * G) +
    (Matrice_ECI_RGB_XYZ_D50_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_ECI_RGB_XYZ_D50_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_ECI_RGB_XYZ_D50_XyzToRgb_[1, 1] * X) +
    (Matrice_ECI_RGB_XYZ_D50_XyzToRgb_[1, 2] * Y) +
    (Matrice_ECI_RGB_XYZ_D50_XyzToRgb_[1, 3] * Z);
  G := (Matrice_ECI_RGB_XYZ_D50_XyzToRgb_[2, 1] * X) +
    (Matrice_ECI_RGB_XYZ_D50_XyzToRgb_[2, 2] * Y) +
    (Matrice_ECI_RGB_XYZ_D50_XyzToRgb_[2, 3] * Z);
  B := (Matrice_ECI_RGB_XYZ_D50_XyzToRgb_[3, 1] * X) +
    (Matrice_ECI_RGB_XYZ_D50_XyzToRgb_[3, 2] * Y) +
    (Matrice_ECI_RGB_XYZ_D50_XyzToRgb_[3, 3] * Z);
end;

//----- Ekta Space PS5 D50 -----
procedure Matrice_Ecta_Space_PS5_RGB_XYZ_D50_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_RgbToXyz_[1, 1] * R) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_RgbToXyz_[1, 2] * G) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_RgbToXyz_[1, 3] * B);
  Y := (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_RgbToXyz_[2, 1] * R) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_RgbToXyz_[2, 2] * G) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_RgbToXyz_[2, 3] * B);
  Z := (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_RgbToXyz_[3, 1] * R) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_RgbToXyz_[3, 2] * G) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_Ecta_Space_PS5_RGB_XYZ_D50_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_XyzToRgb_[1, 1] * X) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_XyzToRgb_[1, 2] * Y) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_XyzToRgb_[1, 3] * Z);
  G := (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_XyzToRgb_[2, 1] * X) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_XyzToRgb_[2, 2] * Y) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_XyzToRgb_[2, 3] * Z);
  B := (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_XyzToRgb_[3, 1] * X) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_XyzToRgb_[3, 2] * Y) +
    (Matrice_Ekta_Space_PS5_RGB_XYZ_D50_XyzToRgb_[3, 3] * Z);
end;

//----- NTSC RGB C -----
procedure Matrice_NTSC_RGB_XYZ_C_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_NTSC_RGB_XYZ_C_RgbToXyz_[1, 1] * R) +
    (Matrice_NTSC_RGB_XYZ_C_RgbToXyz_[1, 2] * G) +
    (Matrice_NTSC_RGB_XYZ_C_RgbToXyz_[1, 3] * B);
  Y := (Matrice_NTSC_RGB_XYZ_C_RgbToXyz_[2, 1] * R) +
    (Matrice_NTSC_RGB_XYZ_C_RgbToXyz_[2, 2] * G) +
    (Matrice_NTSC_RGB_XYZ_C_RgbToXyz_[2, 3] * B);
  Z := (Matrice_NTSC_RGB_XYZ_C_RgbToXyz_[3, 1] * R) +
    (Matrice_NTSC_RGB_XYZ_C_RgbToXyz_[3, 2] * G) +
    (Matrice_NTSC_RGB_XYZ_C_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_NTSC_RGB_XYZ_C_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_NTSC_RGB_XYZ_C_XyzToRgb_[1, 1] * X) +
    (Matrice_NTSC_RGB_XYZ_C_XyzToRgb_[1, 2] * Y) +
    (Matrice_NTSC_RGB_XYZ_C_XyzToRgb_[1, 3] * Z);
  G := (Matrice_NTSC_RGB_XYZ_C_XyzToRgb_[2, 1] * X) +
    (Matrice_NTSC_RGB_XYZ_C_XyzToRgb_[2, 2] * Y) +
    (Matrice_NTSC_RGB_XYZ_C_XyzToRgb_[2, 3] * Z);
  B := (Matrice_NTSC_RGB_XYZ_C_XyzToRgb_[3, 1] * X) +
    (Matrice_NTSC_RGB_XYZ_C_XyzToRgb_[3, 2] * Y) +
    (Matrice_NTSC_RGB_XYZ_C_XyzToRgb_[3, 3] * Z);
end;

//----- Matrices PAL-SECAM D65 -----
procedure Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz_[1, 1] * R) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz_[1, 2] * G) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz_[1, 3] * B);
  Y := (Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz_[2, 1] * R) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz_[2, 2] * G) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz_[2, 3] * B);
  Z := (Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz_[3, 1] * R) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz_[3, 2] * G) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRgb_[1, 1] * X) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRgb_[1, 2] * Y) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRgb_[1, 3] * Z);
  G := (Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRgb_[2, 1] * X) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRgb_[2, 2] * Y) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRgb_[2, 3] * Z);
  B := (Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRgb_[3, 1] * X) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRgb_[3, 2] * Y) +
    (Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRgb_[3, 3] * Z);
end;

//----- ProPhoto RGB D50 -----
procedure Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz_[1, 1] * R) +
    (Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz_[1, 2] * G) +
    (Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz_[1, 3] * B);
  Y := (Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz_[2, 1] * R) +
    (Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz_[2, 2] * G) +
    (Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz_[2, 3] * B);
  Z := (Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz_[3, 1] * R) +
    (Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz_[3, 2] * G) +
    (Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_ProPhoto_RGB_XYZ_D50_D50_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_ProPhoto_RGB_XYZ_D50_XyzToRgb_[1, 1] * X) +
    (Matrice_ProPhoto_RGB_XYZ_D50_XyzToRgb_[1, 2] * Y) +
    (Matrice_ProPhoto_RGB_XYZ_D50_XyzToRgb_[1, 3] * Z);
  G := (Matrice_ProPhoto_RGB_XYZ_D50_XyzToRgb_[2, 1] * X) +
    (Matrice_ProPhoto_RGB_XYZ_D50_XyzToRgb_[2, 2] * Y) +
    (Matrice_ProPhoto_RGB_XYZ_D50_XyzToRgb_[2, 3] * Z);
  B := (Matrice_ProPhoto_RGB_XYZ_D50_XyzToRgb_[3, 1] * X) +
    (Matrice_ProPhoto_RGB_XYZ_D50_XyzToRgb_[3, 2] * Y) +
    (Matrice_ProPhoto_RGB_XYZ_D50_XyzToRgb_[3, 3] * Z);
end;

//----- SMPTE-C RGB D65 -----
procedure Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz_[1, 1] * R) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz_[1, 2] * G) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz_[1, 3] * B);
  Y := (Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz_[2, 1] * R) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz_[2, 2] * G) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz_[2, 3] * B);
  Z := (Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz_[3, 1] * R) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz_[3, 2] * G) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRgb_[1, 1] * X) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRgb_[1, 2] * Y) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRgb_[1, 3] * Z);
  G := (Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRgb_[2, 1] * X) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRgb_[2, 2] * Y) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRgb_[2, 3] * Z);
  B := (Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRgb_[3, 1] * X) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRgb_[3, 2] * Y) +
    (Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRgb_[3, 3] * Z);
end;

//----- Matrices sRGB D65 -----
procedure Matrice_sRGB_RGB_XYZ_D65_RgbToXyz(R, G, B: real; Out X, Y, Z: real);
begin
  X := (Matrice_sRGB_RGB_XYZ_D65_RgbToXyz_[1, 1] * R) +
    (Matrice_sRGB_RGB_XYZ_D65_RgbToXyz_[1, 2] * G) +
    (Matrice_sRGB_RGB_XYZ_D65_RgbToXyz_[1, 3] * B);
  Y := (Matrice_sRGB_RGB_XYZ_D65_RgbToXyz_[2, 1] * R) +
    (Matrice_sRGB_RGB_XYZ_D65_RgbToXyz_[2, 2] * G) +
    (Matrice_sRGB_RGB_XYZ_D65_RgbToXyz_[2, 3] * B);
  Z := (Matrice_sRGB_RGB_XYZ_D65_RgbToXyz_[3, 1] * R) +
    (Matrice_sRGB_RGB_XYZ_D65_RgbToXyz_[3, 2] * G) +
    (Matrice_sRGB_RGB_XYZ_D65_RgbToXyz_[3, 3] * B);
end;

procedure Matrice_sRGB_RGB_XYZ_D65_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
begin
  R := (Matrice_sRGB_RGB_XYZ_D65_XyzToRgb_[1, 1] * X) +
    (Matrice_sRGB_RGB_XYZ_D65_XyzToRgb_[1, 2] * Y) +
    (Matrice_sRGB_RGB_XYZ_D65_XyzToRgb_[1, 3] * Z);
  G := (Matrice_sRGB_RGB_XYZ_D65_XyzToRgb_[2, 1] * X) +
    (Matrice_sRGB_RGB_XYZ_D65_XyzToRgb_[2, 2] * Y) +
    (Matrice_sRGB_RGB_XYZ_D65_XyzToRgb_[2, 3] * Z);
  B := (Matrice_sRGB_RGB_XYZ_D65_XyzToRgb_[3, 1] * X) +
    (Matrice_sRGB_RGB_XYZ_D65_XyzToRgb_[3, 2] * Y) +
    (Matrice_sRGB_RGB_XYZ_D65_XyzToRgb_[3, 3] * Z);
end;

//----- CIE sVGA - RGB/XYZ -----
procedure Matrice_CIE_sVGA_RgbToXyz(R, G, B: byte; Out X, Y, Z: real);
const
  M_: Matrice_r33_ = (
    (0.4124, 0.3576, 0.1805),
    (0.2126, 0.7152, 0.0722),
    (0.0193, 0.1192, 0.9505)
    );
begin
  // 3,2406, -1,5372, -0,4986 = 1,2048
  //-0,9689,  1,8758,  0,0415 = 0,9484
  // 0,0557, -0,2040,  1,0570 = 0,9087
  X := (M_[1, 1] * R) + (M_[1, 2] * G) + (M_[1, 3] * B);
  Y := (M_[2, 1] * R) + (M_[2, 2] * G) + (M_[2, 3] * B);
  Z := (M_[3, 1] * R) + (M_[3, 2] * G) + (M_[3, 3] * B);
end;

procedure Matrice_CIE_sVGA_XyzToRgb(X, Y, Z: byte; Out R, G, B: real);
const
  M_: Matrice_r33_ = (
    (3.2406, -1.5372, -0.4986),
    (-0.9689, 1.8758, 0.0415),
    (0.0557, -0.2040, 1.0570)
    );
begin
  // 3,2406, -1,5372, -0,4986 = 1,2048
  //-0,9689,  1,8758,  0,0415 = 0,9484
  // 0,0557, -0,2040,  1,0570 = 0,9087
  R := (M_[1, 1] * X) + (M_[1, 2] * Y) + (M_[1, 3] * Z);
  G := (M_[2, 1] * X) + (M_[2, 2] * Y) + (M_[2, 3] * Z);
  B := (M_[3, 1] * X) + (M_[3, 2] * Y) + (M_[3, 3] * Z);
end;

//----- Luminance -----
function sRGB_Luminance(R, G, B: byte): real;
begin
  //Luminance relative sRGB
  Result := (0.2126 * R) + (0.7152 * G) + (0.0722 * B);
end;

function sRGB_Luminance_R(Lu, G, B: byte): real;
begin
  //R d'après la autres valeurs
  Result := (Lu - (0.7152 * G) - (0.0722 * B)) / 0.2126;
end;

function sRGB_Luminance_G(Lu, R, B: byte): real;
begin
  //G d'après la autres valeurs
  Result := (Lu - (0.2126 * R) + (0.0722 * B)) / 0.7152;
end;

function sRGB_Luminance_B(Lu, R, G: byte): real;
begin
  //B d'après la autres valeurs
  Result := (Lu - (0.2126 * R) + (0.7152 * G)) / 0.0722;
end;

//XYZ
function sRGB_XYZ_R(X, Y, Z: real): real;
begin
  //3,2406 - 1,5372 - 0,4986 = 1,2048
  Result := (3.2406 * X) + (-1.5372 * Y) + (-0.4986 * Z);
end;
//XYZ
function sRGB_XYZ_G(X, Y, Z: real): real;
begin
  //-0,9689 + 1,8758 + 0,0415 = 1,9173
  Result := (-0.9689 * X) + (1.8758 * Y) + (0.0415 * Z);
end;
//XYZ
function sRGB_XYZ_B(X, Y, Z: real): real;
begin
  //0,0557 + -0,2040 + 1,0570 = 0,9087
  Result := (0.0557 * X) + (-0.2040 * Y) + (1.0570 * Z);
end;

//----- Matrices sRGB - RGB/XYZ - D65 -----
//sRGB D65
procedure Matrice_sRGB_RGB_XYZ_D65_RgbToXyz(R, G, B: byte; Out X, Y, Z: real);
const
  M_: Matrice_r33_ = (
    (0.4124564, 0.3575761, 0.1804375),
    (0.2126729, 0.7151522, 0.0721750),
    (0.0193339, 0.1191920, 0.9503041)
    );
begin
  X := (M_[1, 1] * R) + (M_[1, 2] * G) + (M_[1, 3] * B);
  Y := (M_[2, 1] * R) + (M_[2, 2] * G) + (M_[2, 3] * B);
  Z := (M_[3, 1] * R) + (M_[3, 2] * G) + (M_[3, 3] * B);
end;

procedure Matrice_sRGB_RGB_XYZ_D65_XyzToXyz(R, G, B: byte; Out X, Y, Z: real);
const
  M_: Matrice_r33_ = (
    (3.2404542, -1.5371385, -0.4985314),
    (-0.9692660, 1.8760108, 0.0415560),
    (0.0556434, -0.2040259, 1.0572252)
    );
begin
  X := (M_[1, 1] * R) + (M_[1, 2] * G) + (M_[1, 3] * B);
  Y := (M_[2, 1] * R) + (M_[2, 2] * G) + (M_[2, 3] * B);
  Z := (M_[3, 1] * R) + (M_[3, 2] * G) + (M_[3, 3] * B);
end;

//----- Matrice sRGB - RGB/XYZ - D50 -----
procedure Matrice_sRGB_RGB_XYZ_D50_RgbToXyz(R, G, B: byte; Out X, Y, Z: real);
const
  M_: Matrice_r33_ = (
    (0.4360747, 0.3850649, 0.1430804),
    (0.2225045, 0.7168786, 0.0606169),
    (0.0139322, 0.0971045, 0.7141733)
    );
begin
  X := (M_[1, 1] * R) + (M_[1, 2] * G) + (M_[1, 3] * B);
  Y := (M_[2, 1] * R) + (M_[2, 2] * G) + (M_[2, 3] * B);
  Z := (M_[3, 1] * R) + (M_[3, 2] * G) + (M_[3, 3] * B);
end;

procedure Matrice_sRGB_RGB_XYZ_D50_XyzToXyz(R, G, B: byte; Out X, Y, Z: real);
const
  M_: Matrice_r33_ = (
    (3.1338561, -1.6168667, -0.4906146),
    (-0.9787684, 1.9161415, 0.0334540),
    (0.0719453, -0.2289914, 1.4052427)
    );
begin
  X := (M_[1, 1] * R) + (M_[1, 2] * G) + (M_[1, 3] * B);
  Y := (M_[2, 1] * R) + (M_[2, 2] * G) + (M_[2, 3] * B);
  Z := (M_[3, 1] * R) + (M_[3, 2] * G) + (M_[3, 3] * B);
end;

//----- Matrice CIE 1931 - RGB/XYZ -----
procedure Matrice_CIE_XYZ_1931_RgbToXyz(R, G, B: byte; Out X, Y, Z: real);
const
  M_: Matrice_r33_ = (
    (0.49000, 0.31000, 0.20000),
    (0.17696, 0.81240, 0.01063),
    (0.00000, 0.01000, 0.99000)
    );
begin
  X := (M_[1, 1] * R) + (M_[1, 2] * G) + (M_[1, 3] * B);
  Y := (M_[2, 1] * R) + (M_[2, 2] * G) + (M_[2, 3] * B);
  Z := (M_[3, 1] * R) + (M_[3, 2] * G) + (M_[3, 3] * B);
end;

procedure Matrice_CIE_XYZ_1931_XyzToRgb(X, Y, Z: real; Out R, G, B: real);
const
  M_: Matrice_r33_ = (
    (0.418456, -0.158657, -0.082833),
    (-0.091167, 0.252426, 0.015707),
    (0.000921, -0.002550, 0.178595)
    );
begin
  R := (M_[1, 1] * X) + (M_[1, 2] * Y) + (M_[1, 3] * Z);
  G := (M_[2, 1] * X) + (M_[2, 2] * Y) + (M_[2, 3] * Z);
  B := (M_[3, 1] * X) + (M_[3, 2] * Y) + (M_[3, 3] * Z);
end;

function XYZ_1931_X(R, G, B: byte): real;
begin
  //0.49+0.31+0.2=1
  Result := (0.49 * R) + (0.31 * G) + (0.2 * B);
end;

function XYZ_1931_Y(R, G, B: byte): real;
begin
  //0,17696+0,8124+0,01063=1
  Result := (0.17696 * R) + (0.8124 * G) + (0.01063 * B);
end;

function XYZ_1931_Z(R, G, B: byte): real;
begin
  //0+0.01+0.99=1
  Result := (0 * R) + (0.01 * G) + (0.99 * B);
end;

function XYZ_1931_R(G, B: byte): real;
begin
  Result := (1 - (0.31 * G) - (0.2 * B)) / 0.49;
end;

function XYZ_1931_G(R, B: byte): real;
begin
  Result := (1 - (0.17696 * R) - (0.01063 * B)) / 0.8124;
end;

function XYZ_1931_B(R, G: byte): byte;
begin
  Result := Round(((1 - (0.17696 * R) - (0.8124 * G)) / 0.01063) * 255);
end;

//----- Matrices XYZ Coordonnées xyz -----
function XYZ_xyz_Plan_x(Xc, Yc, Zc: real): real;
begin
  if Xc + Yc + Zc = 0 then
    Result := 0
  else
    Result := Xc / (Xc + Yc + Zc);
end;

function XYZ_xyz_Plan_y(Xc, Yc, Zc: real): real;
begin
  if Xc + Yc + Zc = 0 then
    Result := 0
  else
    Result := Yc / (Xc + Yc + Zc);
end;

function XYZ_xyz_Plan_z(Xc, Yc, Zc: real): real;
begin
  if Xc + Yc + Zc = 0 then
    Result := 0
  else
    Result := Zc / (Xc + Yc + Zc);
end;

function XYZ_xyz_Coord_X(x, y, Yc: real): real;
begin
  if y > 0 then
    Result := x * (Yc / y)
  else
    Result := 0;
end;

function XYZ_xyz_Coord_Z(x, y, Yc: real): real;
begin
  if y > 0 then
    Result := (1 - x - y) * (Yc / y)
  else
    Result := 0;
end;

//----- XYZ/LAB -----
function CIE_LAB_Distance_Euclidienne(L1, L2, a1, a2, b1, b2: real): real;
begin
  Result := Sqrt(Abs(Sqr(L2 - L1)) + Abs(Sqr(a2 - a1)) + Abs(Sqr(b2 - b1)));
end;

function CIE_LAB_Distance_Polaire(L1, L2, C1, C2, H1, H2: real): real;
var
  dH: real;
begin
  dH := Abs(H2 - H1);
  dH := 2 * Sqrt(C1 * C2) * Sin(dH / 2);
  Result := Sqrt(Abs(Sqr(L2 - L1)) + Abs(Sqr(C2 - C1)) + Abs(Sqr(dH)));
end;

//----- Matrices ADOBE RGB/XYZ 1988
procedure Matrice_Adobe_RGB_1988_RgbToXyz(R, G, B: byte; Out X, Y, Z: real);
const
  M_: Matrice_r33_ = (
    (0.5767, 0.1856, 0.1882),
    (0.2974, 0.6273, 0.0753),
    (0.0270, 0.0707, 0.9911)
    );
begin
  X := (M_[1, 1] * R) + (M_[1, 2] * G) + (M_[1, 3] * B);
  Y := (M_[2, 1] * R) + (M_[2, 2] * G) + (M_[2, 3] * B);
  Z := (M_[3, 1] * R) + (M_[3, 2] * G) + (M_[3, 3] * B);
end;

procedure Matrice_Adobe_RGB_1988_XyzToRgb(X, Y, Z: byte; Out R, G, B: real);
const
  M_: Matrice_r33_ = (
    (2.0414, -0.5649, -0.3447),
    (-0.9693, 1.8760, 0.0416),
    (0.0134, -0.1184, 1.0154)
    );
begin
  R := (M_[1, 1] * X) + (M_[1, 2] * Y) + (M_[1, 3] * Z);
  G := (M_[2, 1] * X) + (M_[2, 2] * Y) + (M_[2, 3] * Z);
  B := (M_[3, 1] * X) + (M_[3, 2] * Y) + (M_[3, 3] * Z);
end;

//----- RGB CIE 709 pour TVHD -----
//Utilisé pour définir la norme sRGB et HDTV
function RGB_CIE_709_R(X, Y, Z: real): real;
begin
  Result := (3.240479 * X) + (-1.53715 * Y) + (-0.498535 * Z);
end;

function RGB_CIE_709_G(X, Y, Z: real): real;
begin
  Result := (-0.969256 * X) + (1.875992 * Y) + (0.041556 * Z);
end;

function RGB_CIE_709_B(X, Y, Z: real): real;
begin
  Result := (0.055648 * X) + (-0.204043 * Y) + (1.057311 * Z);
end;

function RGB_CIE_709_X(R, G, B: byte): real;
begin
  Result := (0.412453 * R) + (0.35758 * G) + (0.180423 * B);
end;

function RGB_CIE_709_Y(R, G, B: byte): real;
begin
  Result := (0.212671 * R) + (0.71516 * G) + (0.072169 * B);
end;

function RGB_CIE_709_Z(R, G, B: byte): real;
begin
  Result := (0.019334 * R) + (0.119193 * G) + (0.950227 * B);
end;

//----- Yuv : Intensité -----
function Yuv_Y(R, G, B: byte): real;
begin
  //Luminance PAL et SECAM : Vidéo analogique (CCIR 601)
  Result := (0.299 * R) + (0.587 * G) + (0.114 * B);
end;
//----- Yuv : RGBToGray -----
function RGBToGray(R, G, B: real): real;
begin
  Result := (0.299 * R) + (0.587 * G) + (0.114 * B);
end;

function Yuv_U(Y, B: real): real;
begin
  //U=– 0.147R ́– 0.289G ́+ 0.436B ́= 0.492 (B ́– Y) ???
  Result := (B - Y) * 0.565;
end;

function Yuv_V(Y, R: real): real;
begin
  //V = 0.615R – 0.515G ́– 0.100B ́= 0.877(R ́– Y
  Result := (R - Y) * 0.713;
end;

//Passage de YUV en RGB
function Yuv_R(Y, V: real): real;
begin
  //R = Y + 1.140V ???
  Result := Y + (1.403 * V);
end;

function Yuv_G(Y, U, V: real): real;
begin
  //G = Y – 0.395U – 0.581V ???
  Result := Y - (0.344 * U) - (0.714 * V);
end;

function Yuv_B(Y, U: real): real;
begin
  //B = Y + 2.032U
  Result := Y + (1.770 * U);
end;
//Pour Y constant, distance chromatique
function Dist_ab(Ua, Ub, Va, Vb: real): real;
begin
  //D Ca-b = sqrt( (Ub-Ua)² + (Vb-Va)² ).
  Result := Sqrt(Sqr(Ub - Ua) + Sqr(Vb - Va));
end;

//----- Matrice ??? -----
procedure Matrice_XYZ_RgbToXyz(R, G, B: byte; Out X, Y, Z: real);
const
  M_: Matrice_r33_ = (
    (0.73467, 0.26533, 0.00000),
    (0.27376, 0.71741, 0.00883),
    (0.16658, 0.00886, 0.82456)
    );
begin
  //0.73467+0.26533+0=1
  //0.27376+0.71741+0.00883=1
  //0.16658+0.00886+0.82456=1
  X := (M_[1, 1] * R) + (M_[1, 2] * G) + (M_[1, 3] * B);
  Y := (M_[2, 1] * R) + (M_[2, 2] * G) + (M_[2, 3] * B);
  Z := (M_[3, 1] * R) + (M_[3, 2] * G) + (M_[3, 3] * B);
end;

//-----Matrices LMS -----
procedure Matrice_LMS_LmsToRgb(L, M, S: real; Out R, G, B: real);
const
  M_: Matrice_r33_ = (
    (0.55005, -0.57637, 0.048812),
    (-0.00020163, 0.0037003, -0.0010514),
    (0.00000070743, -0.000012983, 0.019884)
    );
begin
  // 0,55005       + -0,57637     +  0,048812  = 0,022492
  //-0,00020163    +  0,0037003   + -0,0010514 = 0,00244727
  // 0,00000070743 + -0,000012983 +  0,019884  = 0,01987172443
  R := (M_[1, 1] * L) + (M_[1, 2] * M) + (M_[1, 3] * S);
  G := (M_[2, 1] * L) + (M_[2, 2] * M) + (M_[2, 3] * S);
  B := (M_[3, 1] * L) + (M_[3, 2] * M) + (M_[3, 3] * S);
end;

procedure Matrice_LMS_RgbToLms(R, G, B: byte; Out L, M, S: real);
const
  M_: Matrice_r33_ = (
    (1.92811, 300.36447, 11.14934),
    (0.10506, 286.66280, 14.90023),
    (0.00000, 0.17649, 50.30185)
    );
begin
  //1,92811 + 300,36447 + 11,14934 = 313,44192
  //0,10506 + 286,66280 + 14,90023 = 301,66809
  //0,00000 +   0,17649 + 50,30185 =  50,47834
  L := (M_[1, 1] * R) + (M_[1, 2] * R) + (M_[1, 3] * R);
  M := (M_[2, 1] * G) + (M_[2, 2] * G) + (M_[2, 3] * G);
  S := (M_[3, 1] * B) + (M_[3, 2] * B) + (M_[3, 3] * B);
end;

//----- Filtre 5x5 -----
//Sobel 1  (Contours)
procedure M5x5_Sobel_1(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11,
  p12, p13, p14, p15: integer; Out r: real);
const
  M_: Matrice_I_5x5_ = (
    (0, 0, 0, 0, 0),
    (0, 1, 0, -1, 0),
    (0, 2, 0, -2, 0),
    (0, 1, 0, -1, 0),
    (0, 0, 0, 0, 0)
    );
begin
  //Matrice_5x5 Sobel 1
  r := (p1 * m_[1, 1]) + (p2 * m_[1, 2]) + (p3 * m_[1, 3]) + (p4 * m_[1, 4]) +
    (p5 * m_[1, 5]) + (p6 * m_[2, 1]) + (p7 * m_[2, 2]) + (p8 * m_[2, 3]) +
    (p9 * m_[2, 4]) + (p10 * m_[2, 5]) + (p11 * m_[3, 1]) + (p12 * m_[3, 2]) +
    (p13 * m_[3, 3]) + (p14 * m_[3, 4]) + (p15 * m_[3, 5]) +
    (p11 * m_[4, 1]) + (p12 * m_[4, 2]) + (p13 * m_[4, 3]) +
    (p14 * m_[4, 4]) + (p15 * m_[4, 5]) + (p11 * m_[5, 1]) +
    (p12 * m_[5, 2]) + (p13 * m_[5, 3]) + (p14 * m_[5, 4]) + (p15 * m_[5, 5]);
end;

procedure QuickSort_Cl_16x16(var a: TabTC256_; Lo, Hi: integer);

  procedure Sort(l, r: integer);
  var
    i, j, x, y: integer;
  begin
    i := l;
    j := r;
    x := a[(l + r) div 2];
    repeat
      while a[i] < x do
        i := i + 1;
      while x < a[j] do
        j := j - 1;
      if i <= j then
      begin
        y := a[i];
        a[i] := a[j];
        a[j] := y;
        i := i + 1;
        j := j - 1;
      end;
    until i > j;
    if l < j then
      sort(l, j);
    if i < r then
      sort(i, r);
  end;

begin
  Sort(Lo, Hi);
end;

//----- RGB to HSL ----------------------------------------------------

procedure RGBtoHSL_RGB255_H360_S100_L100(R, G, B: integer; var H, S, L: integer);
var
  Delta: double;
  CMax, CMin: double;
  Red, Green, Blue: double;
  Hue, Sat, Lum: double;
begin
  //Sortie H:max 360, S:max=100, L:max=100
  Red := R / 255;
  Green := G / 255;
  Blue := B / 255;
  CMax := Max(Red, Max(Green, Blue));
  CMin := Min(Red, Min(Green, Blue));
  Lum := (CMax + CMin) / 2;
  if CMax = CMin then
  begin
    Sat := 0;
    Hue := 0;
  end
  else
  begin
    if Lum < 0.5 then
      Sat := (CMax - CMin) / (CMax + CMin)
    else
      Sat := (cmax - cmin) / (2 - cmax - cmin);
    Delta := CMax - CMin;
    if Red = CMax then
    begin
      Hue := (Green - Blue) / Delta;
    end
    else
    begin
      if Green = CMax then
      begin
        Hue := 2 + (Blue - Red) / Delta;
      end
      else
      begin
        Hue := 4.0 + (Red - Green) / Delta;
      end;
    end;
    Hue := Hue / 6;
    if Hue < 0 then
      Hue := Hue + 1;
  end;
  H := Round(Hue * 360);
  S := Round(Sat * 100);
  L := Round(Lum * 100);
end;

//----- HSL to RGB ----------------------------------------

procedure TWdMain.HSLtoRGB_H360_S1_L1_RGB255(H, S, L: real; Out R, G, B: byte);
var
  d, m, x: real;
  M1, M2: real;
  Rb, Gb, Bb: real;
begin
  //HSL to RGB
  //Entrée : H:0 à 360, S:0 à 1,   L:0 à 1
  //Sortie : R:0 à 255, G:0 à 255, B:0 à 255
  d := S * (1 - abs(2 * L - 1));
  m := 255 * (L - (0.5 * d));
  //-
  M1 := H / 60;
  M2 := Int(M1 / 2);
  M2 := M2 * 2;
  M1 := M1 - M2;
  x := d * (1 - abs(M1 - 1));
  if (H >= 0) and (H < 60) then
  begin
    Rb := (255 * d) + m;
    Gb := (255 * x) + m;
    Bb := m;
  end
  else
  begin
    if (H >= 60) and (H < 120) then
    begin
      Rb := (255 * x) + m;
      Gb := (255 * d) + m;
      Bb := m;
    end
    else
    begin
      if (H >= 120) and (H < 180) then
      begin
        Rb := m;
        Gb := (255 * d) + m;
        Bb := (255 * x) + m;
      end
      else
      begin
        if (H >= 180) and (H < 240) then
        begin
          Rb := m;
          Gb := (255 * x) + m;
          Bb := (255 * d) + m;
        end
        else
        begin
          if (H >= 240) and (H < 300) then
          begin
            Rb := (255 * x) + m;
            Gb := m;
            Bb := (255 * d) + m;
          end
          else
          begin
            if (H >= 300) and (H <= 359) then
            begin
              Rb := (255 * d) + m;
              Gb := m;
              Bb := (255 * x) + m;
            end;
          end;
        end;
      end;
    end;
  end;
  //Arrondi au plus grand
  R := Floor(Rb);
  G := Floor(Gb);
  B := Floor(Bb);
end;

procedure HSLtoRGB_H360_S100_L100_RGB255(H, S, L: integer; var R, G, B: byte);
var
  Sat, Lum: double;
begin
  //Entrée : H:0 à 360, S:0 à 100, L:0 à 100
  //Sortie : R:0 à 255, G:0 à 255, B:0 à 255
  R := 0;
  G := 0;
  B := 0;
  if ((H >= 0) and (H <= 359)) and ((S >= 0) and (S <= 100)) and
    ((L >= 0) and (L <= 100)) then
  begin
    if H <= 60 then
    begin
      R := 255;
      G := Round((255 / 60) * H);
      B := 0;
    end
    else if H <= 120 then
    begin
      R := Round(255 - (255 / 60) * (H - 60));
      G := 255;
      B := 0;
    end
    else if H <= 180 then
    begin
      R := 0;
      G := 255;
      B := Round((255 / 60) * (H - 120));
    end
    else if H <= 240 then
    begin
      R := 0;
      G := Round(255 - (255 / 60) * (H - 180));
      B := 255;
    end
    else if H <= 300 then
    begin
      R := Round((255 / 60) * (H - 240));
      G := 0;
      B := 255;
    end
    else if H <= 359 then
    begin
      R := 255;
      G := 0;
      B := Round(255 - (255 / 60) * (H - 300));
    end;
    Sat := Abs((S - 100) / 100);
    R := Round(R - ((R - 128) * Sat));
    G := Round(G - ((G - 128) * Sat));
    B := Round(B - ((B - 128) * Sat));
    Lum := (L - 50) / 50;
    if Lum > 0 then
    begin
      R := Round(R + ((255 - R) * Lum));
      G := Round(G + ((255 - G) * Lum));
      B := Round(B + ((255 - B) * Lum));
    end
    else if Lum < 0 then
    begin
      R := Round(R + (R * Lum));
      G := Round(G + (G * Lum));
      B := Round(B + (B * Lum));
    end;
  end;
end;

//--- Img1 Bmp -----
procedure ImgBmp_Creation(MaxImgX, MaxImgY: integer);
begin
  //Création du pointeur
  Re := Rect(0, 0, MaxImgX - 1, MaxImgY - 1);
  ImgBmp := TBitmap.Create;
  ImgBmp.Width := MaxImgX;
  ImgBmp.Height := MaxImgY;
end;

procedure Img_vers_ImgBmp;
begin
  with WdMain do
    ImgBmp.Canvas.CopyRect(Re, Img1.Canvas, Re);
end;

procedure ImgBmp_vers_Img;
begin
  with WdMain do
    Img1.Canvas.CopyRect(Re, ImgBmp.Canvas, Re);
end;

procedure ImgBmp_Close;
begin
  ImgBmp.Free;
end;

procedure RGB_vers_Img(Select, MaxImgX, MaxImgY: integer);
var
  x, y: integer;
begin
  with WdMain do
  begin
    ImgBmp_Creation(MaxImgX, MaxImgY);
    with ImgBmp.Canvas do
    begin
      for y := 0 to MaxImgY - 1 do
      begin
        for x := 0 to MaxImgX - 1 do
        begin
          case Select of
            2:
            begin
              Pixels[x, y] := RgbHsl2[x, y].Cl;
            end;
            3:
            begin
              Pixels[x, y] := RgbHsl3[x, y].Cl;
            end;
          end;
        end;
        Application.ProcessMessages;
      end;
    end;
    ImgBmp_vers_Img;
    ImgBmp_Close;
  end;
end;

//----- Img1 Jpeg -----
procedure ImgJpg_Creation(MaxImgX, MaxImgY: integer);
begin
  //Création du pointeur
  Re := Rect(0, 0, MaxImgX - 1, MaxImgY - 1);
  ImgJpg := TJPEGImage.Create;
  ImgJpg.Width := MaxImgX;
  ImgJpg.Height := MaxImgY;
end;

procedure Img_vers_ImgJpg;
begin
  with WdMain do
  begin
    ImgJpg.Canvas.CopyRect(Re, Img1.Canvas, Re);
  end;
end;

procedure ImgJpg_Close;
begin
  ImgJpg.Free;
end;

//----- Selection des Matrices RGB to XYZ -----
procedure Matrice_Selection(Select: integer; R, G, B: real; Out X, Y, Z: real);
begin
  case Select of
    //00 - Adobe RGB 1998 D65
    0:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //01 - Best RGB D50
    1:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_Best_RGB_XYZ_D50_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //02 - Beta RGB D50
    2:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_Beta_RGB_XYZ_D50_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //03 - Bruce RGB D65
    3:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_Bruce_RGB_XYZ_D65_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //04 - CIE RGB E
    4:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_CIE_RGB_XYZ_E_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //05 - ColorMatch RGB D50
    5:
    begin
      //10 113 211 / 17.0920  20.0525  51.7420
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //06 - Don RGB 4 D50
    6:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_Don_4_RGB_XYZ_D50_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //07 - ECI RGB v2 D50
    7:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_ECI_RGB_XYZ_D50_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //08 - Ekta Space PS5 D50
    8:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_Ecta_Space_PS5_RGB_XYZ_D50_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //09 - NTSC RGB C
    9:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_NTSC_RGB_XYZ_C_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //10 - PAL-SECAM RGB D65
    10:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //11 - ProPhoto RGB D50
    11:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //12 - SMPTE-C RGB D65
    12:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz(R, G, B, X, Y, Z);
    end;
    //13 - sRGB D65
    13:
    begin
      //Gamma=sRGB - XYZ Scaling
      //----- vérifiée = Ok -----
      //10 113 211 : 17.7837 16.5755 63.8775
      Matrice_sRGB_RGB_XYZ_D65_RgbToXyz(R, G, B, X, Y, Z);
    end;
  end;
end;

procedure XYZToxyY(Xe, Ye, Ze: real; Out X, Y, Ys: real);
begin
  if Xe + Ye + Ze = 0 then
    X := Zero_
  else
    X := Xe / (Xe + Ye + Ze);
  if Xe + Ye + Ze = 0 then
    Y := Zero_
  else
    Y := Ye / (Xe + Ye + Ze);
  Ys := Ye;
end;

procedure xyZ(Xe, Ye: real; Out X, Y, Z: real);
begin
  Y := 1;
  if Ye = 0 then
    X := Zero_
  else
    X := Xe * Y / Ye;
  if Ye = 0 then
    Z := Zero_
  else
    Z := (1 - Xe - Ye) * Y / Ye;
end;

procedure XYZtoLab(X, Y, Z: real; Out L, a, b: real);
const
  Epsilon_ = 0.00885645168; //(6/29)^3 ou 216/24389
  k1_ = 903.3;
  //k2_     =216/24389;
var
  Xw, Yw, Zw, Xr, Yr, Zr, fXr, fYr, fZr: real;
begin
  //Observer= 2°, Illuminant= D65...
  //Point Blanc du modele
  case WdConvert.ComboBox2.ItemIndex of
    //00 - Adobe RGB 1998 D65
    0:
    begin
      Xw := Point_Blanc_1931_02d_A_[1];
      Yw := Point_Blanc_1931_02d_A_[2];
    end;
    //01 - Best RGB D50
    1:
    begin
      Xw := Point_Blanc_1931_02d_D65_[1];
      Yw := Point_Blanc_1931_02d_D65_[2];
    end;
    //02 - Beta RGB D50
    2:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //03 - Bruce RGB D65
    3:
    begin
      Xw := Point_Blanc_1931_02d_D65_[1];
      Yw := Point_Blanc_1931_02d_D65_[2];
    end;
    //04 - CIE RGB E
    4:
    begin
      Xw := Point_Blanc_1931_02d_E_[1];
      Yw := Point_Blanc_1931_02d_E_[2];
    end;
    //05 - ColorMatch RGB D50
    5:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //06 - Don RGB 4 D50
    6:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //07 - ECI RGB v2 D50
    7:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //08 - Ekta Space PS5 D50
    8:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //09 - NTSC RGB C
    9:
    begin
      Xw := Point_Blanc_1931_02d_C_[1];
      Yw := Point_Blanc_1931_02d_C_[2];
    end;
    //10 - PAL/SECAM RGB D65
    10:
    begin
      Xw := Point_Blanc_1931_02d_D65_[1];
      Yw := Point_Blanc_1931_02d_D65_[2];
    end;
    //11 - ProPhoto RGB D50
    11:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //12 - SMPTE-C RGB D65
    12:
    begin
      Xw := Point_Blanc_1931_02d_D65_[1];
      Yw := Point_Blanc_1931_02d_D65_[2];
    end;
    //13 - sRGB D65
    13:
    begin
      Xw := Point_Blanc_1931_02d_D65_[1];
      Yw := Point_Blanc_1931_02d_D65_[2];
    end;
    //14 - sRGB D50
    14:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
  end;
  //Transposition du Point Blanc
  xyZ(Xw, Yw, Xw, Yw, Zw);
  Xw := Xw * 100;
  Yw := Yw * 100;
  Zw := Zw * 100;
  //Scale
  if Xw = 0 then
    Xr := Zero_
  else
    Xr := X / Xw;
  if Yw = 0 then
    Yr := Zero_
  else
    Yr := Y / Yw;
  if Zw = 0 then
    Zr := Zero_
  else
    Zr := Z / Zw;
  if Xr > Epsilon_ then
  begin
    fXr := Power(Xr, 1 / 3);
  end
  else
  begin
    fXr := ((k1_ * Xr) + 16) / 116;
    //X:=(7.787*X)+(16/116);
  end;
  if Yr > Epsilon_ then
  begin
    fYr := Power(Yr, 1 / 3);
  end
  else
  begin
    fYr := ((k1_ * Yr) + 16) / 116;
    //Y:=(7.787*Y)+(16/116);
  end;
  if Zr > Epsilon_ then
  begin
    fZr := Power(Zr, 1 / 3);
  end
  else
  begin
    fZr := ((k1_ * Zr) + 16) / 116;
    //Z:=(7.787*Z)+(16/116);
  end;
  L := (116 * fYr) - 16;
  a := 500 * (fXr - fYr);
  b := 200 * (fYr - fZr);
end;

procedure RGBToXYZ(RGB: TColor; Out X, Y, Z: real);
var
  Rr, Gr, Br: real;
  Rb, Gb, Bb: byte;
begin
  RedGreenBlue(RGB, Rb, Gb, Bb);
  Rr := Rb;
  Gr := Gb;
  Br := Bb;
  //Scale 1
  if Rr > 0 then
    Rr := Rr / 255;
  if Gr > 0 then
    Gr := Gr / 255;
  if Br > 0 then
    Br := Br / 255;
  //----- Scale 2 - Transformation Gamma inverse -----
  //sRGB - Gamma=2.4
  Rr := WdMain.Correction_Gamma_Inverse_2_4_sRGBToRGB(Rr);
  Gr := WdMain.Correction_Gamma_Inverse_2_4_sRGBToRGB(Gr);
  Br := WdMain.Correction_Gamma_Inverse_2_4_sRGBToRGB(Br);
  //----- Scale 3 -----
  Rr := Rr * 100;
  Gr := Gr * 100;
  Br := Br * 100;
  //----- Matrice RGB -> XYZ
  Matrice_sRGB_RGB_XYZ_D65_RgbToXyz(Rr, Gr, Br, X, Y, Z);
end;

procedure RGBToXYZToLab(RGB: TColor; Out L, a, b: real);
var
  Rr, Gr, Br: real;
  X, Y, Z: real;
  Rb, Gb, Bb: byte;
begin
  RedGreenBlue(RGB, Rb, Gb, Bb);
  Rr := Rb;
  Gr := Gb;
  Br := Bb;
  //Scale 1
  if Rr > 0 then
    Rr := Rr / 255;
  if Gr > 0 then
    Gr := Gr / 255;
  if Br > 0 then
    Br := Br / 255;
  //----- Scale 2 - Transformation Gamma inverse -----
  //sRGB - Gamma=2.4
  Rr := WdMain.Correction_Gamma_Inverse_2_4_sRGBToRGB(Rr);
  Gr := WdMain.Correction_Gamma_Inverse_2_4_sRGBToRGB(Gr);
  Br := WdMain.Correction_Gamma_Inverse_2_4_sRGBToRGB(Br);
  //----- Scale 3 -----
  Rr := Rr * 100;
  Gr := Gr * 100;
  Br := Br * 100;
  //----- Matrice RGB -> XYZ
  Matrice_sRGB_RGB_XYZ_D65_RgbToXyz(Rr, Gr, Br, X, Y, Z);
  //Lab
  XYZtoLab(X, Y, Z, L, a, b);
end;

procedure XYZtoLuv(X, Y, Z: real; Out L, u, v: real);
const
  Epsilon_ = 0.00885645168; //(6/29)^3 ou 216/24389
  k1_ = 903.3;
var
  Xw, Yw, XwT, YwT, ZwT: real;
  Xr, Yr, Zr: real;
  Un, Vn, Up, Vp, Factor2: real;
  Total: real;
begin
  //Point Blanc du modele
  case WdConvert.ComboBox2.ItemIndex of
    //00 - Adobe RGB 1998 D65
    0:
    begin
      Xw := Point_Blanc_1931_02d_A_[1];
      Yw := Point_Blanc_1931_02d_A_[2];
    end;
    //01 - Best RGB D50
    1:
    begin
      Xw := Point_Blanc_1931_02d_D65_[1];
      Yw := Point_Blanc_1931_02d_D65_[2];
    end;
    //02 - Beta RGB D50
    2:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //03 - Bruce RGB D65
    3:
    begin
      Xw := Point_Blanc_1931_02d_D65_[1];
      Yw := Point_Blanc_1931_02d_D65_[2];
    end;
    //04 - CIE RGB E
    4:
    begin
      Xw := Point_Blanc_1931_02d_E_[1];
      Yw := Point_Blanc_1931_02d_E_[2];
    end;
    //05 - ColorMatch RGB D50
    5:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //06 - Don RGB 4 D50
    6:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //07 - ECI RGB v2 D50
    7:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //08 - Ekta Space PS5 D50
    8:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //09 - NTSC RGB C
    9:
    begin
      Xw := Point_Blanc_1931_02d_C_[1];
      Yw := Point_Blanc_1931_02d_C_[2];
    end;
    //10 - PAL/SECAM RGB D65
    10:
    begin
      Xw := Point_Blanc_1931_02d_D65_[1];
      Yw := Point_Blanc_1931_02d_D65_[2];
    end;
    //11 - ProPhoto RGB D50
    11:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
    //12 - SMPTE-C RGB D65
    12:
    begin
      Xw := Point_Blanc_1931_02d_D65_[1];
      Yw := Point_Blanc_1931_02d_D65_[2];
    end;
    //13 - sRGB D65
    13:
    begin
      Xw := Point_Blanc_1931_02d_D65_[1];
      Yw := Point_Blanc_1931_02d_D65_[2];
    end;
    //sRGB D50
    14:
    begin
      Xw := Point_Blanc_1931_02d_D50_[1];
      Yw := Point_Blanc_1931_02d_D50_[2];
    end;
  end;
  //D65X=0.312713 D65Y=0.329016
  //Transposition du Point Blanc en XYZ
  xyZ(Xw, Yw, XwT, YwT, ZwT);
  //XwT=0.95044 YwT=1 ZwT=1.08891
  //U', V'
  Factor2 := XwT + (15 * YwT) + (3 * ZwT);
  if Factor2 = 0 then
    Un := Zero_
  else
    Un := (4 * XwT) / Factor2;
  if Factor2 = 0 then
    Vn := Zero_
  else
    Vn := (9 * YwT) / Factor2;
  //Scale
  XwT := XwT * 100;
  YwT := YwT * 100;
  ZwT := ZwT * 100;
  //Scale
  if XwT = 0 then
    Xr := Zero_
  else
    Xr := X / XwT;
  if YwT = 0 then
    Yr := Zero_
  else
    Yr := Y / YwT;
  if ZwT = 0 then
    Zr := Zero_
  else
    Zr := Z / ZwT;
  //----- L -----
  if Yr > Epsilon_ then
  begin
    L := (116 * Power(Yr, 1 / 3)) - 16;
  end
  else
  begin
    L := k1_ * Yr;
  end;
  //----- U, V -----
  Total := (X + (15 * Y) + (3 * Z));
  if Total = 0 then
    Up := Zero_
  else
    Up := (4 * X) / Total;
  Total := (X + (15 * Y) + (3 * Z));
  if Total = 0 then
    Vp := Zero_
  else
    Vp := (9 * Y) / Total;
  //U et V
  u := 13 * L * (Up - Un);
  v := 13 * L * (Vp - Vn);
end;

procedure TWdMain.Convert_Aff_Couleurs;
var
  CoefX, CoefYL: real;
  H, S, L: real;
  MaxImgX, MaxImgY: integer;
  x, y: integer;
  Rb, Gb, Bb: byte;
begin
  with WdConvert do
  begin
    with ImgCl.Canvas do
    begin
      MaxImgX := ImgCl.Width;
      MaxImgY := ImgCl.Height;
      //Coef
      CoefX := 360 / MaxImgX;
      CoefYL := 100 / MaxImgY;
      S := 100;
      L := 100;
      Rb := 0;
      Gb := 0;
      Bb := 0;
      for y := 0 to MaxImgY - 1 do
      begin
        H := 0;
        for x := 0 to 360 do
        begin
          HSLtoRGB_H360_S100_L100_RGB255(Round(H), Round(S), Round(L), Rb, Gb, Bb);
          Pixels[x, y] := RGBToColor(Rb, Gb, Bb);
          H := H + CoefX;
        end;
        L := L - CoefYL;
      end;
      Application.ProcessMessages;
    end;
    //Barre de Niveau
    with ImgNv.Canvas do
    begin
      MaxImgX := ImgNv.Width;
      MaxImgY := ImgNv.Height;
      //Coef
      CoefX := 360 / MaxImgX;
      CoefYL := 100 / MaxImgY;
      H := 60;
      S := 100;
      L := 100;
      for y := 0 to MaxImgY - 1 do
      begin
        HSLtoRGB_H360_S100_L100_RGB255(Round(H), Round(S), Round(L), Rb, Gb, Bb);
        Pen.Color := RGBToColor(Rb, Gb, Bb);
        Line(0, y, MaxImgX - 1, y);
        L := L - CoefYL;
        Application.ProcessMessages;
      end;
      L := 50;
      Pen.Color := ClSilver;
      Line(0, Round((L * CoefYL) - 1), MaxImgX - 1, Round((L * CoefYL) - 1));
      Line(0, Round(L * CoefYL), MaxImgX - 1, Round(L * CoefYL));
      Line(0, Round((L * CoefYL) + 1), MaxImgX - 1, Round((L * CoefYL) + 1));
    end;
  end;
end;

procedure TWdMain.Convert_Aff_Barre_de_Niveau(Re, Ge, Be: byte);
var
  CoefYL, L: real;
  MaxImgX, MaxImgY: integer;
  H, S, Se, Le, y: integer;
  Rb, Gb, Bb: byte;
begin
  with WdConvert do
  begin
    with ImgNv.Canvas do
    begin
      MaxImgX := ImgNv.Width;
      MaxImgY := ImgNv.Height;
      //Coef
      CoefYL := 100 / MaxImgY;
      //-
      H := 0;
      Se := 0;
      Le := 0;
      RGBtoHSL_RGB255_H360_S100_L100(Re, Ge, Be, H, Se, Le);
      //-
      S := 100;
      L := 100;
      //-
      Rb := 0;
      Gb := 0;
      Bb := 0;
      for y := 0 to MaxImgY - 1 do
      begin
        HSLtoRGB_H360_S100_L100_RGB255(H, S, Round(L), Rb, Gb, Bb);
        Pen.Color := RGBToColor(Rb, Gb, Bb);
        Line(0, y, MaxImgX - 1, y);
        L := L - CoefYL;
      end;
    end;
  end;
end;

procedure TWdMain.Convert_RGB_Calculs;
var
  X, Y, Z: real;

  procedure Aff_XYZ;
  begin
    with WdConvert do
    begin
      EdX.Text := RealToStr(X, Exp6_);
      EdY.Text := RealToStr(Y, Exp6_);
      EdZ.Text := RealToStr(Z, Exp6_);
    end;
  end;

  procedure Aff_Matrice_XYZ;
  var
    Ma: array[1..2] of Matrice_;
    n, p: integer;
  begin
    with WdConvert do
    begin
      case ComboBox2.ItemIndex of
        //00 - Adobe RGB 1998 D65
        0:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_Adobe_RGB_XYZ_1998_D65_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_Adobe_RGB_XYZ_1998_D65_XyzToRGB_[n, p];
            end;
        end;
        //01 - Best RGB D50
        1:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_Best_RGB_XYZ_D50_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_Best_RGB_XYZ_D50_XyzToRGB_[n, p];
            end;
        end;
        //02 - Beta RGB D50
        2:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_Beta_RGB_XYZ_D50_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_Beta_RGB_XYZ_D50_XyzToRGB_[n, p];
            end;
        end;
        //03 - Bruce RGB D65
        3:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_Bruce_RGB_XYZ_D65_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_Bruce_RGB_XYZ_D65_XyzToRGB_[n, p];
            end;
        end;
        //04 - CIE RGB E
        4:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_CIE_RGB_XYZ_E_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_CIE_RGB_XYZ_E_XyzToRGB_[n, p];
            end;
        end;
        //05 - ColorMatch RGB D50
        5:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_ColorMatch_RGB_XYZ_D50_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_ColorMatch_RGB_XYZ_D50_XyzToRGB_[n, p];
            end;
        end;
        //06 - Don RGB 4 D50
        6:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_Don_4_RGB_XYZ_D50_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_Don_4_RGB_XYZ_D50_XyzToRGB_[n, p];
            end;
        end;
        //07 - ECI RGB v2 D50
        7:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_ECI_RGB_XYZ_D50_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_ECI_RGB_XYZ_D50_XyzToRGB_[n, p];
            end;
        end;
        //08 - Ekta Space PS5 D50
        8:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_Ekta_Space_PS5_RGB_XYZ_D50_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_Ekta_Space_PS5_RGB_XYZ_D50_XyzToRGB_[n, p];
            end;
        end;
        //09 - NTSC RGB C
        9:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_NTSC_RGB_XYZ_C_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_NTSC_RGB_XYZ_C_XyzToRGB_[n, p];
            end;
        end;
        //10 - PAL/SECAM RGB D65
        10:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_PAL_SECAM_RGB_XYZ_D65_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_PAL_SECAM_RGB_XYZ_D65_XyzToRGB_[n, p];
            end;
        end;
        //11 - ProPhoto RGB D50
        11:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_ProPhoto_RGB_XYZ_D50_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_ProPhoto_RGB_XYZ_D50_XyzToRGB_[n, p];
            end;
        end;
        //12 - SMPTE-C RGB D65
        12:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_SMPTE_C_RGB_XYZ_D65_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_SMPTE_C_RGB_XYZ_D65_XyzToRGB_[n, p];
            end;
        end;
        //13 - sRGB D65
        13:
        begin
          for n := 1 to 3 do
            for p := 1 to 3 do
            begin
              Ma[1, n, p] := Matrice_sRGB_RGB_XYZ_D65_RgbToXyz_[n, p];
              Ma[2, n, p] := Matrice_sRGB_RGB_XYZ_D65_XyzToRGB_[n, p];
            end;
        end;
      end;
      //Matrice XYZ
      PnMa1.Caption := RealToStr(Ma[1, 1, 1], Exp7_);
      PnMa2.Caption := RealToStr(Ma[1, 1, 2], Exp7_);
      PnMa3.Caption := RealToStr(Ma[1, 1, 3], Exp7_);
      PnMa4.Caption := RealToStr(Ma[1, 2, 1], Exp7_);
      PnMa5.Caption := RealToStr(Ma[1, 2, 2], Exp7_);
      PnMa6.Caption := RealToStr(Ma[1, 2, 3], Exp7_);
      PnMa7.Caption := RealToStr(Ma[1, 3, 1], Exp7_);
      PnMa8.Caption := RealToStr(Ma[1, 3, 2], Exp7_);
      PnMa9.Caption := RealToStr(Ma[1, 3, 3], Exp7_);
      //Matrice XYZ Inverse
      PnMa11.Caption := RealToStr(Ma[2, 1, 1], Exp7_);
      PnMa12.Caption := RealToStr(Ma[2, 1, 2], Exp7_);
      PnMa13.Caption := RealToStr(Ma[2, 1, 3], Exp7_);
      PnMa14.Caption := RealToStr(Ma[2, 2, 1], Exp7_);
      PnMa15.Caption := RealToStr(Ma[2, 2, 2], Exp7_);
      PnMa16.Caption := RealToStr(Ma[2, 2, 3], Exp7_);
      PnMa17.Caption := RealToStr(Ma[2, 3, 1], Exp7_);
      PnMa18.Caption := RealToStr(Ma[2, 3, 2], Exp7_);
      PnMa19.Caption := RealToStr(Ma[2, 3, 3], Exp7_);
      //Matrice Inverse
      //Mi     :Matrice_;
    end;
  end;

var
  //RGB
  Rr, Gr, Br: real;
  //Lab,LCHab
  Llab, Alab, Blab: real;
  //Luv
  Lluv, Uluv, Vluv: real;
  //-
  Xy, Yy, Yy2: real;
  Select: integer;
begin
  with WdConvert do
  begin
    if If_Integer(EdRe.Text) then
    begin
      if If_Integer(EdGe.Text) then
      begin
        if If_Integer(EdBe.Text) then
        begin
          Rr := StrToInt(EdRe.Text);
          Gr := StrToInt(EdGe.Text);
          Br := StrToInt(EdBe.Text);
          if (Rr >= 0) and (Rr <= 255) and (Gr >= 0) and (Gr <= 255) and
            (Br >= 0) and (Br <= 255) then
          begin
            //----- Scale 1 -----
            if Rr > 0 then
              Rr := Rr / 255;
            if Gr > 0 then
              Gr := Gr / 255;
            if Br > 0 then
              Br := Br / 255;
            //----- Scale 2 - Transformation Gamma inverse -----
            //sRGB
            case ComboBox1.ItemIndex of
              //sRGB - Gamma=2.4
              0:
              begin
                Rr := Correction_Gamma_Inverse_2_4_sRGBToRGB(Rr);
                Gr := Correction_Gamma_Inverse_2_4_sRGBToRGB(Gr);
                Br := Correction_Gamma_Inverse_2_4_sRGBToRGB(Br);
              end;
              //Gamma=2.2
              1:
              begin
                Rr := Correction_Gamma_Inverse_G_sRGBToRGB(Rr, 2.2);
                Gr := Correction_Gamma_Inverse_G_sRGBToRGB(Gr, 2.2);
                Br := Correction_Gamma_Inverse_G_sRGBToRGB(Br, 2.2);
              end;
              //Gamma=2.0
              2:
              begin
                Rr := Correction_Gamma_Inverse_G_sRGBToRGB(Rr, 2);
                Gr := Correction_Gamma_Inverse_G_sRGBToRGB(Gr, 2);
                Br := Correction_Gamma_Inverse_G_sRGBToRGB(Br, 2);
              end;
              //Gamma=2.8
              3:
              begin
                Rr := Correction_Gamma_Inverse_G_sRGBToRGB(Rr, 1.8);
                Gr := Correction_Gamma_Inverse_G_sRGBToRGB(Gr, 1.8);
                Br := Correction_Gamma_Inverse_G_sRGBToRGB(Br, 1.8);
              end;
              //Gamma=1.0
              4:
              begin
                Rr := Correction_Gamma_Inverse_G_sRGBToRGB(Rr, 1);
                Gr := Correction_Gamma_Inverse_G_sRGBToRGB(Gr, 1);
                Br := Correction_Gamma_Inverse_G_sRGBToRGB(Br, 1);
              end;
            end;
            //----- Scale 3 -----
            Rr := Rr * 100;
            Gr := Gr * 100;
            Br := Br * 100;
            //----- Matrices RGB -> XYZ
            Select := ComboBox2.ItemIndex;
            Matrice_Selection(Select, Rr, Gr, Br, X, Y, Z);
            //XYZ -> xyY
            XYZToxyY(X, Y, Z, Xy, Yy, Yy2);
            EdxyX.Text := RealToStr(Xy, Exp6_);
            EdxyY.Text := RealToStr(Yy, Exp6_);
            EdxyZ.Text := RealToStr(Yy2, Exp6_);
            //Lab
            XYZtoLab(X, Y, Z, Llab, Alab, Blab);
            EdLabL.Text := RealToStr(Llab, Exp6_);
            EdLabA.Text := RealToStr(Alab, Exp6_);
            EdLabB.Text := RealToStr(Blab, Exp6_);
            //Luv
            XYZtoLuv(X, Y, Z, Lluv, Uluv, Vluv);
            EdLuvL.Text := RealToStr(Lluv, Exp6_);
            EdLuvU.Text := RealToStr(Uluv, Exp6_);
            EdLuvV.Text := RealToStr(Vluv, Exp6_);
            //-
            Aff_XYZ;
            Aff_Matrice_XYZ;
          end
          else
          begin
            //XYZ
            EdX.Text := '0';
            EdY.Text := '0';
            EdZ.Text := '0';
            //xyY
            EdxyX.Text := '0';
            EdxyY.Text := '0';
            EdxyZ.Text := '0';
            //lab
            EdLabL.Text := '0';
            EdLabA.Text := '0';
            EdLabB.Text := '0';
            //Luv
            EdLuvL.Text := '0';
            EdLuvU.Text := '0';
            EdLuvV.Text := '0';
          end;
        end
        else
        begin
          EdBe.Text := '';
        end;
      end
      else
      begin
        EdGe.Text := '';
      end;
    end
    else
    begin
      EdRe.Text := '';
    end;
  end;
end;

procedure Histogrammes(Select: integer);
var
  CoefYH: real;
  CoefYS, CoefYL: real;
  CoefXH: real;
  CoefXS, CoefXL: real;
  Hr, Sr, Lr: real;
  BilanH: array[0..360] of cardinal;
  BilanS: array[0..100] of cardinal;
  BilanL: array[0..100] of cardinal;
  TotR, TotG, TotB: cardinal;
  mR, mG, mB, v: cardinal;
  Lu1, Lu2: real;
  MaxIX, MaxIY: integer;
  MaxXHSL, MaxYH: integer;
  MaxYS, MaxYL: integer;
  Hmax, Smax, Lmax: integer;
  H, S, L: integer;
  x, y, n, Nb: integer;
  Rb, Gb, Bb: byte;
begin
  with WdHisto do
  begin
    //Max Img1
    MaxIX := Wdmain.Img1.Width;
    MaxIY := Wdmain.Img1.Height;
    //Max ImgHisto X de H,S,L
    MaxXHSL := ImgHistoH.Width;
    //Coef X de H
    if MaxXHSL > 0 then
      CoefXH := 360 / MaxXHSL
    else
      CoefXH := 0;
    //Coef X de S
    if MaxXHSL > 0 then
      CoefXS := 100 / MaxXHSL
    else
      CoefXS := 0;
    //Coef X de L
    if MaxXHSL > 0 then
      CoefXL := 100 / MaxXHSL
    else
      CoefXL := 0;
    //Max Y de H
    MaxYH := ImgHistoH.Height;
    //Max Y de S
    MaxYS := ImgHistoS.Height;
    //Max Y de L
    MaxYL := ImgHistoS.Height;
    //----- Bilan Bilans H,S,L -----
    //Moyenne Clear
    for n := 0 to 360 do
      BilanH[n] := 0;
    for n := 0 to 100 do
    begin
      BilanS[n] := 0;
      BilanL[n] := 0;
    end;
    //----- Bilan des pixels de l'image -----
    TotR := 0;
    TotG := 0;
    TotB := 0;
    mR := 0;
    mG := 0;
    mB := 0;
    Lu1 := 0;
    Lu2 := 0;
    Nb := 0;
    for y := 0 to MaxIY - 1 do
    begin
      for x := 0 to MaxIX - 1 do
      begin
        //Bilan H,S et L
        case Select of
          //Histo H - DataHSL
          1:
          begin
            //Luminance
            Lu1 := Lu1 + sRGB_Luminance(RgbHsl0[x, y].R, RgbHsl0[x, y].G,
              RgbHsl0[x, y].B);
            Lu2 := Lu2 + RgbHsl0[x, y].L;

            if (RgbHsl0[x, y].H >= 0) and (RgbHsl0[x, y].H <= 360) then
              Inc(BilanH[RgbHsl0[x, y].H]);
            if (RgbHsl0[x, y].S >= 0) and (RgbHsl0[x, y].S <= 100) then
              Inc(BilanS[RgbHsl0[x, y].S]);
            if (RgbHsl0[x, y].L >= 0) and (RgbHsl0[x, y].L <= 100) then
              Inc(BilanL[RgbHsl0[x, y].L]);
          end;
          //Histo S - DataHSL2
          2:
          begin
            //Luminance
            Lu1 := Lu1 + sRGB_Luminance(RgbHsl2[x, y].R, RgbHsl2[x, y].G,
              RgbHsl2[x, y].B);
            Lu2 := Lu2 + RgbHsl2[x, y].L;

            if (RgbHsl2[x, y].H >= 0) and (RgbHsl2[x, y].H <= 360) then
              Inc(BilanH[RgbHsl2[x, y].H]);
            if (RgbHsl2[x, y].S >= 0) and (RgbHsl2[x, y].S <= 100) then
              Inc(BilanS[RgbHsl2[x, y].S]);
            if (RgbHsl2[x, y].L >= 0) and (RgbHsl2[x, y].L <= 100) then
              Inc(BilanL[RgbHsl2[x, y].L]);
          end;
          //Histo L - DataHSL3
          3:
          begin
            //Luminance
            Lu1 := Lu1 + sRGB_Luminance(RgbHsl3[x, y].R, RgbHsl3[x, y].G,
              RgbHsl3[x, y].B);
            Lu2 := Lu2 + RgbHsl3[x, y].L;

            if (RgbHsl3[x, y].H >= 0) and (RgbHsl3[x, y].H <= 360) then
              Inc(BilanH[RgbHsl3[x, y].H]);
            if (RgbHsl3[x, y].S >= 0) and (RgbHsl3[x, y].S <= 100) then
              Inc(BilanS[RgbHsl3[x, y].S]);
            if (RgbHsl3[x, y].L >= 0) and (RgbHsl3[x, y].L <= 100) then
              Inc(BilanL[RgbHsl3[x, y].L]);
          end;
        end;
        Inc(TotR);
        Inc(TotG);
        Inc(TotB);
        //H - Bilan pour les Moyennes
        case Select of
          1:
          begin
            Inc(mR, RgbHsl2[x, y].R);
            Inc(mG, RgbHsl2[x, y].G);
            Inc(mB, RgbHsl2[x, y].B);
          end;
          //S
          2:
          begin
            Inc(mR, RgbHsl2[x, y].R);
            Inc(mG, RgbHsl2[x, y].G);
            Inc(mB, RgbHsl2[x, y].B);
          end;
          //L
          3:
          begin
            Inc(mR, RgbHsl3[x, y].R);
            Inc(mG, RgbHsl3[x, y].G);
            Inc(mB, RgbHsl3[x, y].B);
          end;
        end;
        Inc(Nb);
      end;
      Application.ProcessMessages;
    end;
    //----- Luminance -----
    with WdMain do
    begin
      LumiRGB := Round(Lu1 / Nb);
      PaLumRGB.Caption := IntToStr(LumiRGB);
      LumiHSL := Round(Lu2 / Nb);
      PaLumHSL.Caption := IntToStr(LumiHSL);
    end;
    //Bilan Moyenne
    MoyR := Round(mR / TotR);
    MoyG := Round(mG / TotG);
    MoyB := Round(mB / TotB);
    //Moyenne Luminance
    MoyY := Round(sRGB_Luminance(MoyR, MoyG, MoyB));
    //Affichage des Moyennes
    with WdMain do
    begin
      PaMoyY.Caption := IntToStr(MoyY);
      PaMoyR.Caption := IntToStr(MoyR);
      PaMoyG.Caption := IntToStr(MoyG);
      PaMoyB.Caption := IntToStr(MoyB);
    end;
    //----- Ln de H,S et L -----
    //Ln de H - Ln doit etre >0
    for n := 0 to 360 do
    begin
      if BilanH[n] > 0 then
        BilanH[n] := Round(Ln(BilanH[n]))
      else
        BilanH[n] := 0;
    end;
    //Ln de S et L
    for n := 0 to 100 do
    begin
      //S
      if BilanS[n] > 0 then
        BilanS[n] := Round(Ln(BilanS[n]))
      else
        BilanS[n] := 0;
      //L
      if BilanL[n] > 0 then
        BilanL[n] := Round(Ln(BilanL[n]))
      else
        BilanL[n] := 0;
    end;
    //----- CoefY H,S et L Max -----
    //H Max
    Hmax := 0;
    for n := 0 to 360 do
      if BilanH[n] > Hmax then
        Hmax := BilanH[n];
    //- 10%
    v := MaxYH - Round(MaxYH * 0.1);
    if Hmax > v then
      CoefYH := Hmax / v
    else
      CoefYH := v / Hmax;
    //Applique CoefY de H
    for n := 0 to 360 do
      BilanH[n] := Round(BilanH[n] * CoefYH);
    //S Max et L Max
    Smax := 0;
    Lmax := 0;
    for n := 0 to 100 do
    begin
      if BilanS[n] > Smax then
        Smax := BilanS[n];
      if BilanL[n] > Lmax then
        Lmax := BilanL[n];
    end;
    //S
    //- 10%
    v := MaxYS - Round(MaxYS * 0.1);
    if Smax > v then
      CoefYS := Smax / v
    else
      CoefYS := v / Smax;
    //L
    //- 10%
    v := MaxYL - Round(MaxYL * 0.1);
    if Lmax > v then
      CoefYL := Lmax / v
    else
      CoefYL := v / Lmax;
    //Applique CoefY de S et de L
    for n := 0 to 100 do
    begin
      BilanS[n] := Round(BilanS[n] * CoefYS);
      BilanL[n] := Round(BilanL[n] * CoefYL);
    end;
    //----- Histogramme H -----
    ImgBmp_Creation(MaxXHSL, MaxYH);
    with ImgBmp.Canvas do
    begin
      //Efface
      Pen.Color := ColCream_;
      for x := 0 to MaxXHSL - 1 do
        Line(x, 0, x, MaxYH - 1);
      Hr := 0;
      S := 100;
      L := 40;
      Rb := 0;
      Gb := 0;
      Bb := 0;
      for x := 0 to MaxXHSL - 1 do
      begin
        HSLtoRGB_H360_S100_L100_RGB255(Round(Hr), S, L, Rb, Gb, Bb);
        Pen.Color := RGBToColor(Rb, Gb, Bb);
        Line(x, MaxYH - 1, x, MaxYH - 1 - BilanH[Round(Hr)]);
        Hr := Hr + CoefXH;
      end;
    end;
    //Recopie dans Histo H et libération
    ImgHistoH.Canvas.CopyRect(Re, ImgBmp.Canvas, Re);
    ImgBmp_Close;
    //----- Histogramme S -----
    ImgBmp_Creation(MaxXHSL, MaxYS);
    //----- Histogramme Ln de S -----
    with ImgBmp.Canvas do
    begin
      //Efface
      Pen.Color := ColCream_;
      for x := 0 to MaxXHSL - 1 do
        Line(x, 0, x, MaxYS - 1);
      H := 180;
      L := 40;
      Sr := 0;
      Pen.Color := $00AEAEAE;
      Rb := 0;
      Gb := 0;
      Bb := 0;
      for x := 0 to MaxXHSL - 1 do
      begin
        HSLtoRGB_H360_S100_L100_RGB255(H, Round(Sr), L, Rb, Gb, Bb);
        Line(x, MaxYS - 1, x, MaxYS - 1 - BilanS[Round(Sr)]);
        Sr := Sr + CoefXS;
      end;
    end;
    //Recopie dans Histo S et libération
    ImgHistoS.Canvas.CopyRect(Re, ImgBmp.Canvas, Re);
    ImgBmp_Close;
    //----- Histogramme L -----
    ImgBmp_Creation(MaxXHSL, MaxYL);
    //----- Histogramme Ln de L -----
    with ImgBmp.Canvas do
    begin
      //Efface
      Pen.Color := ColCream_;
      for x := 0 to MaxXHSL - 1 do
        Line(x, 0, x, MaxYL - 1);
      H := 0;
      S := 0;
      Lr := 0;
      Rb := 0;
      Gb := 0;
      Bb := 0;
      for x := 0 to MaxXHSL - 1 do
      begin
        HSLtoRGB_H360_S100_L100_RGB255(H, S, Round(Lr), Rb, Gb, Bb);
        Pen.Color := RGBToColor(Rb, Gb, Bb);
        Line(x, MaxYL - 1, x, MaxYL - 1 - BilanL[Round(Lr)]);
        Lr := Lr + CoefXL;
      end;
    end;
    //Recopie dans Histo L et libération
    ImgHistoL.Canvas.CopyRect(Re, ImgBmp.Canvas, Re);
    ImgBmp_Close;
  end;
end;

procedure DataN_vers_DataN(Select: integer);
var
  MaxImgX, MaxImgY: integer;
  x, y: integer;
  Rb, Gb, Bb: byte;
begin
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    Rb := 0;
    Gb := 0;
    Bb := 0;
    for y := 0 to MaxImgY - 1 do
    begin
      for x := 0 to MaxImgX - 1 do
      begin
        case Select of
          //RGB0 vers RGB2
          2:
          begin
            //RGB0 vers RGB2
            RgbHsl2[x, y].Cl := RgbHsl0[x, y].Cl;
            RedGreenBlue(RgbHsl2[x, y].Cl, Rb, Gb, Bb);
            RgbHsl2[x, y].R := Rb;
            RgbHsl2[x, y].G := Gb;
            RgbHsl2[x, y].B := Bb;
            //HSL0 vers HSL2
            RgbHsl2[x, y].H := RgbHsl0[x, y].H;
            RgbHsl2[x, y].S := RgbHsl0[x, y].S;
            RgbHsl2[x, y].L := RgbHsl0[x, y].L;
          end;
          3:
          begin
            //RGB2 vers RGB3
            RgbHsl3[x, y].Cl := RgbHsl2[x, y].Cl;
            RgbHsl3[x, y].R := RgbHsl2[x, y].R;
            RgbHsl3[x, y].G := RgbHsl2[x, y].G;
            RgbHsl3[x, y].B := RgbHsl2[x, y].B;
            //HSL2 vers HSL3
            RgbHsl3[x, y].H := RgbHsl2[x, y].H;
            RgbHsl3[x, y].S := RgbHsl2[x, y].S;
            RgbHsl3[x, y].L := RgbHsl2[x, y].L;
          end;
        end;
      end;
      Application.ProcessMessages;
    end;
  end;
end;

procedure Loader(OnOff: boolean);
begin
  with WdMain do
  begin
    //----- Générale -----
    //Panel 4
    PaFile.Enabled := OnOff;
    //Panel 11
    PaSelect.Enabled := OnOff;
    //Matrices et Ouvrir
    Pa10.Enabled := OnOff;
    CbMatrices.Enabled := OnOff;
  end;
end;

procedure Wait_Aff(Select, MaxV, v: integer);
var
  Col: TColor;
  Coef: real;
  n: integer;
begin
  with WdWait do
  begin
    Coef := 42 / MaxV;
    n := Round(v * Coef);
    case Select of
      0: Col := ClCream;
      1: Col := Pal42Color_[n];
    end;
    case n of
      1: Pn01.Color := Col;
      2: Pn02.Color := Col;
      3: Pn03.Color := Col;
      4: Pn04.Color := Col;
      5: Pn05.Color := Col;
      6: Pn06.Color := Col;
      7: Pn07.Color := Col;
      8: Pn08.Color := Col;
      9: Pn09.Color := Col;
      10: Pn10.Color := Col;
      11: Pn11.Color := Col;
      12: Pn12.Color := Col;
      13: Pn13.Color := Col;
      14: Pn14.Color := Col;
      15: Pn15.Color := Col;
      16: Pn16.Color := Col;
      17: Pn17.Color := Col;
      18: Pn18.Color := Col;
      19: Pn19.Color := Col;
      20: Pn20.Color := Col;
      21: Pn21.Color := Col;
      22: Pn22.Color := Col;
      23: Pn23.Color := Col;
      24: Pn24.Color := Col;
      25: Pn25.Color := Col;
      26: Pn26.Color := Col;
      27: Pn27.Color := Col;
      28: Pn28.Color := Col;
      29: Pn29.Color := Col;
      30: Pn30.Color := Col;
      31: Pn31.Color := Col;
      32: Pn32.Color := Col;
      33: Pn33.Color := Col;
      34: Pn34.Color := Col;
      35: Pn35.Color := Col;
      36: Pn36.Color := Col;
      37: Pn37.Color := Col;
      38: Pn38.Color := Col;
      39: Pn39.Color := Col;
      40: Pn40.Color := Col;
      41: Pn41.Color := Col;
      42: Pn42.Color := Col;
    end;
    //Refresh;
    Application.ProcessMessages;
  end;
end;

procedure Wait_Init;
var
  n: integer;
begin
  with WdWait do
  begin
    for n := 1 to 42 do
      Wait_Aff(0, 42, n);
  end;
end;

procedure Wait_Close;
begin
  WdWait.Close;
end;

procedure Masque_vers_Saisie;
begin
  with WdMain do
  begin
    //5x5
    //y=1
    EdC11.Text := IntToStr(Matrice5x5.M5x5[1, 1]);
    EdC21.Text := IntToStr(Matrice5x5.M5x5[2, 1]);
    EdC31.Text := IntToStr(Matrice5x5.M5x5[3, 1]);
    EdC41.Text := IntToStr(Matrice5x5.M5x5[4, 1]);
    EdC51.Text := IntToStr(Matrice5x5.M5x5[5, 1]);
    //y=2
    EdC12.Text := IntToStr(Matrice5x5.M5x5[1, 2]);
    EdC22.Text := IntToStr(Matrice5x5.M5x5[2, 2]);
    EdC32.Text := IntToStr(Matrice5x5.M5x5[3, 2]);
    EdC42.Text := IntToStr(Matrice5x5.M5x5[4, 2]);
    EdC52.Text := IntToStr(Matrice5x5.M5x5[5, 2]);
    //y=3
    EdC13.Text := IntToStr(Matrice5x5.M5x5[1, 3]);
    EdC23.Text := IntToStr(Matrice5x5.M5x5[2, 3]);
    EdC33.Text := IntToStr(Matrice5x5.M5x5[3, 3]);
    EdC43.Text := IntToStr(Matrice5x5.M5x5[4, 3]);
    EdC53.Text := IntToStr(Matrice5x5.M5x5[5, 3]);
    //y=4
    EdC14.Text := IntToStr(Matrice5x5.M5x5[1, 4]);
    EdC24.Text := IntToStr(Matrice5x5.M5x5[2, 4]);
    EdC34.Text := IntToStr(Matrice5x5.M5x5[3, 4]);
    EdC44.Text := IntToStr(Matrice5x5.M5x5[4, 4]);
    EdC54.Text := IntToStr(Matrice5x5.M5x5[5, 4]);
    //y=5
    EdC15.Text := IntToStr(Matrice5x5.M5x5[1, 5]);
    EdC25.Text := IntToStr(Matrice5x5.M5x5[2, 5]);
    EdC35.Text := IntToStr(Matrice5x5.M5x5[3, 5]);
    EdC45.Text := IntToStr(Matrice5x5.M5x5[4, 5]);
    EdC55.Text := IntToStr(Matrice5x5.M5x5[5, 5]);
    PaMatrice.Refresh;
  end;
end;

procedure Saisie_vers_Masque;
begin
  with WdMain do
  begin
    //5x5
    //y=1
    Matrice5x5.M5x5[1, 1] := StrToInt(EdC11.Text);
    Matrice5x5.M5x5[2, 1] := StrToInt(EdC21.Text);
    Matrice5x5.M5x5[3, 1] := StrToInt(EdC31.Text);
    Matrice5x5.M5x5[4, 1] := StrToInt(EdC41.Text);
    Matrice5x5.M5x5[5, 1] := StrToInt(EdC51.Text);
    //y=2
    Matrice5x5.M5x5[1, 2] := StrToInt(EdC12.Text);
    Matrice5x5.M5x5[2, 2] := StrToInt(EdC22.Text);
    Matrice5x5.M5x5[3, 2] := StrToInt(EdC32.Text);
    Matrice5x5.M5x5[4, 2] := StrToInt(EdC42.Text);
    Matrice5x5.M5x5[5, 2] := StrToInt(EdC52.Text);
    //y=3
    Matrice5x5.M5x5[1, 3] := StrToInt(EdC13.Text);
    Matrice5x5.M5x5[2, 3] := StrToInt(EdC23.Text);
    Matrice5x5.M5x5[3, 3] := StrToInt(EdC33.Text);
    Matrice5x5.M5x5[4, 3] := StrToInt(EdC43.Text);
    Matrice5x5.M5x5[5, 3] := StrToInt(EdC53.Text);
    //y=4
    Matrice5x5.M5x5[1, 4] := StrToInt(EdC14.Text);
    Matrice5x5.M5x5[2, 4] := StrToInt(EdC24.Text);
    Matrice5x5.M5x5[3, 4] := StrToInt(EdC34.Text);
    Matrice5x5.M5x5[4, 4] := StrToInt(EdC44.Text);
    Matrice5x5.M5x5[5, 4] := StrToInt(EdC54.Text);
    //y=5
    Matrice5x5.M5x5[1, 5] := StrToInt(EdC15.Text);
    Matrice5x5.M5x5[2, 5] := StrToInt(EdC25.Text);
    Matrice5x5.M5x5[3, 5] := StrToInt(EdC35.Text);
    Matrice5x5.M5x5[4, 5] := StrToInt(EdC45.Text);
    Matrice5x5.M5x5[5, 5] := StrToInt(EdC55.Text);
  end;
end;

procedure Fenetre_RGB_HSL(MaxImgX, MaxImgY, x, y: integer; Out Tab: TabRec16x16_);
var
  MaxFeX, MaxFeY: integer;
  n, p, Decal: integer;
begin
  //Fenetre NxN
  //1:x 2:y 3:decal
  MaxFeX := 5;
  MaxFeY := 5;
  Decal := 3;
  //Clear
  for p := 1 to MaxFeY do
    for n := 1 to MaxFeX do
      with Tab[n, p] do
      begin
        Cl := 0;
        Xp := -1;
        Yp := -1;
        Rp := 0;
        Gp := 0;
        Bp := 0;
        Hp := 0;
        Sp := 0;
        Lp := 0;
        Contours := 0;
      end;
  //Clear
  with FenetreBilan do
  begin
    //Somme
    Rso := 0;
    Gso := 0;
    Bso := 0;
    Hso := 0;
    Sso := 0;
    Lso := 0;
    //MinMax RGB
    Rmin := 0;
    Rmax := 0;
    Gmin := 0;
    Gmax := 0;
    Bmin := 0;
    Bmax := 0;
    //Luminance
    Lu := 0;
    LuMin := 0;
    LuMax := 0;
    //MinMax HSL
    Hmin := 0;
    Hmax := 0;
    Smin := 0;
    Smax := 0;
    Lmin := 0;
    Lmax := 0;
  end;
  for p := 1 to MaxFeY do
  begin
    for n := 1 to MaxFeX do
    begin
      //Récup. pixels n*p
      if (y - Decal + p >= 0) and (y - Decal + p <= MaxImgY) then
      begin
        if (x - Decal + n >= 0) and (x - Decal + n <= MaxImgX) then
        begin
          with Tab[n, p] do
          begin
            //Tab -> Xp,Yp
            Xp := x - Decal + n;
            Yp := y - Decal + p;
            //Cl
            Cl := RgbHsl2[Xp, Yp].Cl;
            //Rp,Gp,Bp
            Rp := RgbHsl2[Xp, Yp].R;
            Gp := RgbHsl2[Xp, Yp].G;
            Bp := RgbHsl2[Xp, Yp].B;
            //Tab -> Hp,Sp,Lp
            Hp := RgbHsl2[Xp, Yp].H;
            Sp := RgbHsl2[Xp, Yp].S;
            Lp := RgbHsl2[Xp, Yp].L;
            //Tab -> Contours
            if (p = 1) or (p = MaxFeY + 2) then
            begin
              Contours := 1;
            end
            else
            begin
              if n in [1, MaxFeX + 2] then
                Contours := 1;
            end;
            //----- Sommes et MinMax -----
            //5x5
            with FenetreBilan do
            begin
              //RGB
              Rso := Rso + (Rp * Matrice5x5.M5x5[n, p]);
              if Rso > Rmax then
                Rmax := Rso;
              if Rso < Rmin then
                Rmin := Rso;
              Gso := Gso + (Gp * Matrice5x5.M5x5[n, p]);
              if Gso > Gmax then
                Gmax := Gso;
              if Gso < Gmin then
                Gmin := Gso;
              Bso := Bso + (Bp * Matrice5x5.M5x5[n, p]);
              if Bso > Bmax then
                Bmax := Bso;
              if Bso < Bmin then
                Bmin := Bso;
              //Luminance
              Lu := sRGB_Luminance(Rp, Gp, Bp);
              if Lu > LuMax then
                LuMax := Lu;
              if Lu < LuMin then
                LuMin := Lu;
              //HSL
              Hso := Lso + (Hp * Matrice5x5.M5x5[n, p]);
              if Hso > Hmax then
                Hmax := Hso;
              if Hso < Hmin then
                Hmin := Hso;
              //S
              Sso := Lso + (Sp * Matrice5x5.M5x5[n, p]);
              if Sso > Smax then
                Smax := Sso;
              if Sso < Smin then
                Smin := Sso;
              //L
              Lso := Lso + (Lp * Matrice5x5.M5x5[n, p]);
              if Lso > Lmax then
                Lmax := Lso;
              if Sso < Lmin then
                Lmin := Lso;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure Fenetre_Somme_Brute(MaxFenetreX, MaxFenetreY: integer;
  Tb16x16: TabRec16x16_; Out Sr, Sg, Sb, Sl: real);
var
  n, p: integer;
begin
  //----- Calcul de la Somme du Masque -----
  //Clear
  Sr := 0;
  Sg := 0;
  Sb := 0;
  Sl := 0;
  //----- Somme du Masque -----
  for p := 1 to MaxFenetreY do
  begin
    for n := 1 to MaxFenetreX do
    begin
      with Tb16x16[n, p] do
      begin
        //5x5
        //RGB
        Sr := Sr + (Rp * Matrice5x5.M5x5[n, p]);
        Sg := Sg + (Gp * Matrice5x5.M5x5[n, p]);
        Sb := Sb + (Bp * Matrice5x5.M5x5[n, p]);
        //HSL
        Sl := Sl + (Lp * Matrice5x5.M5x5[n, p]);
      end;
    end;
  end;
end;

procedure Chargement_du_Masque;
var
  MaxFeX, MaxFeY: integer;
  n, p, q: integer;
begin
  with WdMain do
  begin
    //Fenetre NxN
    //1:x 2:y 3:decal
    MaxFeX := 5;
    MaxFeY := 5;
    if MT_Matrice > 0 then
    begin
      //Matrices 5x5
      for p := 1 to MaxFeY do
        for n := 1 to MaxFeX do
          Matrice5x5.M5x5[n, p] := 0;
      for n := 1 to 3 do
        Matrice5x5.N3[n] := 0;
    end;
    //Chargement
    if MT_Matrice = 0 then
    begin
      //0-Création : Masque manuel (Saisie vers masque)
      Saisie_vers_Masque;
    end
    else
    begin
      //Chargement de la matrices
      for p := 1 to MaxFeY do
      begin
        for n := 1 to MaxFeX do
        begin
          //----- Matrices 5x5 -----
          case MT_Matrice of
            //Création
            //2-0
            0:
            begin
            end;
            //Repoussage
            //2-1
            1:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Repoussage_1_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Repoussage_1_NPT_[q];
            end;
            //laplacien 2
            //2-2
            2:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Laplacien_2_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Laplacien_2_NPT_[q];
            end;
            //Sobel 4 V01
            //2-3
            3:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Sobel_4_H01_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Sobel_4_H01_NPT_[q];
            end;
            //Sobel 4 V02
            //2-4
            4:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Sobel_4_H02_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Sobel_4_H02_NPT_[q];
            end;
            //Sobel 6 V1
            //2-5
            5:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Sobel_6_V1_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Sobel_6_V1_NPT_[q];
            end;
            //Bords 2
            //2-6
            6:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Bords_V2_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Bords_V2_NPT_[q];
            end;
            //Laplacien 4
            //2-7
            7:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Laplacien_3_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Laplacien_3_NPT_[q];
            end;
            //Bords 1
            //2-8
            8:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Bords_1_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Bords_1_NPT_[q];
            end;
            //Gradient Vertical 2a
            //2-9
            9:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Gradient_V2a_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Gradient_V2a_NPT_[q];
            end;
            //Gradient Vertical 2a
            //2-10
            10:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Gradient_H2a_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Gradient_H2a_NPT_[q];
            end;
            //Sobel V1
            //2-11
            11:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Sobel_V1_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Sobel_V1_NPT_[q];
            end;
            //Sobel H2
            //2-12
            12:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Sobel_H2_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Sobel_H2_NPT_[q];
            end;
            //Sobel V3
            //2-13
            13:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Sobel_V3_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Sobel_V3_NPT_[q];
            end;
            //Sobel V5
            //2-14
            14:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Sobel_V5_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Sobel_V5_NPT_[q];
            end;
            //Sobel V7 Neg
            //2-15
            15:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Sobel_V7_Neg_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Sobel_V7_Neg_NPT_[q];
            end;
            //Sobel 8 Cross
            //2-16
            16:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Sobel_8_Cross_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Sobel_8_Cross_NPT_[q];
            end;
            //laplacien 1
            //2-17
            17:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Laplacien_1_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Laplacien_1_NPT_[q];
            end;
            //Laplacien 5
            //2-18
            18:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Laplacien_5_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Laplacien_5_NPT_[q];
            end;
            //Laplacien 3
            //2-19
            19:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Laplacien_4_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Laplacien_4_NPT_[q];
            end;
            //Gradient Horizontal 1
            //2-20
            20:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Gradient_V1a_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Gradient_V1a_NPT_[q];
            end;
            //Bords 3
            //2-21
            21:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Bords_3_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Bords_3_NPT_[q];
            end;
            //Gradient Horizontal 1
            //2-22
            22:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Gradient_H5_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Gradient_H5_NPT_[q];
            end;
            //Passe-Haut 1
            //2-23
            23:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Passe_Haut_1_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Passe_Haut_1_NPT_[q];
            end;
            //Passe-Haut 2
            //2-24
            24:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Passe_Haut_2_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Passe_Haut_2_NPT_[q];
            end;
            //Lissage 1 (fort)
            //2-25
            25:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Lissage_1_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Lissage_1_NPT_[q];
            end;
            //Lissage 2 (moyen)
            //2-26
            26:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Lissage_2_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Lissage_2_NPT_[q];
            end;
            //Moyenne
            //2-27
            27:
            begin
              Matrice5x5.M5x5[n, p] := Matrice_5x5_Moyenne_1_[p, n];
              for q := 1 to 3 do
                Matrice5x5.N3[q] := Matrice_5x5_Moyenne_1_NPT_[q];
            end;
          end;
        end;
      end;
    end;
    if MT_Matrice > 0 then
      Masque_vers_Saisie;
  end;
end;

procedure Fenetre_RGB3(MaxTabX, MaxTabY, MaxImgX, MaxImgY, x, y: integer;
  Out Tab: TabRec16x16_);
var
  n, p: integer;
  Decal: integer;
begin
  //MaxTabX,MaxTabY:Largeur/Hauteur de la fenetre d'excursion
  //MaxImgX,MaxImgY:Largeur/Hauteur de l'image
  //Clear
  case MaxTabX of
    3: Decal := 2;
    5: Decal := 3;
    7: Decal := 4;
    9: Decal := 5;
    11: Decal := 6;
  end;
  for p := 1 to MaxTabY do
    for n := 1 to MaxTabX do
      with Tab[n, p] do
      begin
        Cl := 0;
        Xp := -1;
        Yp := -1;
        Contours := 0;
      end;
  for p := 1 to MaxTabY do
  begin
    for n := 1 to MaxTabX do
    begin
      //Récup. pixels n*p
      if (y - Decal + p >= 0) and (y - Decal + p <= MaxImgY) then
      begin
        if (x - Decal + n >= 0) and (x - Decal + n <= MaxImgX) then
        begin
          with Tab[n, p] do
          begin
            Xp := x - Decal + n;
            Yp := y - Decal + p;
            Cl := RgbHsl3[Xp, Yp].Cl;
            //Contours
            if (p = 1) or (p = MaxTabY + 2) then
            begin
              Contours := 1;
            end
            else
            begin
              if n in [1, MaxTabX + 2] then
                Contours := 1;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure Fenetre_HSL2(MaxTabX, MaxTabY, MaxImgX, MaxImgY, x, y: integer;
  Out Tab: TabRec16x16_2_);
var
  n, p: integer;
  Decal: integer;
begin
  //MaxTabX,MaxTabY:Largeur/Hauteur de la fenetre d'excursion
  //MaxImgX,MaxImgY:Largeur/Hauteur de l'image
  //Clear
  case MaxTabX of
    3: Decal := 2;
    5: Decal := 3;
    7: Decal := 4;
    9: Decal := 5;
    11: Decal := 6;
  end;
  for p := 1 to MaxTabY do
    for n := 1 to MaxTabX do
      with Tab[n, p] do
      begin
        Cl := 0;
        Xp := -1;
        Yp := -1;
        Hp := 0;
        Sp := 0;
        Lp := 0;
        Contours := 0;
      end;
  for p := 1 to MaxTabY do
  begin
    for n := 1 to MaxTabX do
    begin
      //Récup. pixels n*p
      if (y - Decal + p >= 0) and (y - Decal + p <= MaxImgY - 1) then
      begin
        if (x - Decal + n >= 0) and (x - Decal + n <= MaxImgX - 1) then
        begin
          with Tab[n, p] do
          begin
            Xp := x - Decal + n;
            Yp := y - Decal + p;
            Cl := RgbHsl2[Xp, Yp].Cl;
            RGBtoHSL_RGB255_H360_S100_L100(RgbHsl2[Xp, Yp].R, RgbHsl2[Xp, Yp].G,
              RgbHsl2[Xp, Yp].B, Hp, Sp, Lp);
            //Contours
            if (p = 1) or (p = MaxTabY + 2) then
            begin
              Contours := 1;
            end
            else
            begin
              if n in [1, MaxTabX + 2] then
                Contours := 1;
            end;
          end;
        end;
      end;
    end;
  end;
end;

procedure Masque_Somme_HSL(MaxFenetreX, MaxFenetreY: integer;
  Tb2: TabRec16x16_2_; Out So: real);
var
  n, p: integer;
begin
  //----- HSL : Somme du Masque -----
  So := 0;
  for p := 1 to MaxFenetreY do
  begin
    for n := 1 to MaxFenetreX do
    begin
      //5x5
      with Tb2[n, p] do
      begin
        So := So + (Lp * Matrice5x5.M5x5[n, p]);
      end;
    end;
  end;
  //Correction
  So := So * MT_Amplitude;
end;

procedure Image_MinMax_Masque(MaxImgX, MaxImgY: integer);
var
  TabF: TabRec16x16_;
  x, y: integer;
begin
  //Clear
  with MinMaxImg do
  begin
    RmaxP := 0;
    RmaxN := 0;
    GmaxP := 0;
    GmaxN := 0;
    BmaxP := 0;
    BmaxN := 0;
  end;
  for y := 0 to MaxImgY - 1 do
  begin
    for x := 0 to MaxImgX - 1 do
    begin
      Fenetre_RGB_HSL(MaxImgX, MaxImgY, x, y, TabF);
      with MinMaxImg do
      begin
        //R
        if FenetreBilan.Rmax > RmaxP then
          RmaxP := FenetreBilan.Rmax;
        if FenetreBilan.Rmin > RmaxN then
          RmaxN := FenetreBilan.Rmin;
        //G
        if FenetreBilan.Gmax > GmaxP then
          GmaxP := FenetreBilan.Gmax;
        if FenetreBilan.Gmin > GmaxN then
          GmaxN := FenetreBilan.Gmin;
        //R
        if FenetreBilan.Bmax > RmaxP then
          BmaxP := FenetreBilan.Bmax;
        if FenetreBilan.Rmin > BmaxN then
          BmaxN := FenetreBilan.Bmin;
      end;
    end;
  end;
end;

procedure Affiche_Matrice_RGB_HSL(Niveau: integer);
var
  TabF: TabRec16x16_;
  Sr, Sg, Sb: real;
  MaxImgX, MaxImgY: integer;
  x, y: integer;
  Ri, Bi, Gi: integer;
begin
  Loader(False);
  Wait_Init;
  WdWait.Visible := True;
  //-
  DataN_vers_DataN(3);
  //-
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
  end;
  //RGB
  case Niveau of
    //Niveau 1
    1:
    begin
      Image_MinMax_Masque(MaxImgX, MaxImgY);
    end;
    //Niveau 2
    2:
    begin
      //Image_MinMax_Masque(MaxImgX,MaxImgY);
    end;
  end;
  //-
  Wait_Init;
  WdWait.Visible := True;
  //----- Traitement de la fenetre -----
  for y := 0 to MaxImgY - 1 do
  begin
    Wait_Aff(1, MaxImgY, y);
    for x := 0 to MaxImgX - 1 do
    begin
      //Récup. fenêtre nXn pixels
      //----- Fenetre RGB & HSL 5x5 & 3x3 -----
      Fenetre_RGB_HSL(MaxImgX, MaxImgY, x, y, TabF);
      //5x5
      //----- RGB -----
      //Valeur médiane +- la variation
      //5x5
      //Niveau
      case Niveau of
        //Calcul avec le MinMax du la fenetre
        //Niveau 1
        1:
        begin
          Sr := FenetreBilan.Rso;
          Sg := FenetreBilan.Gso;
          Sb := FenetreBilan.Bso;
          //Ajustement
          //R
          if Sr > 0 then
          begin
            if Abs(FenetreBilan.Rmax) <> 0 then
              Sr := (Sr * 255) / Abs(FenetreBilan.Rmax)
            else
              Sr := 0;
          end
          else
          begin
            if Abs(FenetreBilan.Rmin) <> 0 then
              Sr := (Sr * 255) / Abs(FenetreBilan.Rmin)
            else
              Sr := 0;
          end;
          //G
          if Sg > 0 then
          begin
            if Abs(FenetreBilan.Gmax) <> 0 then
              Sg := (Sg * 255) / Abs(FenetreBilan.Gmax)
            else
              Sg := 0;
          end
          else
          begin
            if Abs(FenetreBilan.Gmin) <> 0 then
              Sg := (Sg * 255) / Abs(FenetreBilan.Gmin)
            else
              Sg := 0;
          end;
          //B
          if Sb > 0 then
          begin
            if Abs(FenetreBilan.Bmax) <> 0 then
              Sb := (Sb * 255) / Abs(FenetreBilan.Bmax)
            else
              Sb := 0;
          end
          else
          begin
            if Abs(FenetreBilan.Bmin) <> 0 then
              Sb := (Sb * 255) / Abs(FenetreBilan.Bmin)
            else
              Sb := 0;
          end;
          //Amplitude sur la variation
          Sr := Sr * MT_Amplitude * 0.5;
          Sg := Sg * MT_Amplitude * 0.5;
          Sb := Sb * MT_Amplitude * 0.5;
          Sr := TabF[3, 3].Rp + Sr;
          Sg := TabF[3, 3].Rp + Sg;
          Sb := TabF[3, 3].Rp + Sb;
          //Normalisation
          Ri := Round(Sr);
          Gi := Round(Sg);
          Bi := Round(Sb);
        end;
        //Niveau 2
        2:
        begin
          Sr := FenetreBilan.Rso;
          Sg := FenetreBilan.Gso;
          Sb := FenetreBilan.Bso;
          //Ajustement
          //R
          if Sr >= 0 then
          begin
            if Abs(FenetreBilan.Rmax) <> 0 then
              Sr := (Sr * 255) / Abs(FenetreBilan.Rmax)
            else
              Sr := 0;
          end
          else
          begin
            if Abs(FenetreBilan.Rmin) <> 0 then
              Sr := (Sr * 255) / Abs(FenetreBilan.Rmin)
            else
              Sr := 0;
          end;
          //G
          if Sg >= 0 then
          begin
            if Abs(FenetreBilan.Gmax) <> 0 then
              Sg := (Sg * 255) / Abs(FenetreBilan.Gmax)
            else
              Sg := 0;
          end
          else
          begin
            if Abs(FenetreBilan.Gmin) <> 0 then
              Sg := (Sg * 255) / Abs(FenetreBilan.Gmin)
            else
              Sg := 0;
          end;
          //B
          if Sb >= 0 then
          begin
            if Abs(FenetreBilan.Bmax) <> 0 then
              Sb := (Sb * 255) / Abs(FenetreBilan.Bmax)
            else
              Sb := 0;
          end
          else
          begin
            if Abs(FenetreBilan.Bmin) <> 0 then
              Sb := (Sb * 255) / Abs(FenetreBilan.Bmin)
            else
              Sb := 0;
          end;
          //Amplitude sur la variation
          Sr := Sr * MT_Amplitude * 3;
          Sg := Sg * MT_Amplitude * 3;
          Sb := Sb * MT_Amplitude * 3;
          //Normalisation
          Ri := Round(Sr);
          Gi := Round(Sg);
          Bi := Round(Sb);
        end;
      end;
      //RGB normalisation
      //R
      if Ri < 0 then
        Ri := 0;
      if Ri > 255 then
        Ri := 255;
      //G
      if Gi < 0 then
        Gi := 0;
      if Gi > 255 then
        Gi := 255;
      //B
      if Bi < 0 then
        Bi := 0;
      if Bi > 255 then
        Bi := 255;
      //RGB3
      RgbHsl3[x, y].R := Ri;
      RgbHsl3[x, y].G := Gi;
      RgbHsl3[x, y].B := Bi;
      RgbHsl3[x, y].Cl := RGBToColor(Ri, Gi, Bi);
      //HSL3
      RGBtoHSL_RGB255_H360_S100_L100(Ri, Gi, Bi, RgbHsl3[x, y].H,
        RgbHsl3[x, y].S, RgbHsl3[x, y].L);
    end;
    Application.ProcessMessages;
  end;
  RGB_vers_Img(3, MaxImgX, MaxImgY);
  Wait_Close;
  Loader(True);
end;

procedure Niveau_1;
begin
  with WdMain do
  begin
    with SpdNv1 do
    begin
      Font.Size := 14;
      Font.Style := [fsBold];
    end;
    with SpdNv2 do
    begin
      Font.Size := 10;
      Font.Style := [];
    end;
  end;
  MT_Niveau := 1;
  Affiche_Matrice_RGB_HSL(MT_Niveau);
  Histogrammes(3);
end;

procedure Niveau_2;
begin
  with WdMain do
  begin
    with SpdNv1 do
    begin
      Font.Size := 10;
      Font.Style := [];
    end;
    with SpdNv2 do
    begin
      Font.Size := 14;
      Font.Style := [fsBold];
    end;
  end;
  MT_Niveau := 2;
  Affiche_Matrice_RGB_HSL(MT_Niveau);
  Histogrammes(3);
end;

//Traitement
procedure Traitement_Init;
var
  n, p: integer;
begin
  with WdMain do
  begin
    //----- Histo -----
    HistoH := 0;
    HistoS := 0;
    HistoL := 0;
    //----- Matrices -----
    //Matrice 5x5
    CbMatrices.ItemIndex := 0;
    MT_Matrice := 0;
    //Matrice création
    for n := 1 to 5 do
      for p := 1 to 5 do
        Matrice_Edition[n, p] := Matrice_5x5_Creation_[n, p];
    //Amplitude
    MT_Amplitude := 1;
    //MT_Amplitude:=3;
    Edit4.Text := RealToStr(MT_Amplitude, 1);
    MT_Focus := 1;
    //Type
    ComboBox4.ItemIndex := 31;
    //Niveau
    MT_Niveau := 1;
    with SpdNv1 do
    begin
      Font.Size := 14;
      Font.Style := [fsBold];
    end;
    with SpdNv2 do
    begin
      Font.Size := 10;
      Font.Style := [];
    end;
    //----- Gamma -----
    ComboBox1.ItemIndex := 10;
    //----- Luminance -----
    LumiRGB := 0;
    LumiHSL := 0;
  end;
end;

//----- Img1 -----
procedure Img_Efface(Col: TColor);
var
  x, MaxImgX, MaxImgY: integer;
begin
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    with Img1.Canvas do
    begin
      Pen.Color := Col;
      for x := 0 to MaxImgX - 1 do
        Line(x, 0, x, MaxImgY - 1);
    end;
  end;
end;

procedure Img_vers_RGB0;
var
  MaxImgX: integer;
  MaxImgY: integer;
  x, y: integer;
begin
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    //Copie Img1 vers ImgBmp
    ImgBmp_Creation(MaxImgX, MaxImgY);
    Img_vers_ImgBmp;
    //Traitement
    with ImgBmp.Canvas do
    begin
      for y := 0 to MaxImgY - 1 do
      begin
        for x := 0 to MaxImgX - 1 do
        begin
          with RgbHsl0[x, y] do
          begin
            //RGB
            Cl := Pixels[x, y];
            RedGreenBlue(Cl, R, G, B);
            RgbHsl0[x, y].R := R;
            RgbHsl0[x, y].G := G;
            RgbHsl0[x, y].B := B;
            //HSL
            RGBtoHSL_RGB255_H360_S100_L100(R, G, B, H, S, L);
            //RGB2
            RgbHsl2[x, y].Cl := Cl;
            RgbHsl2[x, y].R := R;
            RgbHsl2[x, y].G := G;
            RgbHsl2[x, y].B := B;
            //HSL2
            RgbHsl2[x, y].H := H;
            RgbHsl2[x, y].S := S;
            RgbHsl2[x, y].L := L;
            //RGB3
            RgbHsl3[x, y].Cl := Cl;
            RgbHsl3[x, y].R := R;
            RgbHsl3[x, y].G := G;
            RgbHsl3[x, y].B := B;
            //HSL3
            RgbHsl3[x, y].H := H;
            RgbHsl3[x, y].S := S;
            RgbHsl3[x, y].L := L;
          end;
        end;
        Application.ProcessMessages;
      end;
    end;
    ImgBmp_vers_Img;
    ImgBmp_Close;
  end;
end;

procedure RGB0_vers_Img;
var
  MaxImgX: integer;
  MaxImgY: integer;
  x, y: integer;
begin
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    //Copie ImgBmpmem vers Img1
    ImgBmp_Creation(MaxImgX, MaxImgY);
    with ImgBmp.Canvas do
    begin
      for y := 0 to MaxImgY - 1 do
      begin
        for x := 0 to MaxImgX - 1 do
        begin
          //RGB0 vers RGB2
          with RgbHsl0[x, y] do
          begin
            //RGB2
            RgbHsl2[x, y].Cl := Cl;
            RgbHsl2[x, y].R := R;
            RgbHsl2[x, y].G := G;
            RgbHsl2[x, y].B := B;
            //HSL2
            RgbHsl2[x, y].H := H;
            RgbHsl2[x, y].S := S;
            RgbHsl2[x, y].L := L;
            //RGB3
            RgbHsl3[x, y].Cl := Cl;
            RgbHsl3[x, y].R := R;
            RgbHsl3[x, y].G := G;
            RgbHsl3[x, y].B := B;
            //HSL3
            RgbHsl3[x, y].H := H;
            RgbHsl3[x, y].S := S;
            RgbHsl3[x, y].L := L;
          end;
          Pixels[x, y] := RgbHsl0[x, y].Cl;
        end;
      end;
    end;
    ImgBmp_vers_Img;
    ImgBmp_Close;
  end;
end;

procedure RGB2_vers_Img;
var
  MaxX, MaxY: integer;
  x, y: integer;
begin
  with WdMain do
  begin
    MaxX := Img1.Width;
    MaxY := Img1.Height;
    //Copie ImgBmpmem vers Img1
    ImgBmp_Creation(MaxX, MaxY);
    with ImgBmp.Canvas do
    begin
      for y := 0 to ImgMaxY_ - 1 do
      begin
        for x := 0 to ImgMaxX_ - 1 do
        begin
          //RGB0 vers RGB2
          with RgbHsl2[x, y] do
          begin
            //RGB3
            RgbHsl3[x, y].Cl := Cl;
            RgbHsl3[x, y].R := R;
            RgbHsl3[x, y].G := G;
            RgbHsl3[x, y].B := B;
            //HSL3
            RgbHsl3[x, y].H := H;
            RgbHsl3[x, y].S := S;
            RgbHsl3[x, y].L := L;
          end;
          Pixels[x, y] := RgbHsl2[x, y].Cl;
        end;
      end;
    end;
    ImgBmp_vers_Img;
    ImgBmp_Close;
  end;
end;

procedure Data3_vers_Data2;
var
  x, y: integer;
begin
  for y := 0 to ImgMaxY_ - 1 do
  begin
    for x := 0 to ImgMaxX_ - 1 do
    begin
      //RGB vers Data2
      with RgbHsl2[x, y] do
      begin
        Cl := RgbHsl3[x, y].Cl;
        R := RgbHsl3[x, y].R;
        G := RgbHsl3[x, y].G;
        B := RgbHsl3[x, y].B;
        H := RgbHsl3[x, y].H;
        S := RgbHsl3[x, y].S;
        L := RgbHsl3[x, y].L;
      end;
    end;
  end;
end;

procedure TWdMain.Img_XY_RGB_HSL(Select, x, y: integer);
var
  Col: TColor;
  Xx, Yx, Zx: real;
  Le, Ae, Be: real;
  H, S, L: integer;
  Rb, Gb, Bb: byte;
begin
  with WdMain do
  begin
    //X,Y
    EdX.Text := IntToStr(x);
    EdY.Text := IntToStr(y);
    case Select of
      1: Col := WdMain.Img1.Canvas.Pixels[x, y];
      2: Col := WdHisto.ImgHistoH.Canvas.Pixels[x, y];
    end;
    //R,G,B
    RedGreenBlue(Col, Rb, Gb, Bb);
    EdR.Text := IntToStr(Rb);
    EdG.Text := IntToStr(Gb);
    EdB.Text := IntToStr(Bb);
    //H,S,L
    H := 0;
    S := 0;
    L := 0;
    RGBtoHSL_RGB255_H360_S100_L100(Rb, Gb, Bb, H, S, L);
    EdH.Text := IntToStr(H);
    EdS.Text := IntToStr(S);
    EdL.Text := IntToStr(L);
    //X,Y,Z
    Xx := 0;
    Yx := 0;
    Zx := 0;
    RGBToXYZ(Col, Xx, Yx, Zx);
    EdXx.Text := RealToStr(Xx, 2);
    EdYx.Text := RealToStr(Yx, 2);
    EdZx.Text := RealToStr(Zx, 2);
    //Lab
    Le := 0;
    Ae := 0;
    Be := 0;
    XYZtoLab(Xx, Yx, Zx, Le, Ae, Be);
    EdLe.Text := RealToStr(Le, 2);
    EdAe.Text := RealToStr(Ae, 2);
    EdBe.Text := RealToStr(Be, 2);
    //Luminance
    EdLum.Text := RealToStr(sRGB_Luminance(Rb, Gb, Bb), 0);

    PaNbre.Caption := IntToStr(Col);
  end;
end;

procedure TWdMain.Zoom_Affiche(Select, Xp, Yp: integer);
var
  Col: array[1..9, 1..9] of TColor;
  MaxX, MaxY: integer;
  n, p, x, y: integer;
begin
  case Select of
    1: with WdMain do
      begin
        MaxX := Img1.Width;
        MaxY := Img1.Height;
      end;
    2: with WdHisto do
      begin
        MaxX := ImgHistoH.Width;
        MaxY := ImgHistoH.Height;
      end;
  end;
  for p := 1 to 9 do
  begin
    for n := 1 to 9 do
    begin
      Col[n, p] := ClCream;
    end;
  end;
  p := 1;
  for y := Yp - 4 to Yp + 4 do
  begin
    n := 1;
    for x := Xp - 4 to Xp + 4 do
    begin
      if (y >= 0) and (y <= MaxY - 1) then
        if (x >= 0) and (x <= MaxX - 1) then
          case Select of
            1: Col[n, p] := Img1.Canvas.Pixels[x, y];
            2: Col[n, p] := WdHisto.ImgHistoH.Canvas.Pixels[x, y];
          end;
      Inc(n);
    end;
    Inc(p);
  end;
  with WdMain do
  begin
    //y-4
    Pn11.Color := Col[1, 1];
    Pn12.Color := Col[2, 1];
    Pn13.Color := Col[3, 1];
    Pn14.Color := Col[4, 1];
    Pn15.Color := Col[5, 1];
    Pn16.Color := Col[6, 1];
    Pn17.Color := Col[7, 1];
    Pn18.Color := Col[8, 1];
    Pn19.Color := Col[9, 1];
    //y-3
    Pn21.Color := Col[1, 2];
    Pn22.Color := Col[2, 2];
    Pn23.Color := Col[3, 2];
    Pn24.Color := Col[4, 2];
    Pn25.Color := Col[5, 2];
    Pn26.Color := Col[6, 2];
    Pn27.Color := Col[7, 2];
    Pn28.Color := Col[8, 2];
    Pn29.Color := Col[9, 2];
    //y-2
    Pn31.Color := Col[1, 3];
    Pn32.Color := Col[2, 3];
    Pn33.Color := Col[3, 3];
    Pn34.Color := Col[4, 3];
    Pn35.Color := Col[5, 3];
    Pn36.Color := Col[6, 3];
    Pn37.Color := Col[7, 3];
    Pn38.Color := Col[8, 3];
    Pn39.Color := Col[9, 3];
    //y-1
    Pn41.Color := Col[1, 4];
    Pn42.Color := Col[2, 4];
    Pn43.Color := Col[3, 4];
    Pn44.Color := Col[4, 4];
    Pn45.Color := Col[5, 4];
    Pn46.Color := Col[6, 4];
    Pn47.Color := Col[7, 4];
    Pn48.Color := Col[8, 4];
    Pn49.Color := Col[9, 4];
    //y
    Pn51.Color := Col[1, 5];
    Pn52.Color := Col[2, 5];
    Pn53.Color := Col[3, 5];
    Pn54.Color := Col[4, 5];
    Pn55.Color := Col[5, 5];
    Pn56.Color := Col[6, 5];
    Pn57.Color := Col[7, 5];
    Pn58.Color := Col[8, 5];
    Pn59.Color := Col[9, 5];
    //y+1
    Pn61.Color := Col[1, 6];
    Pn62.Color := Col[2, 6];
    Pn63.Color := Col[3, 6];
    Pn64.Color := Col[4, 6];
    Pn65.Color := Col[5, 6];
    Pn66.Color := Col[6, 6];
    Pn67.Color := Col[7, 6];
    Pn68.Color := Col[8, 6];
    Pn69.Color := Col[9, 6];
    //y+2
    Pn71.Color := Col[1, 7];
    Pn72.Color := Col[2, 7];
    Pn73.Color := Col[3, 7];
    Pn74.Color := Col[4, 7];
    Pn75.Color := Col[5, 7];
    Pn76.Color := Col[6, 7];
    Pn77.Color := Col[7, 7];
    Pn78.Color := Col[8, 7];
    Pn79.Color := Col[9, 7];
    //y+3
    Pn81.Color := Col[1, 8];
    Pn82.Color := Col[2, 8];
    Pn83.Color := Col[3, 8];
    Pn84.Color := Col[4, 8];
    Pn85.Color := Col[5, 8];
    Pn86.Color := Col[6, 8];
    Pn87.Color := Col[7, 8];
    Pn88.Color := Col[8, 8];
    Pn89.Color := Col[9, 8];
    //y+4
    Pn91.Color := Col[1, 9];
    Pn92.Color := Col[2, 9];
    Pn93.Color := Col[3, 9];
    Pn94.Color := Col[4, 9];
    Pn95.Color := Col[5, 9];
    Pn96.Color := Col[6, 9];
    Pn97.Color := Col[7, 9];
    Pn98.Color := Col[8, 9];
    Pn99.Color := Col[9, 9];
  end;
end;

procedure Median_Cut(MaxTabX, MaxTabY: integer);
var
  TabF: TabRec16x16_;
  TriCl: TabTC256_;
  Col: TColor;
  MaxImgX, MaxImgY: integer;
  n, p, i, x, y: integer;
  Med, Nb: integer;
  Rb, Gb, Bb: byte;
begin
  Loader(False);
  Wait_Init;
  WdWait.Visible := True;
  DataN_vers_DataN(3);
  with WdMain do
  begin
    //Image
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    //Tableau
    Med := ((MaxTabX * MaxTabY) div 2) + 1;
    for y := 0 to MaxImgY - 1 do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX - 1 do
      begin
        Fenetre_RGB3(MaxTabX, MaxTabY, MaxImgX, MaxImgY, x, y, TabF);
        //Sur toute la couleur
        //Tab vers Tri
        i := 1;
        for p := 1 to MaxTabY do
        begin
          for n := 1 to MaxTabX do
          begin
            TriCl[i] := TabF[n, p].Cl;
            Inc(i);
          end;
        end;
        //Tri...
        QuickSort_Cl_16x16(TriCl, 1, MaxTabX * MaxTabY);
        Col := 0;
        Nb := 0;
        for p := 1 to MaxTabY do
        begin
          for n := 1 to MaxTabX do
          begin
            with TabF[n, p] do
            begin
              if Contours = 1 then
              begin
                Col := Col + TabF[n, p].Cl;
                Inc(Nb);
              end;
            end;
          end;
        end;
        if Nb > 0 then
          Col := Round(Col / Nb)
        else
          Col := 0;
        //Couleur médiane
        RgbHsl3[x, y].Cl := TriCl[Med];
        RedGreenBlue(RgbHsl3[x, y].Cl, Rb, Gb, Bb);
        RgbHsl3[x, y].R := Rb;
        RgbHsl3[x, y].G := Gb;
        RgbHsl3[x, y].B := Bb;
      end;
      Application.ProcessMessages;
    end;
    //Mise à jour RGB3 vers Img1
    RGB_vers_Img(3, MaxImgX, MaxImgY);
  end;
  Wait_Close;
  Loader(True);
end;

procedure RGB_nCubes_Nc_Old(Select: integer);
var
  MaxImgX, MaxImgY: integer;
  x, y: integer;
  Rb, Gb, Bb: byte;
begin
  Loader(False);
  with WdMain do
  begin
    MaxImgX := Img1.Width - 1;
    MaxImgY := Img1.Height - 1;
    Wait_Init;
    WdWait.Visible := True;
    Rb := 0;
    Gb := 0;
    Bb := 0;
    for y := 0 to MaxImgY - 1 do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX - 1 do
      begin
        //Nombre de Couleurs
        case Select of
          1:
          begin
            //8 couleurs = 3^2
            case RgbHsl2[x, y].R of
              0..127: Rb := 0;
              128..255: Rb := 255;
            end;
            case RgbHsl2[x, y].G of
              0..127: Gb := 0;
              128..255: Gb := 255;
            end;
            case RgbHsl2[x, y].B of
              0..127: Bb := 0;
              128..255: Bb := 255;
            end;
          end;
          2:
          begin
            case RgbHsl2[x, y].R of
              0..127: Rb := 63;
              128..255: Rb := 191;
            end;
            case RgbHsl2[x, y].G of
              0..127: Gb := 63;
              128..255: Gb := 191;
            end;
            case RgbHsl2[x, y].B of
              0..127: Bb := 63;
              128..255: Bb := 191;
            end;
          end;
          3:
          begin
            case RgbHsl2[x, y].R of
              0..84: Rb := 42;
              85..169: Rb := 127;
              170..255: Rb := 212;
            end;
            case RgbHsl2[x, y].G of
              0..84: Gb := 42;
              85..169: Gb := 127;
              170..255: Gb := 212;
            end;
            case RgbHsl2[x, y].B of
              0..84: Bb := 42;
              85..169: Bb := 127;
              170..255: Bb := 212;
            end;
          end;
          4:
          begin
            case RgbHsl2[x, y].R of
              0.. 63: Rb := 31;
              64..127: Rb := 95;
              128..191: Rb := 159;
              192..255: Rb := 223;
            end;
            case RgbHsl2[x, y].G of
              0.. 63: Gb := 31;
              64..127: Gb := 95;
              128..191: Gb := 159;
              192..255: Gb := 223;
            end;
            case RgbHsl2[x, y].B of
              0.. 63: Bb := 31;
              64..127: Bb := 95;
              128..191: Bb := 159;
              192..255: Bb := 223;
            end;
          end;
          5:
          begin
            case RgbHsl2[x, y].R of
              0.. 51: Rb := 25;
              52..102: Rb := 77;
              103..153: Rb := 128;
              154..204: Rb := 179;
              205..255: Rb := 230;
            end;
            case RgbHsl2[x, y].G of
              0.. 51: Gb := 25;
              52..102: Gb := 77;
              103..153: Gb := 128;
              154..204: Gb := 179;
              205..255: Gb := 230;
            end;
            case RgbHsl2[x, y].B of
              0.. 51: Bb := 25;
              52..102: Bb := 77;
              103..153: Bb := 128;
              154..204: Bb := 179;
              205..255: Bb := 230;
            end;
          end;
          8:
          begin
            case RgbHsl2[x, y].R of
              0.. 31: Rb := 15;
              32.. 63: Rb := 47;
              64.. 95: Rb := 79;
              96..127: Rb := 111;
              128..159: Rb := 143;
              160..191: Rb := 175;
              192..223: Rb := 207;
              224..255: Rb := 239;
            end;
            case RgbHsl2[x, y].G of
              0.. 31: Gb := 15;
              32.. 63: Gb := 47;
              64.. 95: Gb := 79;
              96..127: Gb := 111;
              128..159: Gb := 143;
              160..191: Gb := 175;
              192..223: Gb := 207;
              224..255: Gb := 239;
            end;
            case RgbHsl2[x, y].B of
              0.. 31: Bb := 15;
              32.. 63: Bb := 47;
              64.. 95: Bb := 79;
              96..127: Bb := 111;
              128..159: Bb := 143;
              160..191: Bb := 175;
              192..223: Bb := 207;
              224..255: Bb := 239;
            end;
          end;
          16:
          begin
            case RgbHsl2[x, y].R of
              0.. 15: Rb := 7;
              16.. 31: Rb := 23;
              32.. 47: Rb := 39;
              48.. 63: Rb := 55;
              64.. 79: Rb := 71;
              80.. 95: Rb := 87;
              96..111: Rb := 103;
              112..127: Rb := 119;
              128..143: Rb := 135;
              144..159: Rb := 151;
              160..175: Rb := 167;
              176..191: Rb := 183;
              192..207: Rb := 199;
              208..223: Rb := 215;
              224..239: Rb := 231;
              240..255: Rb := 247;
            end;
            case RgbHsl2[x, y].G of
              0.. 15: Gb := 7;
              16.. 31: Gb := 23;
              32.. 47: Gb := 39;
              48.. 63: Gb := 55;
              64.. 79: Gb := 71;
              80.. 95: Gb := 87;
              96..111: Gb := 103;
              112..127: Gb := 119;
              128..143: Gb := 135;
              144..159: Gb := 151;
              160..175: Gb := 167;
              176..191: Gb := 183;
              192..207: Gb := 199;
              208..223: Gb := 215;
              224..239: Gb := 231;
              240..255: Gb := 247;
            end;
            case RgbHsl2[x, y].B of
              0.. 15: Bb := 7;
              16.. 31: Bb := 23;
              32.. 47: Bb := 39;
              48.. 63: Bb := 55;
              64.. 79: Bb := 71;
              80.. 95: Bb := 87;
              96..111: Bb := 103;
              112..127: Bb := 119;
              128..143: Bb := 135;
              144..159: Bb := 151;
              160..175: Bb := 167;
              176..191: Bb := 183;
              192..207: Bb := 199;
              208..223: Bb := 215;
              224..239: Bb := 231;
              240..255: Bb := 247;
            end;
          end;
          32:
          begin
            case RgbHsl2[x, y].R of
              0..  7: Rb := 3;
              8.. 15: Rb := 11;
              16.. 23: Rb := 19;
              24.. 31: Rb := 27;
              32.. 39: Rb := 35;
              40.. 47: Rb := 43;
              48.. 55: Rb := 51;
              56.. 64: Rb := 59;
              65.. 71: Rb := 67;
              72.. 79: Rb := 75;
              80.. 87: Rb := 83;
              88.. 95: Rb := 91;
              96..103: Rb := 99;
              104..111: Rb := 107;
              112..119: Rb := 115;
              120..127: Rb := 123;
              128..135: Rb := 131;
              136..143: Rb := 139;
              144..151: Rb := 147;
              152..159: Rb := 155;
              160..167: Rb := 163;
              168..175: Rb := 171;
              176..183: Rb := 179;
              184..191: Rb := 187;
              192..199: Rb := 195;
              200..207: Rb := 203;
              208..215: Rb := 211;
              216..223: Rb := 219;
              224..231: Rb := 227;
              232..239: Rb := 235;
              240..247: Rb := 243;
              248..255: Rb := 251;
            end;
            case RgbHsl2[x, y].G of
              0..  7: Gb := 3;
              8.. 15: Gb := 11;
              16.. 23: Gb := 19;
              24.. 31: Gb := 27;
              32.. 39: Gb := 35;
              40.. 47: Gb := 43;
              48.. 55: Gb := 51;
              56.. 64: Gb := 59;
              65.. 71: Gb := 67;
              72.. 79: Gb := 75;
              80.. 87: Gb := 83;
              88.. 95: Gb := 91;
              96..103: Gb := 99;
              104..111: Gb := 107;
              112..119: Gb := 115;
              120..127: Gb := 123;
              128..135: Gb := 131;
              136..143: Gb := 139;
              144..151: Gb := 147;
              152..159: Gb := 155;
              160..167: Gb := 163;
              168..175: Gb := 171;
              176..183: Gb := 179;
              184..191: Gb := 187;
              192..199: Gb := 195;
              200..207: Gb := 203;
              208..215: Gb := 211;
              216..223: Gb := 219;
              224..231: Gb := 227;
              232..239: Gb := 235;
              240..247: Gb := 243;
              248..255: Gb := 251;
            end;
            case RgbHsl2[x, y].B of
              0..  7: Bb := 3;
              8.. 15: Bb := 11;
              16.. 23: Bb := 19;
              24.. 31: Bb := 27;
              32.. 39: Bb := 35;
              40.. 47: Bb := 43;
              48.. 55: Bb := 51;
              56.. 64: Bb := 59;
              65.. 71: Bb := 67;
              72.. 79: Bb := 75;
              80.. 87: Bb := 83;
              88.. 95: Bb := 91;
              96..103: Bb := 99;
              104..111: Bb := 107;
              112..119: Bb := 115;
              120..127: Bb := 123;
              128..135: Bb := 131;
              136..143: Bb := 139;
              144..151: Bb := 147;
              152..159: Bb := 155;
              160..167: Bb := 163;
              168..175: Bb := 171;
              176..183: Bb := 179;
              184..191: Bb := 187;
              192..199: Bb := 195;
              200..207: Bb := 203;
              208..215: Bb := 211;
              216..223: Bb := 219;
              224..231: Bb := 227;
              232..239: Bb := 235;
              240..247: Bb := 243;
              248..255: Bb := 251;
            end;
          end;
        end;
        //RGB3
        RgbHsl3[x, y].Cl := RGBToColor(Rb, Gb, Bb);
        RgbHsl3[x, y].R := Rb;
        RgbHsl3[x, y].G := Gb;
        RgbHsl3[x, y].B := Bb;
        //HSL3
        RGBtoHSL_RGB255_H360_S100_L100(Rb, Gb, Bb, RgbHsl3[x, y].H, RgbHsl3[x, y].S,
          RgbHsl3[x, y].L);
      end;
      Application.ProcessMessages;
    end;
    //Mise à jour RGB3 vers Img1
    RGB_vers_Img(3, MaxImgX, MaxImgY);
    Wait_Close;
  end;
  Loader(True);
end;

procedure RGB_nCubes_Nc(Select: integer);
var
  MaxImgX, MaxImgY: integer;
  x, y: integer;
  Rb, Gb, Bb: byte;
begin
  Loader(False);
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    Wait_Init;
    WdWait.Visible := True;
    Rb := 0;
    Gb := 0;
    Bb := 0;
    for y := 0 to MaxImgY - 1 do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX - 1 do
      begin
        //Nombre de Couleurs
        case Select of
          1:
          begin
            //8 couleurs = 3^2
            case RgbHsl2[x, y].R of
              0..127: Rb := 0;
              128..255: Rb := 255;
            end;
            case RgbHsl2[x, y].G of
              0..127: Gb := 0;
              128..255: Gb := 255;
            end;
            case RgbHsl2[x, y].B of
              0..127: Bb := 0;
              128..255: Bb := 255;
            end;
          end;
          2:
          begin
            case RgbHsl2[x, y].R of
              0..127: Rb := 63;
              128..255: Rb := 191;
            end;
            case RgbHsl2[x, y].G of
              0..127: Gb := 63;
              128..255: Gb := 191;
            end;
            case RgbHsl2[x, y].B of
              0..127: Bb := 63;
              128..255: Bb := 191;
            end;
          end;
          3:
          begin
            case RgbHsl2[x, y].R of
              0..84: Rb := 42;
              85..169: Rb := 127;
              170..255: Rb := 212;
            end;
            case RgbHsl2[x, y].G of
              0..84: Gb := 42;
              85..169: Gb := 127;
              170..255: Gb := 212;
            end;
            case RgbHsl2[x, y].B of
              0..84: Bb := 42;
              85..169: Bb := 127;
              170..255: Bb := 212;
            end;
          end;
          4:
          begin
            case RgbHsl2[x, y].R of
              0.. 63: Rb := 31;
              64..127: Rb := 95;
              128..191: Rb := 159;
              192..255: Rb := 223;
            end;
            case RgbHsl2[x, y].G of
              0.. 63: Gb := 31;
              64..127: Gb := 95;
              128..191: Gb := 159;
              192..255: Gb := 223;
            end;
            case RgbHsl2[x, y].B of
              0.. 63: Bb := 31;
              64..127: Bb := 95;
              128..191: Bb := 159;
              192..255: Bb := 223;
            end;
          end;
          5:
          begin
            case RgbHsl2[x, y].R of
              0.. 51: Rb := 25;
              52..102: Rb := 77;
              103..153: Rb := 128;
              154..204: Rb := 179;
              205..255: Rb := 230;
            end;
            case RgbHsl2[x, y].G of
              0.. 51: Gb := 25;
              52..102: Gb := 77;
              103..153: Gb := 128;
              154..204: Gb := 179;
              205..255: Gb := 230;
            end;
            case RgbHsl2[x, y].B of
              0.. 51: Bb := 25;
              52..102: Bb := 77;
              103..153: Bb := 128;
              154..204: Bb := 179;
              205..255: Bb := 230;
            end;
          end;
          8:
          begin
            case RgbHsl2[x, y].R of
              0.. 31: Rb := 15;
              32.. 63: Rb := 47;
              64.. 95: Rb := 79;
              96..127: Rb := 111;
              128..159: Rb := 143;
              160..191: Rb := 175;
              192..223: Rb := 207;
              224..255: Rb := 239;
            end;
            case RgbHsl2[x, y].G of
              0.. 31: Gb := 15;
              32.. 63: Gb := 47;
              64.. 95: Gb := 79;
              96..127: Gb := 111;
              128..159: Gb := 143;
              160..191: Gb := 175;
              192..223: Gb := 207;
              224..255: Gb := 239;
            end;
            case RgbHsl2[x, y].B of
              0.. 31: Bb := 15;
              32.. 63: Bb := 47;
              64.. 95: Bb := 79;
              96..127: Bb := 111;
              128..159: Bb := 143;
              160..191: Bb := 175;
              192..223: Bb := 207;
              224..255: Bb := 239;
            end;
          end;
          16:
          begin
            case RgbHsl2[x, y].R of
              0.. 15: Rb := 7;
              16.. 31: Rb := 23;
              32.. 47: Rb := 39;
              48.. 63: Rb := 55;
              64.. 79: Rb := 71;
              80.. 95: Rb := 87;
              96..111: Rb := 103;
              112..127: Rb := 119;
              128..143: Rb := 135;
              144..159: Rb := 151;
              160..175: Rb := 167;
              176..191: Rb := 183;
              192..207: Rb := 199;
              208..223: Rb := 215;
              224..239: Rb := 231;
              240..255: Rb := 247;
            end;
            case RgbHsl2[x, y].G of
              0.. 15: Gb := 7;
              16.. 31: Gb := 23;
              32.. 47: Gb := 39;
              48.. 63: Gb := 55;
              64.. 79: Gb := 71;
              80.. 95: Gb := 87;
              96..111: Gb := 103;
              112..127: Gb := 119;
              128..143: Gb := 135;
              144..159: Gb := 151;
              160..175: Gb := 167;
              176..191: Gb := 183;
              192..207: Gb := 199;
              208..223: Gb := 215;
              224..239: Gb := 231;
              240..255: Gb := 247;
            end;
            case RgbHsl2[x, y].B of
              0.. 15: Bb := 7;
              16.. 31: Bb := 23;
              32.. 47: Bb := 39;
              48.. 63: Bb := 55;
              64.. 79: Bb := 71;
              80.. 95: Bb := 87;
              96..111: Bb := 103;
              112..127: Bb := 119;
              128..143: Bb := 135;
              144..159: Bb := 151;
              160..175: Bb := 167;
              176..191: Bb := 183;
              192..207: Bb := 199;
              208..223: Bb := 215;
              224..239: Bb := 231;
              240..255: Bb := 247;
            end;
          end;
          32:
          begin
            case RgbHsl2[x, y].R of
              0..  7: Rb := 3;
              8.. 15: Rb := 11;
              16.. 23: Rb := 19;
              24.. 31: Rb := 27;
              32.. 39: Rb := 35;
              40.. 47: Rb := 43;
              48.. 55: Rb := 51;
              56.. 64: Rb := 59;
              65.. 71: Rb := 67;
              72.. 79: Rb := 75;
              80.. 87: Rb := 83;
              88.. 95: Rb := 91;
              96..103: Rb := 99;
              104..111: Rb := 107;
              112..119: Rb := 115;
              120..127: Rb := 123;
              128..135: Rb := 131;
              136..143: Rb := 139;
              144..151: Rb := 147;
              152..159: Rb := 155;
              160..167: Rb := 163;
              168..175: Rb := 171;
              176..183: Rb := 179;
              184..191: Rb := 187;
              192..199: Rb := 195;
              200..207: Rb := 203;
              208..215: Rb := 211;
              216..223: Rb := 219;
              224..231: Rb := 227;
              232..239: Rb := 235;
              240..247: Rb := 243;
              248..255: Rb := 251;
            end;
            case RgbHsl2[x, y].G of
              0..  7: Gb := 3;
              8.. 15: Gb := 11;
              16.. 23: Gb := 19;
              24.. 31: Gb := 27;
              32.. 39: Gb := 35;
              40.. 47: Gb := 43;
              48.. 55: Gb := 51;
              56.. 64: Gb := 59;
              65.. 71: Gb := 67;
              72.. 79: Gb := 75;
              80.. 87: Gb := 83;
              88.. 95: Gb := 91;
              96..103: Gb := 99;
              104..111: Gb := 107;
              112..119: Gb := 115;
              120..127: Gb := 123;
              128..135: Gb := 131;
              136..143: Gb := 139;
              144..151: Gb := 147;
              152..159: Gb := 155;
              160..167: Gb := 163;
              168..175: Gb := 171;
              176..183: Gb := 179;
              184..191: Gb := 187;
              192..199: Gb := 195;
              200..207: Gb := 203;
              208..215: Gb := 211;
              216..223: Gb := 219;
              224..231: Gb := 227;
              232..239: Gb := 235;
              240..247: Gb := 243;
              248..255: Gb := 251;
            end;
            case RgbHsl2[x, y].B of
              0..  7: Bb := 3;
              8.. 15: Bb := 11;
              16.. 23: Bb := 19;
              24.. 31: Bb := 27;
              32.. 39: Bb := 35;
              40.. 47: Bb := 43;
              48.. 55: Bb := 51;
              56.. 64: Bb := 59;
              65.. 71: Bb := 67;
              72.. 79: Bb := 75;
              80.. 87: Bb := 83;
              88.. 95: Bb := 91;
              96..103: Bb := 99;
              104..111: Bb := 107;
              112..119: Bb := 115;
              120..127: Bb := 123;
              128..135: Bb := 131;
              136..143: Bb := 139;
              144..151: Bb := 147;
              152..159: Bb := 155;
              160..167: Bb := 163;
              168..175: Bb := 171;
              176..183: Bb := 179;
              184..191: Bb := 187;
              192..199: Bb := 195;
              200..207: Bb := 203;
              208..215: Bb := 211;
              216..223: Bb := 219;
              224..231: Bb := 227;
              232..239: Bb := 235;
              240..247: Bb := 243;
              248..255: Bb := 251;
            end;
          end;
        end;
        //RGB3
        RgbHsl3[x, y].Cl := RGBToColor(Rb, Gb, Bb);
        RgbHsl3[x, y].R := Rb;
        RgbHsl3[x, y].G := Gb;
        RgbHsl3[x, y].B := Bb;
        //HSL3 : Récupération de H,S,L
        RGBtoHSL_RGB255_H360_S100_L100(Rb, Gb, Bb, RgbHsl3[x, y].H, RgbHsl3[x, y].S,
          RgbHsl3[x, y].L);
      end;
      Application.ProcessMessages;
    end;
    //Mise à jour RGB3
    RGB_vers_Img(3, MaxImgX, MaxImgY);
    Wait_Close;
  end;
  Loader(True);
end;

procedure H_HSL_nCubes(Select: integer);
var
  MaxImgX, MaxImgY: integer;
  H, x, y: integer;
  Rb, Gb, Bb: byte;
begin
  Loader(False);
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    Wait_Init;
    WdWait.Visible := True;
    Rb := 0;
    Gb := 0;
    Bb := 0;
    for y := 0 to MaxImgY - 1 do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX - 1 do
      begin
        H := 0;
        case Select of
          2: case RgbHsl2[x, y].H of
              0.. 179: H := 90;
              180..359: H := 270;
            end;
          4: case RgbHsl2[x, y].H of
              0.. 89: H := 45;
              90..179: H := 135;
              180..269: H := 225;
              270..359: H := 315;
            end;
          6: case RgbHsl2[x, y].H of
              0.. 59: H := 30;
              60..119: H := 90;
              120..179: H := 150;
              180..239: H := 210;
              240..299: H := 270;
              300..359: H := 330;
            end;
          //8a
          8: case RgbHsl2[x, y].H of
              0.. 44: H := 22;
              45.. 89: H := 67;
              90..134: H := 112;
              135..179: H := 157;
              180..224: H := 202;
              225..269: H := 247;
              270..314: H := 292;
              315..359: H := 337;
            end;
          10: case RgbHsl2[x, y].H of
              0.. 35: H := 18;
              36.. 71: H := 54;
              72..107: H := 90;
              108..143: H := 126;
              144..179: H := 162;
              180..215: H := 198;
              216..251: H := 234;
              252..287: H := 270;
              288..323: H := 306;
              324..359: H := 342;
            end;
          12: case RgbHsl2[x, y].H of
              0.. 29: H := 15;
              30.. 59: H := 45;
              60.. 89: H := 75;
              90..119: H := 105;
              120..149: H := 135;
              150..179: H := 165;
              180..209: H := 195;
              210..239: H := 225;
              240..269: H := 255;
              270..299: H := 285;
              300..329: H := 315;
              330..359: H := 345;
            end;
          24: case RgbHsl2[x, y].H of
              0.. 14: H := 7;
              15.. 29: H := 22;
              30.. 44: H := 37;
              45.. 59: H := 52;
              60.. 74: H := 67;
              75.. 89: H := 82;
              90..104: H := 97;
              105..119: H := 112;
              120..134: H := 127;
              135..149: H := 142;
              150..164: H := 157;
              165..179: H := 172;
              180..194: H := 187;
              195..209: H := 202;
              210..224: H := 217;
              225..239: H := 232;
              240..254: H := 247;
              255..269: H := 262;
              270..284: H := 277;
              285..299: H := 292;
              300..314: H := 307;
              315..329: H := 322;
              330..344: H := 337;
              345..359: H := 352;
            end;
          36: case RgbHsl2[x, y].H of
              0..  9: H := 5;
              10.. 19: H := 15;
              20.. 29: H := 25;
              30.. 39: H := 35;
              40.. 49: H := 45;
              50.. 59: H := 55;
              60.. 69: H := 65;
              70.. 79: H := 75;
              80.. 89: H := 85;
              90.. 99: H := 95;
              100..109: H := 105;
              110..119: H := 115;
              120..129: H := 125;
              130..139: H := 135;
              140..149: H := 145;
              150..159: H := 155;
              160..169: H := 165;
              170..179: H := 175;
              180..189: H := 185;
              190..199: H := 195;
              200..209: H := 205;
              210..219: H := 215;
              220..229: H := 225;
              230..239: H := 235;
              240..249: H := 245;
              250..259: H := 255;
              260..269: H := 265;
              270..279: H := 275;
              280..289: H := 285;
              290..299: H := 295;
              300..309: H := 305;
              310..319: H := 315;
              320..329: H := 325;
              330..339: H := 335;
              340..349: H := 345;
              350..359: H := 355;
            end;
          72: case RgbHsl2[x, y].H of
              0..  4: H := 2;
              5..  9: H := 7;
              10.. 14: H := 12;
              15.. 19: H := 17;
              20.. 24: H := 22;
              25.. 29: H := 27;
              30.. 34: H := 32;
              35.. 39: H := 37;
              40.. 44: H := 42;
              45.. 49: H := 47;
              50.. 54: H := 52;
              55.. 59: H := 57;
              60.. 64: H := 62;
              65.. 69: H := 67;
              70.. 74: H := 72;
              75.. 79: H := 77;
              80.. 84: H := 82;
              85.. 89: H := 87;
              90.. 94: H := 92;
              95.. 99: H := 97;
              100..104: H := 102;
              105..109: H := 107;
              110..114: H := 112;
              115..119: H := 117;
              120..124: H := 122;
              125..129: H := 127;
              130..134: H := 132;
              135..139: H := 137;
              140..144: H := 142;
              145..149: H := 157;
              150..154: H := 152;
              155..159: H := 157;
              160..164: H := 162;
              165..169: H := 167;
              170..174: H := 172;
              175..179: H := 177;
              180..184: H := 182;
              185..189: H := 187;
              190..194: H := 192;
              195..199: H := 197;
              200..204: H := 202;
              205..209: H := 207;
              210..214: H := 212;
              215..219: H := 217;
              220..224: H := 222;
              225..229: H := 227;
              230..234: H := 232;
              235..239: H := 237;
              240..244: H := 242;
              245..249: H := 247;
              250..254: H := 252;
              255..259: H := 257;
              260..264: H := 262;
              265..269: H := 267;
              270..274: H := 272;
              275..279: H := 277;
              280..284: H := 282;
              285..289: H := 287;
              290..294: H := 292;
              295..299: H := 297;
              300..304: H := 302;
              305..309: H := 307;
              310..314: H := 312;
              315..319: H := 317;
              320..324: H := 322;
              325..329: H := 327;
              330..334: H := 332;
              335..339: H := 337;
              340..344: H := 342;
              345..349: H := 347;
              350..354: H := 322;
              355..359: H := 357;
            end;
          //8b
          88: case RgbHsl2[x, y].H of
              0.. 15: H := 0;  //Rouge
              16.. 45: H := 30; //Orange
              46..70: H := 58; //Jaune
              71..150: H := 110;//Vert
              151..190: H := 170;//Bleu clair
              191..260: H := 225;//Bleu foncé
              261..345: H := 303;//Violet
              346..360: H := 0;  //Rouge
            end;
        end;
        HSLtoRGB_H360_S100_L100_RGB255(H, RgbHsl2[x, y].S, RgbHsl2[x, y].L, Rb, Gb, Bb);
        //RGB3
        RgbHsl3[x, y].Cl := RGBToColor(Rb, Gb, Bb);
        RgbHsl3[x, y].R := Rb;
        RgbHsl3[x, y].G := Gb;
        RgbHsl3[x, y].B := Bb;
        //HSL3 : Récupération de H,S,L
        RGBtoHSL_RGB255_H360_S100_L100(Rb, Gb, Bb, RgbHsl3[x, y].H, RgbHsl3[x, y].S,
          RgbHsl3[x, y].L);
        //Pixels[x,y]:=RGB3[x,y];
      end;
      Application.ProcessMessages;
    end;
    //Mise à jour RGB3 vers Img1
    RGB_vers_Img(3, MaxImgX, MaxImgY);
    WdWait.Visible := False;
  end;
  Loader(True);
end;

procedure S_HSL_nCubes_Old(Select: integer);
var
  MaxImgX, MaxImgY: integer;
  S, x, y: integer;
  Rb, Gb, Bb: byte;
begin
  Loader(False);
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    Wait_Init;
    WdWait.Visible := True;
    Rb := 0;
    Gb := 0;
    Bb := 0;
    for y := 0 to MaxImgY - 1 do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX - 1 do
      begin
        S := 0;
        case Select of
          2: case RgbHsl2[x, y].S of
              0..49: S := 25;
              50..100: S := 75;
            end;
          4: case RgbHsl2[x, y].S of
              0.. 24: S := 12;
              25..49: S := 37;
              50..74: S := 62;
              75..100: S := 87;
            end;
          5: case RgbHsl2[x, y].S of
              0.. 19: S := 10;
              20..39: S := 30;
              40..59: S := 50;
              60..79: S := 70;
              80..100: S := 90;
            end;
          10: case RgbHsl2[x, y].S of
              0.. 9: S := 5;
              10..19: S := 15;
              20..29: S := 25;
              30..39: S := 35;
              40..49: S := 45;
              50..59: S := 55;
              60..69: S := 65;
              70..79: S := 75;
              80..89: S := 85;
              90..100: S := 95;
            end;
          20: case RgbHsl2[x, y].S of
              0.. 4: S := 2;
              5.. 9: S := 7;
              10..14: S := 12;
              15..19: S := 17;
              20..24: S := 22;
              25..29: S := 27;
              30..34: S := 32;
              35..39: S := 37;
              40..44: S := 42;
              45..49: S := 47;
              50..54: S := 52;
              55..59: S := 57;
              60..64: S := 62;
              65..69: S := 67;
              70..74: S := 72;
              75..79: S := 77;
              80..84: S := 82;
              85..89: S := 87;
              90..94: S := 92;
              95..100: S := 97;
            end;
          25: case RgbHsl2[x, y].S of
              0..2: S := 1;
              3..5: S := 4;
              6..8: S := 7;
              9..11: S := 10;
              12..14: S := 13;
              15..17: S := 16;
              18..20: S := 19;
              21..23: S := 22;
              24..26: S := 25;
              27..29: S := 28;
              30..32: S := 31;
              33..35: S := 34;
              36..38: S := 37;
              39..41: S := 40;
              42..44: S := 43;
              45..47: S := 46;
              48..50: S := 49;
              51..53: S := 52;
              54..56: S := 55;
              57..59: S := 58;
              60..62: S := 61;
              63..65: S := 64;
              66..68: S := 67;
              69..71: S := 70;
              72..74: S := 73;
              75..77: S := 76;
              78..80: S := 79;
              81..83: S := 82;
              84..86: S := 85;
              87..89: S := 88;
              90..92: S := 91;
              93..95: S := 94;
              96..98: S := 97;
              99..100: S := 100;
            end;
        end;
        HSLtoRGB_H360_S100_L100_RGB255(RgbHsl2[x, y].H, S, RgbHsl2[x, y].L, Rb, Gb, Bb);
        //RGB3
        RgbHsl3[x, y].CL := RGBToColor(Rb, Gb, Bb);
        RgbHsl3[x, y].R := Rb;
        RgbHsl3[x, y].G := Gb;
        RgbHsl3[x, y].B := Bb;
        //HSL3
        RGBtoHSL_RGB255_H360_S100_L100(Rb, Gb, Bb, RgbHsl3[x, y].H, RgbHsl3[x, y].S,
          RgbHsl3[x, y].L);
      end;
      Application.ProcessMessages;
    end;
    //Mise à jour RGB3 vers Img1
    RGB_vers_Img(3, MaxImgX, MaxImgY);
    Wait_Close;
  end;
  Loader(True);
end;

procedure S_HSL_nCubes(Select: integer);
var
  MaxImgX, MaxImgY: integer;
  S, x, y: integer;
  Rb, Gb, Bb: byte;
begin
  Loader(False);
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    Wait_Init;
    WdWait.Visible := True;
    Rb := 0;
    Gb := 0;
    Bb := 0;
    for y := 0 to MaxImgY - 1 do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX - 1 do
      begin
        S := 0;
        case Select of
          2: case RgbHsl2[x, y].S of
              0..49: S := 25;
              50..100: S := 75;
            end;
          4: case RgbHsl2[x, y].S of
              0.. 24: S := 12;
              25..49: S := 37;
              50..74: S := 62;
              75..100: S := 87;
            end;
          5: case RgbHsl2[x, y].S of
              0.. 19: S := 10;
              20..39: S := 30;
              40..59: S := 50;
              60..79: S := 70;
              80..100: S := 90;
            end;
          10: case RgbHsl2[x, y].S of
              0.. 9: S := 5;
              10..19: S := 15;
              20..29: S := 25;
              30..39: S := 35;
              40..49: S := 45;
              50..59: S := 55;
              60..69: S := 65;
              70..79: S := 75;
              80..89: S := 85;
              90..100: S := 95;
            end;
          20: case RgbHsl2[x, y].S of
              0.. 4: S := 2;
              5.. 9: S := 7;
              10..14: S := 12;
              15..19: S := 17;
              20..24: S := 22;
              25..29: S := 27;
              30..34: S := 32;
              35..39: S := 37;
              40..44: S := 42;
              45..49: S := 47;
              50..54: S := 52;
              55..59: S := 57;
              60..64: S := 62;
              65..69: S := 67;
              70..74: S := 72;
              75..79: S := 77;
              80..84: S := 82;
              85..89: S := 87;
              90..94: S := 92;
              95..100: S := 97;
            end;
          25: case RgbHsl2[x, y].S of
              0..2: S := 1;
              3..5: S := 4;
              6..8: S := 7;
              9..11: S := 10;
              12..14: S := 13;
              15..17: S := 16;
              18..20: S := 19;
              21..23: S := 22;
              24..26: S := 25;
              27..29: S := 28;
              30..32: S := 31;
              33..35: S := 34;
              36..38: S := 37;
              39..41: S := 40;
              42..44: S := 43;
              45..47: S := 46;
              48..50: S := 49;
              51..53: S := 52;
              54..56: S := 55;
              57..59: S := 58;
              60..62: S := 61;
              63..65: S := 64;
              66..68: S := 67;
              69..71: S := 70;
              72..74: S := 73;
              75..77: S := 76;
              78..80: S := 79;
              81..83: S := 82;
              84..86: S := 85;
              87..89: S := 88;
              90..92: S := 91;
              93..95: S := 94;
              96..98: S := 97;
              99..100: S := 100;
            end;
        end;
        HSLtoRGB_H360_S100_L100_RGB255(RgbHsl2[x, y].H, S, RgbHsl2[x, y].L, Rb, Gb, Bb);
        //RGB3
        RgbHsl3[x, y].Cl := RGBToColor(Rb, Gb, Bb);
        RgbHsl3[x, y].R := Rb;
        RgbHsl3[x, y].G := Gb;
        RgbHsl3[x, y].B := Bb;
        //HSL3
        RGBtoHSL_RGB255_H360_S100_L100(Rb, Gb, Bb, RgbHsl3[x, y].H, RgbHsl3[x, y].S,
          RgbHsl3[x, y].L);
      end;
      Application.ProcessMessages;
    end;
    //RGB3 vers Img1;
    RGB_vers_Img(3, MaxImgX, MaxImgY);
    Wait_Close;
  end;
  Loader(True);
end;

procedure L_HSL_nCubes(Select: integer);
var
  MaxImgX, MaxImgY: integer;
  L, x, y: integer;
  Rb, Gb, Bb: byte;
begin
  Loader(False);
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    Wait_Init;
    WdWait.Visible := True;
    Rb := 0;
    Gb := 0;
    Bb := 0;
    for y := 0 to MaxImgY - 1 do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX - 1 do
      begin
        L := 0;
        case Select of
          2: case RgbHsl2[x, y].L of
              0..49: L := 25;
              50..100: L := 75;
            end;
          4: case RgbHsl2[x, y].L of
              0.. 24: L := 12;
              25..49: L := 37;
              50..74: L := 62;
              75..100: L := 87;
            end;
          5: case RgbHsl2[x, y].L of
              0.. 19: L := 10;
              20..39: L := 30;
              40..59: L := 50;
              60..79: L := 70;
              80..100: L := 90;
            end;
          10: case RgbHsl2[x, y].L of
              0.. 9: L := 5;
              10..19: L := 15;
              20..29: L := 25;
              30..39: L := 35;
              40..49: L := 45;
              50..59: L := 55;
              60..69: L := 65;
              70..79: L := 75;
              80..89: L := 85;
              90..100: L := 95;
            end;
          20: case RgbHsl2[x, y].L of
              0.. 4: L := 2;
              5.. 9: L := 7;
              10..14: L := 12;
              15..19: L := 17;
              20..24: L := 22;
              25..29: L := 27;
              30..34: L := 32;
              35..39: L := 37;
              40..44: L := 42;
              45..49: L := 47;
              50..54: L := 52;
              55..59: L := 57;
              60..64: L := 62;
              65..69: L := 67;
              70..74: L := 72;
              75..79: L := 77;
              80..84: L := 82;
              85..89: L := 87;
              90..94: L := 92;
              95..100: L := 97;
            end;
          34: case RgbHsl2[x, y].L of
              0.. 2: L := 1;
              3.. 5: L := 4;
              6.. 8: L := 7;
              9..11: L := 10;
              12..14: L := 13;
              15..17: L := 16;
              18..20: L := 19;
              21..23: L := 22;
              24..26: L := 25;
              27..28: L := 28;
              30..32: L := 31;
              33..35: L := 34;
              36..38: L := 37;
              39..41: L := 40;
              42..44: L := 43;
              45..47: L := 46;
              48..50: L := 49;
              51..53: L := 52;
              54..56: L := 55;
              57..59: L := 58;
              60..62: L := 61;
              63..65: L := 64;
              66..68: L := 67;
              69..71: L := 70;
              72..74: L := 73;
              75..77: L := 76;
              78..80: L := 79;
              81..83: L := 82;
              84..86: L := 85;
              87..89: L := 88;
              90..92: L := 91;
              93..95: L := 94;
              96..98: L := 97;
              99..100: L := 100;
            end;
        end;
        HSLtoRGB_H360_S100_L100_RGB255(RgbHsl2[x, y].H, RgbHsl2[x, y].S, L, Rb, Gb, Bb);
        //RGB3
        RgbHsl3[x, y].Cl := RGBToColor(Rb, Gb, Bb);
        RgbHsl3[x, y].R := Rb;
        RgbHsl3[x, y].G := Gb;
        RgbHsl3[x, y].B := Bb;
        //HSL3 : Récupération de H,S,L
        RGBtoHSL_RGB255_H360_S100_L100(Rb, Gb, Bb, RgbHsl3[x, y].H, RgbHsl3[x, y].S,
          RgbHsl3[x, y].L);
      end;
      Application.ProcessMessages;
    end;
    //RGB3 vers Img1
    RGB_vers_Img(3, MaxImgX, MaxImgY);
    Wait_Close;
  end;
  WdWait.Visible := False;
  Loader(True);
end;

procedure Effet_S(Select: integer);
var
  MaxImgX, MaxImgY: integer;
  H, S, L, x, y: integer;
  Rb, Bb, Gb: byte;
begin
  Loader(False);
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    Wait_Init;
    WdWait.Visible := True;
    H := 0;
    S := 0;
    L := 0;
    Rb := 0;
    Gb := 0;
    Bb := 0;
    for y := 0 to MaxImgY - 1 do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX - 1 do
      begin
        case Select of
          //Noir et blanc HSL
          1:
          begin
            S := 0;
            HSLtoRGB_H360_S100_L100_RGB255(RgbHsl2[x, y].H, S,
              RgbHsl2[x, y].L, Rb, Gb, Bb);
          end;
          2:
          begin
            Rb := Round(Yuv_Y(RgbHsl2[x, y].R, RgbHsl2[x, y].G, RgbHsl2[x, y].B));
            Gb := Rb;
            Bb := Rb;
          end;
        end;
        //RGB3
        RgbHsl3[x, y].Cl := RGBToColor(Rb, Gb, Bb);
        RgbHsl3[x, y].R := Rb;
        RgbHsl3[x, y].G := Gb;
        RgbHsl3[x, y].B := Bb;
        //Récupération de H,S,L
        RGBtoHSL_RGB255_H360_S100_L100(Rb, Gb, Bb, H, S, L);
        //HSL
        RgbHsl3[x, y].H := H;
        RgbHsl3[x, y].S := S;
        RgbHsl3[x, y].L := L;
      end;
      Application.ProcessMessages;
    end;
    //Mise à jour RGB3 vers Img1
    RGB_vers_Img(3, MaxImgX, MaxImgY);
    Wait_Close;
  end;
  Loader(True);
end;

procedure Traitements(Select: integer);
var
  MaxImgX, MaxImgY: integer;
  x, y: integer;
  R3, G3, B3: byte;
begin
  Loader(False);
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    Wait_Init;
    WdWait.Visible := True;
    for y := 0 to MaxImgY - 1 do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX - 1 do
      begin
        case Select of
          //Négatif RGB
          1:
          begin
            //RGB3
            R3 := 255 - RgbHsl2[x, y].R;
            G3 := 255 - RgbHsl2[x, y].G;
            B3 := 255 - RgbHsl2[x, y].B;
          end;
          //Noir et Blanc RGB
          2:
          begin
            //----- RGBToGray : Y=0.299*R + 0.587*G + 0.114*B -----
            R3 := Round(RGBToGray(RgbHsl2[x, y].R, RgbHsl2[x, y].G, RgbHsl2[x, y].B));
            G3 := R3;
            B3 := R3;
          end;
          //Gamma
          3:
          begin
            R3 := Correction_Gamma_3(RgbHsl2[x, y].R, 0.8);
            G3 := Correction_Gamma_3(RgbHsl2[x, y].G, 0.8);
            B3 := Correction_Gamma_3(RgbHsl2[x, y].B, 0.8);
          end;
          //Eclaircissement
          4:
          begin
            R3 := Round(255 * Sqrt(RgbHsl2[x, y].R / 255));
            G3 := Round(255 * Sqrt(RgbHsl2[x, y].G / 255));
            B3 := Round(255 * Sqrt(RgbHsl2[x, y].B / 255));
          end;
          //Assombrissement
          5:
          begin
            R3 := Round(255 * Sqr(RgbHsl2[x, y].R / 255));
            G3 := Round(255 * Sqr(RgbHsl2[x, y].G / 255));
            B3 := Round(255 * Sqr(RgbHsl2[x, y].B / 255));
          end;
          //Contraste +
          6:
          begin
            R3 := Round(255 * (0.5 + 0.5 * (Sin((RgbHsl2[x, y].R / 255 - 0.5) * Pi))));
            G3 := Round(255 * (0.5 + 0.5 * (Sin((RgbHsl2[x, y].G / 255 - 0.5) * Pi))));
            B3 := Round(255 * (0.5 + 0.5 * (Sin((RgbHsl2[x, y].B / 255 - 0.5) * Pi))));
          end;
          //Contraste -
          7:
          begin
            R3 := Round(255 * (0.5 + (1 / Pi) * (ArcSin((2 * RgbHsl2[x, y].R / 255) - 1))));
            G3 := Round(255 * (0.5 + (1 / Pi) * (ArcSin((2 * RgbHsl2[x, y].G / 255) - 1))));
            B3 := Round(255 * (0.5 + (1 / Pi) * (ArcSin((2 * RgbHsl2[x, y].B / 255) - 1))));
          end;
        end;
        //Seuil
        if R3 > 255 then
          R3 := 255;
        if R3 < 0 then
          R3 := 0;
        if G3 > 255 then
          G3 := 255;
        if G3 < 0 then
          G3 := 0;
        if B3 > 255 then
          B3 := 255;
        if B3 < 0 then
          B3 := 0;
        //RGB3
        RgbHsl3[x, y].Cl := RGBToColor(R3, G3, B3);
        RgbHsl3[x, y].R := R3;
        RgbHsl3[x, y].G := G3;
        RgbHsl3[x, y].G := B3;
        //HSL3
        RGBtoHSL_RGB255_H360_S100_L100(R3, G3, B3, RgbHsl3[x, y].H, RgbHsl3[x, y].S,
          RgbHsl3[x, y].L);
      end;
      Application.ProcessMessages;
    end;
    //Mise à jour RGB3 vers Img1
    RGB_vers_Img(3, MaxImgX, MaxImgY);
    Wait_Close;
  end;
  Loader(True);
end;

procedure Gamma_var(Gamma: real);
var
  MaxImgX, MaxImgY: integer;
  x, y: integer;
  R3, G3, B3: byte;
begin
  Loader(False);
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    Wait_Init;
    WdWait.Visible := True;
    for y := 0 to MaxImgY - 1 do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX - 1 do
      begin
        R3 := Correction_Gamma_3(RgbHsl2[x, y].R, Gamma);
        G3 := Correction_Gamma_3(RgbHsl2[x, y].G, Gamma);
        B3 := Correction_Gamma_3(RgbHsl2[x, y].B, Gamma);
        //RGB3
        RgbHsl3[x, y].Cl := RGBToColor(R3, G3, B3);
        RgbHsl3[x, y].R := R3;
        RgbHsl3[x, y].G := G3;
        RgbHsl3[x, y].B := B3;
        //HSL3 : Récupérayion de H,S,L
        RGBtoHSL_RGB255_H360_S100_L100(R3, G3, B3, RgbHsl3[x, y].H, RgbHsl3[x, y].S,
          RgbHsl3[x, y].L);
      end;
      Application.ProcessMessages;
    end;
    //Mise à jour RGB3 vers Img1
    RGB_vers_Img(3, MaxImgX, MaxImgY);
    Wait_Close;
  end;
  Loader(True);
end;

procedure RGB_vers_R_G_B(Select: integer);
var
  MaxImgX, MaxImgY: integer;
  x, y: integer;
begin
  Loader(False);
  with WdMain do
  begin
    MaxImgX := Img1.Width;
    MaxImgY := Img1.Height;
    //-
    Wait_Init;
    WdWait.Visible := True;
    //-
    //Data2_vers_Data_3;
    for y := 0 to MaxImgY - 1 do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX - 1 do
      begin
        case Select of
          //Red uniquement
          1:
          begin
            RgbHsl3[x, y].R := RgbHsl2[x, y].R;
            RgbHsl3[x, y].G := 0;
            RgbHsl3[x, y].B := 0;
            RgbHsl3[x, y].Cl := RGBToColor(RgbHsl3[x, y].R, 0, 0);
          end;
          //Vert uniquement
          2:
          begin
            RgbHsl3[x, y].R := 0;
            RgbHsl3[x, y].G := RgbHsl2[x, y].G;
            RgbHsl3[x, y].B := 0;
            RgbHsl3[x, y].Cl := RGBToColor(0, RgbHsl3[x, y].G, 0);
          end;
          //Blue uniquement
          3:
          begin
            RgbHsl3[x, y].R := 0;
            RgbHsl3[x, y].G := 0;
            RgbHsl3[x, y].B := RgbHsl2[x, y].B;
            RgbHsl3[x, y].Cl := RGBToColor(0, 0, RgbHsl3[x, y].B);
          end;
          //Rouge et Vert
          4:
          begin
            RgbHsl3[x, y].R := RgbHsl2[x, y].R;
            RgbHsl3[x, y].G := RgbHsl2[x, y].G;
            RgbHsl3[x, y].B := 0;
            RgbHsl3[x, y].Cl := RGBToColor(RgbHsl2[x, y].R, RgbHsl2[x, y].G, 0);
          end;
          //Rouge et Bleu
          5:
          begin
            RgbHsl3[x, y].R := RgbHsl2[x, y].R;
            RgbHsl3[x, y].G := 0;
            RgbHsl3[x, y].B := RgbHsl2[x, y].B;
            RgbHsl3[x, y].Cl := RGBToColor(RgbHsl2[x, y].R, 0, RgbHsl2[x, y].B);
          end;
          //vert et Bleu
          6:
          begin
            RgbHsl3[x, y].R := 0;
            RgbHsl3[x, y].G := RgbHsl2[x, y].G;
            RgbHsl3[x, y].B := RgbHsl2[x, y].B;
            RgbHsl3[x, y].Cl := RGBToColor(0, RgbHsl2[x, y].G, RgbHsl2[x, y].B);
          end;
        end;
        //HSL3
        RGBtoHSL_RGB255_H360_S100_L100(RgbHsl3[x, y].R, RgbHsl3[x, y].G,
          RgbHsl3[x, y].B, RgbHsl3[x, y].H,
          RgbHsl3[x, y].S, RgbHsl3[x, y].L);
      end;
      Application.ProcessMessages;
    end;
    //Mise à jour RGB3 vers Img1
    RGB_vers_Img(3, MaxImgX, MaxImgY);
    Wait_Close;
  end;
  Loader(True);
end;

procedure HSL_Total(Select: integer);
var
  CoefXH: real;
  CoefXH60: real;
  CoefXS, CoefXL: real;
  CoefYS, CoefYL: real;
  H, S, L: real;
  MaxImgX, MaxImgY: integer;
  x, y: integer;
  Rb, Bb, Gb: byte;
begin
  with WdMain do
  begin
    MaxImgX := Img1.Width - 1;
    MaxImgY := Img1.Height - 1;
    CoefXH := 360 / MaxImgX;
    CoefXH60 := 60 / MaxImgX;
    CoefXS := 100 / MaxImgX;
    CoefYS := 100 / MaxImgY;
    CoefXL := 100 / MaxImgX;
    CoefYL := 100 / MaxImgY;
    case Select of
      //Dégradé H
      1:
      begin
        S := 100;
        L := 50;
      end;
      //Dégradé S
      2:
      begin
        H := 156;
        S := 100;
        L := 50;
      end;
      //Dégradé L
      3:
      begin
        H := 156;
        S := 100;
        L := 100;
      end;
      //H et S - Teinte et saturation
      4:
      begin
        S := 100;
        L := 50;
      end;
      //H et L - Teinte et luminosité
      5:
      begin
        S := 100;
        L := 100;
      end;
      //Dégradé S et L
      6:
      begin
        H := 156;
        S := 100;
        L := 100;
      end;
      // 7:Dégradé 0..60 - Rouge -> Jaune
      // 8:Dégradé 60..120 - Vert clair -> Vert foncé
      // 9:Dégradé 120..180 - Vert foncé -> Bleu clair
      //10:Dégradé 180..240 - Bleu clair -> Bleu foncé
      //11:Dégradé 240..300 - Bleu foncé -> Violet
      //12:Dégradé 300..360 - Violet -> Rouge
      7..12:
      begin
        H := 0;
        S := 50;
        L := 50;
      end;
    end;
    Rb := 0;
    Gb := 0;
    Bb := 0;
    for y := 0 to MaxImgY - 1 do
    begin
      case Select of
        //H
        1: H := 0;
        //S
        2: S := 100;
        //L
        3: L := 100;
        //HS
        4: H := 0;
        //HL
        5: H := 0;
        //SL
        6: L := 100;
        //H60
        7: H := 0;
        8: H := 60;
        9: H := 120;
        10: H := 180;
        11: H := 240;
        12: H := 300;
      end;
      for x := 0 to MaxImgX - 1 do
      begin
        HSLtoRGB_H360_S100_L100_RGB255(Round(H), Round(S), Round(L), Rb, Gb, Bb);
        //RGB3
        RgbHsl3[x, y].Cl := RGBToColor(Rb, Gb, Bb);
        RgbHsl3[x, y].R := Rb;
        RgbHsl3[x, y].G := Gb;
        RgbHsl3[x, y].B := Bb;
        //HSL3
        RgbHsl3[x, y].H := Round(H);
        RgbHsl3[x, y].S := Round(S);
        RgbHsl3[x, y].L := Round(L);
        //Axe x
        case Select of
          //H
          1: H := H + CoefXH;
          //S
          2:
          begin
            S := S - CoefXS;
          end;
          3: L := L - CoefXL;
          //HS
          4: H := H + CoefXH;
          //HL
          5: H := H + CoefXH;
          //SL
          6:
          begin
            L := L - CoefXL;
          end;
          7..12:
          begin
            H := H + CoefXH60;
          end;
        end;
      end;
      //Axe y
      case Select of
        //H
        1:
        begin
        end;
        2:
        begin
        end;
        3:
        begin
        end;
        //HS
        4: S := S - CoefYS;
        //HL
        5: L := L - CoefYL;
        //SL
        6:
        begin
          S := S - CoefYS;
        end;
        //H60
        7..12:
        begin

        end;
      end;
      Application.ProcessMessages;
    end;
    //Mise à jour RGB3 vers Img1
    RGB_vers_Img(3, MaxImgX, MaxImgY);
  end;
end;

procedure Genere_Couleurs(Select: integer);
var
  CoefH, CoefSL: real;
  H, S, L: real;
  MaxImgX, MaxImgY: integer;
  x, y: integer;
  Rb, Bb, Gb: byte;
begin
  with WdMain do
  begin
    MaxImgX := Img1.Width - 1;
    MaxImgY := Img1.Height;
    CoefH := 59 / MaxImgX;
    CoefSL := 100 / (MaxImgY - 1);
    //-
    H := 0;
    S := 100;
    L := 100;
    Rb := 0;
    Gb := 0;
    Bb := 0;
    for y := 0 to MaxImgY - 1 do
    begin
      case Select of
        //H et L - Rouge -> Jaune
        1: H := 0;
        //H et L - Jaune -> Vert
        2: H := 60;
        //H et L - Vert -> Bleu
        3: H := 120;
        //H et L - Bleu clair -> Bleu foncé
        4: H := 180;
        //H et L - Bleu foncé - Violet
        5: H := 240;
        //H et L - Violet -> Rouge
        6: H := 300;
      end;
      for x := 0 to MaxImgX - 1 do
      begin
        HSLtoRGB_H360_S100_L100_RGB255(Round(H), Round(S), Round(L), Rb, Gb, Bb);
        //HSL3
        RgbHsl3[x, y].H := Round(H);
        RgbHsl3[x, y].S := Round(S);
        RgbHsl3[x, y].L := Round(L);
        //RGB3
        RgbHsl3[x, y].Cl := RGBToColor(Rb, Gb, Bb);
        RgbHsl3[x, y].R := Rb;
        RgbHsl3[x, y].G := Gb;
        RgbHsl3[x, y].B := Bb;
        H := H + CoefH;
      end;
      L := L - CoefSL;
      Application.ProcessMessages;
    end;
    //Mise à jour RGB3 vers Img1
    RGB_vers_Img(3, MaxImgX, MaxImgY);
  end;
end;

procedure Diagramme_de_chromaticite(Select: integer);
var
  X, Y, Z, Kdc: real;
  MaxImgX, MaxImgY: integer;
  xi, yi, n, xd, yd: integer;
  Kfr: integer;
  Rb, Gb, Bb: byte;
begin
  Loader(False);
  with WdMain do
  begin
    MaxImgX := Img1.Width - 1;
    MaxImgY := Img1.Height - 1;
    Wait_Init;
    WdWait.Visible := True;
    //Copie Img1 vers ImgBmp
    ImgBmp_Creation(MaxImgX, MaxImgY);
    Img_vers_ImgBmp;
    with ImgBmp.Canvas do
    begin
      //Efface
      Pen.Color := ClWhite;
      for xi := 0 to MaxImgX - 1 do
        Line(xi, 0, xi, MaxImgY - 1);
      Pen.Color := ClBlack;
      //Courbe des longueurs d'onde
      case Select of
        1: TextOut(550, 20, 'CIE 1931');
        2: TextOut(550, 20, 'CIE sRGB D50 ');
        3: TextOut(550, 20, 'CIE sRGB D65');
      end;
      Kfr := 750;
      for n := 1 to 36 do
      begin
        xd := Round(DiagChroma_[n, 1] * Kfr) + 40;
        yd := MaxImgY - (Round(DiagChroma_[n, 2] * Kfr)) - 10;
        Rectangle(xd - 2, yd - 2, xd + 2, yd + 2);
      end;
      //Diagramme des couleurs
      Gb := 0;
      Kdc := 1.14;
      Stop := False;
      repeat
        Wait_Aff(1, 255, Gb);
        for Bb := 0 to 255 do
        begin
          for Rb := 0 to 255 do
          begin
            case Select of
              //CIE 1931
              1: Matrice_CIE_XYZ_1931_RgbToXyz(Rb, Gb, Bb, X, Y, Z);
              //sRGB D50
              2: Matrice_sRGB_RGB_XYZ_D50_RgbToXyz(Rb, Gb, Bb, X, Y, Z);
              //sRGB D65
              3: Matrice_sRGB_RGB_XYZ_D65_RgbToXyz(Rb, Gb, Bb, X, Y, Z);
            end;
            xi := Round(XYZ_xyz_Plan_x(X, Y, Z) * MaxImgX * Kdc) - 32;
            yi := Round(XYZ_xyz_Plan_y(X, Y, Z) * MaxImgY * Kdc) - 70;
            Pixels[xi + 80, MaxImgY - yi - 80] := RGBToColor(Rb, Gb, Bb);
          end;
        end;
        if Gb = 255 then
          Stop := True
        else
          Inc(Gb);
        Application.ProcessMessages;
      until Stop;
    end;
    ImgBmp_vers_Img;
    ImgBmp_Close;
    Wait_Close;
  end;
  Loader(True);
end;

procedure Matrice_Test(Select: integer);
var
  s: string;
begin
  with WdMain do
  begin
    case Select of
      1: s := EdC11.Text;
      2: s := EdC21.Text;
      3: s := EdC31.Text;
      4: s := EdC41.Text;
      5: s := EdC51.Text;
      6: s := EdC12.Text;
      7: s := EdC22.Text;
      8: s := EdC32.Text;
      9: s := EdC42.Text;
      10: s := EdC52.Text;
      11: s := EdC13.Text;
      12: s := EdC23.Text;
      13: s := EdC33.Text;
      14: s := EdC43.Text;
      15: s := EdC53.Text;
      16: s := EdC14.Text;
      17: s := EdC24.Text;
      18: s := EdC34.Text;
      19: s := EDC44.Text;
      20: s := EdC54.Text;
      21: s := EdC15.Text;
      22: s := EdC25.Text;
      23: s := EdC35.Text;
      24: s := EdC45.Text;
      25: s := EDC55.Text;
    end;
    if not if_Integer_PN(s) then
    begin
      case Select of
        1: EdC11.Text := '0';
        2: EdC21.Text := '0';
        3: EdC31.Text := '0';
        4: EdC41.Text := '0';
        5: EdC51.Text := '0';
        6: EdC12.Text := '0';
        7: EdC22.Text := '0';
        8: EdC32.Text := '0';
        9: EdC42.Text := '0';
        10: EdC52.Text := '0';
        11: EdC13.Text := '0';
        12: EdC23.Text := '0';
        13: EdC33.Text := '0';
        14: EdC43.Text := '0';
        15: EdC53.Text := '0';
        16: EdC14.Text := '0';
        17: EdC24.Text := '0';
        18: EdC34.Text := '0';
        19: EDC44.Text := '0';
        20: EdC54.Text := '0';
        21: EdC15.Text := '0';
        22: EdC25.Text := '0';
        23: EdC35.Text := '0';
        24: EdC45.Text := '0';
        25: EDC55.Text := '0';
      end;
    end;
  end;
end;

procedure Matrices_Var(Sens: integer);
var
  s: string;
  n: integer;
begin
  with WdMain do
  begin
    n := 0;
    case MT_Focus of
      1: n := StrToInt(EdC11.Text);
      2: n := StrToInt(EdC21.Text);
      3: n := StrToInt(EdC31.Text);
      4: n := StrToInt(EdC41.Text);
      5: n := StrToInt(EdC51.Text);
      6: n := StrToInt(EdC12.Text);
      7: n := StrToInt(EdC22.Text);
      8: n := StrToInt(EdC32.Text);
      9: n := StrToInt(EdC42.Text);
      10: n := StrToInt(EdC52.Text);
      11: n := StrToInt(EdC13.Text);
      12: n := StrToInt(EdC23.Text);
      13: n := StrToInt(EdC33.Text);
      14: n := StrToInt(EdC43.Text);
      15: n := StrToInt(EdC53.Text);
      16: n := StrToInt(EdC14.Text);
      17: n := StrToInt(EdC24.Text);
      18: n := StrToInt(EdC34.Text);
      19: n := StrToInt(EDC44.Text);
      20: n := StrToInt(EdC54.Text);
      21: n := StrToInt(EdC15.Text);
      22: n := StrToInt(EdC25.Text);
      23: n := StrToInt(EdC35.Text);
      24: n := StrToInt(EdC45.Text);
      25: n := StrToInt(EDC55.Text);
    end;
    case Sens of
      0: Dec(n);
      1: Inc(n);
    end;
    s := IntToStr(n);
    case MT_Focus of
      1: EdC11.Text := s;
      2: EdC21.Text := s;
      3: EdC31.Text := s;
      4: EdC41.Text := s;
      5: EdC51.Text := s;
      6: EdC12.Text := s;
      7: EdC22.Text := s;
      8: EdC32.Text := s;
      9: EdC42.Text := s;
      10: EdC52.Text := s;
      11: EdC13.Text := s;
      12: EdC23.Text := s;
      13: EdC33.Text := s;
      14: EdC43.Text := s;
      15: EdC53.Text := s;
      16: EdC14.Text := s;
      17: EdC24.Text := s;
      18: EdC34.Text := s;
      19: EDC44.Text := s;
      20: EdC54.Text := s;
      21: EdC15.Text := s;
      22: EdC25.Text := s;
      23: EdC35.Text := s;
      24: EdC45.Text := s;
      25: EDC55.Text := s;
    end;
  end;
end;

procedure Isoles(LaHa: integer);
var
  TabF: TabRec16x16_;
  ColMin, ColMax: int64;
  Ref: TColor;
  MaxImgX, MaxImgY: integer;
  n, p, x, y, Xm, Ym, v: integer;
  Rb, Gb, Bb: byte;
  Ok: boolean;
begin
  with WdMain do
  begin
    MaxImgX := Img1.Width - 1;
    MaxImgY := Img1.Height - 1;
    Wait_Init;
    WdWait.Visible := True;
    DataN_vers_DataN(3);
    //Init.
    //####### 5x5
    //#.....#
    //#.....#
    //#.....#
    //#.....#
    //#.....#
    //#######
    //Traitement image
    for y := 0 to MaxImgY do
    begin
      Wait_Aff(1, MaxImgY, y);
      for x := 0 to MaxImgX do
      begin
        //Clear
        for p := 1 to LaHa do
          for n := 1 to LaHa do
            with TabF[n, p] do
            begin
              Cl := 0;
              Xp := -1;
              Yp := -1;
              Contours := 0;
            end;
        //Récup. fenêtre
        Ym := y;
        for p := 1 to LaHa do
        begin
          if Ym <= MaxImgY then
          begin
            Xm := x;
            for n := 1 to LaHa do
            begin
              if Xm <= MaxImgX then
              begin
                with TabF[n, p] do
                begin
                  Cl := RgbHsl3[Xm, Ym].Cl;
                  Xp := Xm;
                  Yp := Ym;
                  //Contours
                  if p in [1, LaHa] then
                    Contours := 1
                  else
                  if n in [1, LaHa] then
                    Contours := 1;
                  {
                  if (x=371) and (y=0) then begin
                    WdMain.Memo1.Lines.Add(IntToStr(TabF[n, p].Xp)+'/'+
                      IntToStr(TabF[n, p].Yp)+' '+IntToStr(TabF[n, p].Contours)+
                      '  '+IntToStr(TabF[n, p].Cl));
                  end;
                  }
                end;
              end;
              Inc(Xm);
            end;
            Inc(Ym);
          end;
        end;
        //Test si les couleurs du contour sont proches
        Ref := TabF[1, 1].Cl;
        //Noir
        ColMin := Ref - SupIso;
        if ColMin < 0 then
          ColMin := 0;
        //Blanc
        ColMax := Ref + SupIso;
        if ColMax > 16777215 then
          ColMax := 16777215;
        Ok := True;
        p := 1;
        repeat
          n := 1;
          repeat
            with TabF[n, p] do
            begin
              //Ignore les bords...
              if (Xp >= 0) and (Yp >= 0) then
              begin
                if Contours = 1 then
                begin
                  if (TabF[n, p].Cl < ColMin) or (TabF[n, p].Cl > ColMax) then
                    Ok := False;
                end;
              end;
            end;
            Inc(n);
          until (not Ok) or (n > Laha);
          Inc(p);
        until (not Ok) or (p > LaHa);
        //Les couleurs du contour sont identiques
        if Ok then
        begin
          //Mettre toutes les couleurs à la couleur du contour
          v := 0;
          for p := 1 to LaHa do
          begin
            for n := 1 to LaHa do
            begin
              with TabF[n, p] do
              begin
                if (Yp >= 0) and (Yp <= MaxImgY) then
                begin
                  if (Xp >= 0) and (Xp <= MaxImgX) then
                  begin
                    Inc(v);
                    RgbHsl3[Xp, Yp].Cl := Ref;
                    RedGreenBlue(RgbHsl3[Xp, Yp].Cl, Rb, Gb, Bb);
                    RgbHsl3[Xp, Yp].R := Rb;
                    RgbHsl3[Xp, Yp].G := Gb;
                    RgbHsl3[Xp, Yp].B := Bb;
                  end;
                end;
              end;
            end;
          end;
          {
          if (x=371) and (y=0) then begin
           WdMain.Memo1.Lines.Add(IntToStr(v));
          end;
          }
        end;
      end;
      Application.ProcessMessages;
    end;
  end;
  //Mise à jour RGB3 vers Img1
  RGB_vers_Img(3, MaxImgX, MaxImgY);
  Wait_Close;
end;

procedure Nuancier_10x18;
var
  MaxImgX, MaxImgY: integer;
  H, S, L, n, x, y: integer;
  Rb, Gb, Bb: byte;
begin
  //Nuancier 10x18
  with WdMain do
  begin
    MaxImgX := Img1.Width - 1;
    MaxImgY := Img1.Height - 1;
    //Création du pointeur
    ImgBmp_Creation(MaxImgX, MaxImgY);
    with ImgBmp.Canvas do
    begin
      //Efface
      Pen.Color := ClWhite;
      for x := 0 to MaxImgX - 1 do
        Line(x, 0, x, MaxImgY - 1);
      H := 0;
      y := 5;
      repeat
        x := 7;
        S := 100;
        L := 80;
        repeat
          if H <= 360 then
          begin
            Rb := 0;
            Gb := 0;
            Bb := 0;
            HSLtoRGB_H360_S100_L100_RGB255(H, S, L, Rb, Gb, Bb);
            Pen.Color := RGBToColor(Rb, Gb, Bb);
            for n := 0 to 22 do
              Line(x, y + n, x + 58, y + n);
            Inc(H, 2);
            L := L - 6;
            S := S - 5;
          end;
          Inc(x, 64);
        until x > MaxImgX - 21;
        Inc(y, 36);
      until y > MaxImgY - 1;
      for y := 0 to MaxImgY - 1 do
      begin
        for x := 0 to MaxImgY - 1 do
        begin
          //RGB3
          RgbHsl3[x, y].Cl := Pixels[x, y];
          RedGreenBlue(RgbHsl3[x, y].Cl, Rb, Gb, Bb);
          //HSL3
          RGBtoHSL_RGB255_H360_S100_L100(Rb, Gb, Bb, RgbHsl3[x, y].H, RgbHsl3[x, y].S,
            RgbHsl3[x, y].L);
        end;
      end;
    end;
    ImgBmp_vers_Img;
    ImgBmp_Close;
    Wait_Close;
  end;
end;

procedure Nuancier_6x15;
var
  MaxImgX, MaxImgY: integer;
  H, S, L, n, x, y: integer;
  Rb, Gb, Bb: byte;
begin
  //Nuancier 6x15
  with WdMain do
  begin
    MaxImgX := Img1.Width - 1;
    MaxImgY := Img1.Height - 1;
    //Création du pointeur
    ImgBmp_Creation(MaxImgX, MaxImgY);
    //-
    with ImgBmp.Canvas do
    begin
      //Efface
      Pen.Color := ClWhite;
      for x := 0 to MaxImgX - 1 do
        Line(x, 0, x, MaxImgY - 1);
      //-
      H := 0;
      y := 8;
      repeat
        x := 10;
        L := 80;
        S := 90;
        repeat
          if H <= 359 then
          begin
            Rb := 0;
            Gb := 0;
            Bb := 0;
            HSLtoRGB_H360_S100_L100_RGB255(H, S, L, Rb, Gb, Bb);
            Pen.Color := RGBToColor(Rb, Gb, Bb);
            for n := 0 to 33 do
              Line(x, y + n, x + 96, y + n);
            Inc(H, 4);
            L := L - 10;
            S := S - 4;
          end;
          Inc(x, 107);
        until x > MaxImgX - 80;
        Inc(y, 42);
      until y > MaxImgY - 1;
      for y := 0 to MaxImgY - 1 do
      begin
        for x := 0 to MaxImgY - 1 do
        begin
          //RGB3
          RgbHsl3[x, y].Cl := Pixels[x, y];
          RedGreenBlue(RgbHsl3[x, y].Cl, Rb, Gb, Bb);
          RgbHsl3[x, y].R := Rb;
          RgbHsl3[x, y].G := Gb;
          RgbHsl3[x, y].B := Bb;
          //HSL3
          RGBtoHSL_RGB255_H360_S100_L100(Rb, Gb, Bb, RgbHsl3[x, y].H, RgbHsl3[x, y].S,
            RgbHsl3[x, y].L);
        end;
      end;
    end;
    ImgBmp_vers_Img;
    ImgBmp_Close;
    Wait_Close;
  end;
end;

procedure Matrices_Mouse(HB, xy: integer);
var
  n: integer;
begin
  with WdMain do
  begin
    case HB of
      //Haut
      1:
      begin
        case xy of
          1:
          begin
            n := StrToInt(EdC11.Text);
            Inc(n);
            EdC11.Text := IntToStr(n);
          end;
        end;
      end;
      //Bas
      2:
      begin
        case xy of
          1:
          begin
            n := StrToInt(EdC11.Text);
            Dec(n);
            EdC11.Text := IntToStr(n);
          end;
        end;
      end;
    end;
  end;
end;

procedure Lecture;
var
  Txt: Textfile;
  MaxImgX, MaxImgY: integer;
  x, y, n: integer;
  Rb, Gb, Bb: byte;
begin
  AssignFile(Txt, 'Sensibilite.txt');
  Rewrite(Txt);
  with WdMain do
  begin
    MaxImgX := Img1.Width - 1;
    MaxImgY := Img1.Height;
    Wait_Init;
    WdWait.Visible := True;
    //Copie Img1 vers ImgBmp
    ImgBmp_Creation(MaxImgX, MaxImgY);
    Img_vers_ImgBmp;
    //Bleu
    with ImgBmp.Canvas do
    begin
      Rb := 0;
      Gb := 0;
      Bb := 0;
      n := 1;
      for x := 0 to MaxImgX - 1 do
      begin
        Wait_Aff(1, MaxImgX, x);
        for y := 0 to MaxImgX - 1 do
        begin
          RedGreenBlue(Pixels[x, y], Rb, Gb, Bb);
          if (Rb < 255) and (Gb < 255) and (Bb < 255) then
          begin
            if n < 26000 then
            begin
              Ptx[n].x := x;
              Ptx[n].y := y;
            end;
            Writeln(Txt, IntToStr(y));
            Inc(n);
          end;
        end;
      end;
    end;
    ImgBmp_vers_Img;
    ImgBmp_Close;
    Wait_Close;
  end;
  Closefile(txt);
end;

procedure Image_Ouvrir;
var
  jpg: TJPegImage;
  CoefX, CoefY: real;
  Haut, Larg: integer;
begin
  with WdMain do
  begin
    with OpenDialog1 do
    begin
      InitialDir := DirOuvrir;
      if Execute then
      begin
        DirOuvrir := ExtractFilePath(FileName);
        if DirOuvrir[Length(DirOuvrir)] <> '\' then
          DirOuvrir := DirOuvrir + '\';
        DirSauver := DirOuvrir;
        Img_Nom := ExtractFileName(FileName);
        Edit1.Text := ExtractFileName(Img_Nom);
        //Panel au maximum
        PaImg1.Width := ImgMaxX_ + 4;
        PaImg1.Height := ImgMaxY_ + 4;
        //Ajustement de la taille du cadre
        //Récup. taille
        jpg := TJPegImage.Create;
        jpg.LoadFromFile(DirOuvrir + Img_Nom);
        Jpg.GetSize(Larg, Haut);
        PaLa.Caption := IntToStr(Larg);
        PaHa.Caption := IntToStr(Haut);
        if (Larg > PaImg1.Width) or (Haut > PaImg1.Height) then
        begin
          //Reduire
          if Larg >= Haut then
          begin
            CoefX := Larg / Img1.Width;
            PaImg1.Height := Round(Haut / CoefX) + 4;
          end
          else
          begin
            CoefY := Haut / Img1.Height;
            PaImg1.Width := Round(Larg / CoefY) + 4;
          end;
        end
        else
        begin
          //Agrandir
          if Larg >= Haut then
          begin
            CoefX := Img1.Width / Larg;
            PaImg1.Height := Round(Haut * CoefX) + 4;
          end
          else
          begin
            CoefX := Larg / Haut;
            PaImg1.Width := Round(PaImg1.Height * CoefX);
          end;
        end;
        //Chargement Image dans Img1
        Img1.Picture.LoadFromFile(DirOuvrir + Img_Nom);
        Traitement_Init;
        Loader(False);
        Timer1.Enabled := True;
        Loader(True);
      end;
    end;
  end;
end;

procedure Image_Sauver;
var
  Fichier: string;
  MaxImgX, MaxImgY: integer;
begin
  with WdMain do
  begin
    Fichier := Img_Nom;
    if Img_Nom <> '' then
    begin
      Fichier := ChangeFileExt(Fichier, '') + '-' + IntToStr(Sauve_Nb) +
        ExtractFileExt(Fichier);
      with SaveDialog1 do
      begin
        FileName := Fichier;
        InitialDir := DirSauver;
        if Execute then
        begin
          DirSauver := ExtractFilePath(FileName);
          Fichier := ExtractFileName(FileName);
          Edit1.Text := Fichier;
          MaxImgX := Img1.Width;
          MaxImgY := Img1.Height;
          ImgJpg_Creation(MaxImgX, MaxImgY);
          Img_vers_ImgJpg;
          ImgJpg.SaveToFile(DirSauver + Fichier);
          ImgJpg_Close;
          Inc(Sauve_Nb);
        end;
      end;
    end;
  end;
end;

procedure Img_Initiale;
begin
  //Affiche Img0
  Traitement_Init;
  RGB0_vers_Img;
  Histogrammes(1);
end;

procedure Img_Mem;
begin
  //RGB3 vers RGB2
  Traitement_Init;
  Loader(False);
  Data3_vers_Data2;
  Loader(True);
end;

procedure Matrice_Affiche;
begin
  Chargement_du_Masque;
  Affiche_Matrice_RGB_HSL(Mt_Niveau);
  Histogrammes(3);
  if WdMain.CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.MenuItem34Click(Sender: TObject);
begin
  //R uniquement
  RGB_vers_R_G_B(1);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem35Click(Sender: TObject);
begin
  //G uniquement
  RGB_vers_R_G_B(2);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem36Click(Sender: TObject);
begin
  //B uniquement
  RGB_vers_R_G_B(3);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem39Click(Sender: TObject);
begin
  //Aide
  WdAide.Show;
end;

procedure TWdMain.SpeedButton10Click(Sender: TObject);
begin
  Median_Cut(3, 3);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton12Click(Sender: TObject);
begin
  MT_Amplitude := MT_Amplitude + 0.1;
  Edit4.Text := RealToStr(MT_Amplitude, 1);
  Matrice_Affiche;
end;

procedure TWdMain.SpeedButton13Click(Sender: TObject);
begin
  Median_Cut(5, 5);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton15Click(Sender: TObject);
begin
  Median_Cut(7, 7);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton14Click(Sender: TObject);
begin
  Median_Cut(11, 11);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.Img1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
begin
  Img_XY_RGB_HSL(1, X, Y);
  Zoom_Affiche(1, X, Y);
end;

procedure TWdMain.MenuItem10Click(Sender: TObject);
begin
  //Dégradé Spectre HL
  HSL_Total(5);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem11Click(Sender: TObject);
begin
  Diagramme_de_chromaticite(1);
end;

procedure TWdMain.MenuItem12Click(Sender: TObject);
begin
  //Dégradé S
  HSL_Total(2);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem13Click(Sender: TObject);
begin
  //Dégradé L
  HSL_Total(3);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem14Click(Sender: TObject);
begin
  //Dégradé S et L
  HSL_Total(6);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem16Click(Sender: TObject);
begin
  //Dégradé 0..60 - Rouge -> Jaune
  HSL_Total(7);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem17Click(Sender: TObject);
begin
  //Dégradé 60..120 - Vert clair -> Vert foncé
  HSL_Total(8);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem18Click(Sender: TObject);
begin
  //Dégradé 120..180 - Vert foncé -> Bleu clair
  HSL_Total(9);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem19Click(Sender: TObject);
begin
  //Dégradé 180..240 - Bleu clair -> Bleu foncé
  HSL_Total(10);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem20Click(Sender: TObject);
begin
  //Dégradé 240..300 - Bleu foncé -> Violet
  HSL_Total(11);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem21Click(Sender: TObject);
begin
  //Dégradé 300..360 - Violet -> Rouge
  HSL_Total(12);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem23Click(Sender: TObject);
begin
  //Nuancier 6x15
  Nuancier_6x15;
  Histogrammes(3);
end;

procedure TWdMain.MenuItem24Click(Sender: TObject);
begin
  //Nuancier 10x18
  Nuancier_10x18;
  Histogrammes(3);
end;

procedure TWdMain.MenuItem25Click(Sender: TObject);
begin
  Diagramme_de_chromaticite(2);
end;

procedure TWdMain.MenuItem26Click(Sender: TObject);
begin
  Diagramme_de_chromaticite(3);
end;

procedure TWdMain.MenuItem27Click(Sender: TObject);
begin
  //Dégradé HL
  Genere_Couleurs(1);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem28Click(Sender: TObject);
begin
  //Dégradé HL
  Genere_Couleurs(2);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem29Click(Sender: TObject);
begin
  //Dégradé HL
  Genere_Couleurs(3);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem2Click(Sender: TObject);
begin
  //Quitter
  WdMain.Close;
end;

procedure TWdMain.MenuItem30Click(Sender: TObject);
begin
  //Dégradé HL
  Genere_Couleurs(4);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem31Click(Sender: TObject);
begin
  //Dégradé HL
  Genere_Couleurs(5);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem32Click(Sender: TObject);
begin
  //Dégradé HL
  Genere_Couleurs(6);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem40Click(Sender: TObject);
begin
  //Rouge et Vert
  RGB_vers_R_G_B(4);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem41Click(Sender: TObject);
begin
  //Rouge et Bleu
  RGB_vers_R_G_B(5);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem42Click(Sender: TObject);
begin
  //Vert et Bleu
  RGB_vers_R_G_B(6);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem4Click(Sender: TObject);
begin
  //Convertisseur
  WdConvert.Show;
end;

procedure TWdMain.MenuItem5Click(Sender: TObject);
begin
  //Sauver
  Image_Sauver;
end;

procedure TWdMain.MenuItem6Click(Sender: TObject);
begin
  //Fichier
  Image_Ouvrir;
end;

procedure TWdMain.MenuItem8Click(Sender: TObject);
begin
  //Dégradé Spectre H
  HSL_Total(1);
  Histogrammes(3);
end;

procedure TWdMain.MenuItem9Click(Sender: TObject);
begin
  //Dégradé Spectre HS
  HSL_Total(4);
  Histogrammes(3);
end;

procedure TWdMain.PaSelectClick(Sender: TObject);
begin

end;

procedure TWdMain.Pn63Click(Sender: TObject);
begin

end;

procedure TWdMain.SpBLoadClick(Sender: TObject);
begin
  Image_Ouvrir;
end;

procedure TWdMain.SpdMemClick(Sender: TObject);
begin
  Img_Mem;
end;

procedure TWdMain.SpdImg2Click(Sender: TObject);
begin
  //Affiche Img2
  Traitement_Init;
  RGB2_vers_Img;
  Histogrammes(2);
end;

procedure TWdMain.SpeedButton17Click(Sender: TObject);
begin
  Median_Cut(9, 9);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton18Click(Sender: TObject);
begin
  MT_Amplitude := MT_Amplitude - 0.1;
  Edit4.Text := RealToStr(MT_Amplitude, 1);
  Matrice_Affiche;
end;

procedure TWdMain.Spdn9Click(Sender: TObject);
begin
  RGB_nCubes_Nc(3);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.Spdn1Click(Sender: TObject);
begin
  RGB_nCubes_Nc(1);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.Spdn12Click(Sender: TObject);
begin
  RGB_nCubes_Nc(4);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.Spdn15Click(Sender: TObject);
begin
  RGB_nCubes_Nc(5);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.Spd02Click(Sender: TObject);
begin
  Img_Mem;
end;

procedure TWdMain.Spdn24Click(Sender: TObject);
begin
  RGB_nCubes_Nc(8);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.Spdn48Click(Sender: TObject);
begin
  RGB_nCubes_Nc(16);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.Spdn96Click(Sender: TObject);
begin
  RGB_nCubes_Nc(32);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpdImg0Click(Sender: TObject);
begin
  Img_Initiale;
end;

procedure TWdMain.SpeedButton1Click(Sender: TObject);
begin
  Traitements(4);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton26Click(Sender: TObject);
begin
  H_HSL_nCubes(2);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton27Click(Sender: TObject);
begin
  H_HSL_nCubes(4);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton28Click(Sender: TObject);
begin
  H_HSL_nCubes(6);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton29Click(Sender: TObject);
begin
  H_HSL_nCubes(8);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.Spdn2Click(Sender: TObject);
begin
  RGB_nCubes_Nc(2);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton2Click(Sender: TObject);
begin
  Traitements(5);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton30Click(Sender: TObject);
begin
  H_HSL_nCubes(10);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton31Click(Sender: TObject);
begin
  H_HSL_nCubes(12);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton32Click(Sender: TObject);
begin
  H_HSL_nCubes(24);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton33Click(Sender: TObject);
begin
  H_HSL_nCubes(36);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton34Click(Sender: TObject);
begin
  H_HSL_nCubes(72);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton35Click(Sender: TObject);
begin
  Effet_S(1);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton36Click(Sender: TObject);
begin
  Traitements(1);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton37Click(Sender: TObject);
begin
  S_HSL_nCubes(2);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton38Click(Sender: TObject);
begin
  S_HSL_nCubes(4);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton39Click(Sender: TObject);
begin
  S_HSL_nCubes(5);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton3Click(Sender: TObject);
var
  MaxFeX, MaxFeY: integer;
  n, p: integer;
begin
  //Fenetre NxN
  //1:x 2:y 3:decal
  MaxFeX := 5;
  MaxFeY := 5;
  //Masque_Chargement(0);
  for p := 1 to MaxFeY do
  begin
    for n := 1 to MaxFeX do
    begin
      //5x5
      Matrice5x5.M5x5[n, p] := Matrice_5x5_Creation_[n, p];
    end;
  end;
  Masque_vers_Saisie;
end;

procedure TWdMain.SpeedButton40Click(Sender: TObject);
begin
  S_HSL_nCubes(10);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton41Click(Sender: TObject);
begin
  S_HSL_nCubes(20);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton42Click(Sender: TObject);
begin
  S_HSL_nCubes(25);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton43Click(Sender: TObject);
var
  G: real;
begin
  G := ComboBox1.ItemIndex / 10;
  if G < 5 then
  begin
    if G = 0.05 then
    begin
      ComboBox1.ItemIndex := 1;
    end
    else
    begin
      G := G + 0.1;
      ComboBox1.ItemIndex := Round(G * 10);
    end;
    Gamma_var(G);
    Histogrammes(3);
  end;
end;

procedure TWdMain.SpeedButton4Click(Sender: TObject);
begin
  MT_Matrice := 0;
  CbMatrices.ItemIndex := MT_Matrice;
  Matrice_Affiche;
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton50Click(Sender: TObject);
begin
  H_HSL_nCubes(88);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton51Click(Sender: TObject);
var
  G: real;
begin
  G := ComboBox1.ItemIndex / 10;
  if G > 0 then
  begin
    if G = 0.1 then
    begin
      G := 0.05;
      ComboBox1.ItemIndex := 0;
    end
    else
    begin
      G := G - 0.1;
      ComboBox1.ItemIndex := Round(G * 10);
    end;
    Gamma_var(G);
    Histogrammes(3);
  end;
end;

procedure TWdMain.SpdNv1Click(Sender: TObject);
begin
  Niveau_1;
end;

procedure TWdMain.SpdNv2Click(Sender: TObject);
begin
  Niveau_2;
end;

procedure TWdMain.SpdPlusClick(Sender: TObject);
begin
  Matrices_Var(1);
end;

procedure TWdMain.SpdMoinsClick(Sender: TObject);
begin
  Matrices_Var(0);
end;

procedure TWdMain.SpeedButton52Click(Sender: TObject);
begin
  L_HSL_nCubes(34);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton5Click(Sender: TObject);
begin
  Image_Sauver;
end;

procedure TWdMain.SpeedButton44Click(Sender: TObject);
begin
  Traitements(2);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton45Click(Sender: TObject);
begin
  L_HSL_nCubes(2);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton46Click(Sender: TObject);
begin
  L_HSL_nCubes(4);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton47Click(Sender: TObject);
begin
  L_HSL_nCubes(5);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton48Click(Sender: TObject);
begin
  L_HSL_nCubes(10);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton49Click(Sender: TObject);
begin
  L_HSL_nCubes(20);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.Spd00Click(Sender: TObject);
begin
  Img_Initiale;
end;

procedure TWdMain.SpdHistoClick(Sender: TObject);
begin
  if WdHisto.Visible then
    WdHisto.Visible := False
  else
    WdHisto.Visible := True;
end;

procedure TWdMain.SpeedButton6Click(Sender: TObject);
begin
  Traitements(6);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.SpeedButton7Click(Sender: TObject);
begin
  Traitements(7);
  Histogrammes(3);
  if CkMem.Checked then
    Img_Mem;
end;

procedure TWdMain.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  Img_vers_RGB0;
  Histogrammes(1);
  WdMain.Enabled := True;
  with WdHisto do
  begin
    Width := 772;
    Height := 300;
    Left := WdMain.Left + WdMain.Width - Width + (Width div 6);
    Top := WdMain.Top + WdMain.Height - Height;
    //Show;
  end;
  Loader(True);
  if not WdAide.CheckAide.Checked then
    WdAIde.Show;
end;

procedure TWdMain.ImgHistoHMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
begin
  Img_XY_RGB_HSL(2, X, Y);
end;

procedure TWdMain.CheckBox1Change(Sender: TObject);
begin
  if CheckBox1.Checked then
    Img1.Stretch := True
  else
    Img1.Stretch := False;
end;

procedure TWdMain.CkMemChange(Sender: TObject);
begin
  if CkMem.Checked then
  begin
    Img_Mem;
    CkMem.Caption := 'On';
    SpdMem.Enabled := False;
  end
  else
  begin
    CkMem.Caption := 'Off';
    SpdMem.Enabled := True;
  end;
end;

procedure TWdMain.ComboBox1Change(Sender: TObject);
var
  G: real;
begin
  case ComboBox1.ItemIndex of
    0: G := 0.05;
    else
    begin
      G := ComboBox1.ItemIndex / 10;
    end;
  end;
  Gamma_var(G);
  Histogrammes(3);
end;

procedure TWdMain.CbMatricesChange(Sender: TObject);
begin
  MT_Matrice := CbMatrices.ItemIndex;
  Matrice_Affiche;
end;

procedure TWdMain.ComboBox2Change(Sender: TObject);
begin
  case ComboBox2.ItemIndex of
    0: SupIso := 0;
    1: SupIso := 500;
    2: SupIso := 1000;
    3: SupIso := 1500;
    4: SupIso := 200;
  end;
end;

procedure TWdMain.ComboBox4Change(Sender: TObject);
begin
  MT_Amplitude := ComboBox4.ItemIndex - 30;
  Edit4.Text := RealToStr(MT_Amplitude, 1);
  Matrice_Affiche;
end;

procedure TWdMain.ComboBox6Change(Sender: TObject);
begin
  case ComboBox6.ItemIndex of
    0: Isoles(2);
    1: Isoles(3);
    2: Isoles(4);
    3: Isoles(5);
    4: Isoles(6);
    5: Isoles(7);
    6: Isoles(8);
    7: Isoles(9);
    8: Isoles(10);
    9: Isoles(11);
    10: Isoles(12);
    11: Isoles(13);
    12: Isoles(14);
    13: Isoles(15);
    14: Isoles(16);
  end;
end;

procedure TWdMain.EdC11MouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: boolean);
begin
  Matrices_Mouse(2, 1);
end;

procedure TWdMain.EdC11MouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: boolean);
begin
  Matrices_Mouse(1, 1);
end;

procedure TWdMain.EdC11Click(Sender: TObject);
begin
  MT_Focus := 1;
end;

procedure TWdMain.EdC11Change(Sender: TObject);
begin
  Matrice_Test(1);
end;

procedure TWdMain.EdC21Click(Sender: TObject);
begin
  MT_Focus := 2;
end;

procedure TWdMain.EdC21Change(Sender: TObject);
begin
  Matrice_Test(2);
end;

procedure TWdMain.EdC31Click(Sender: TObject);
begin
  MT_Focus := 3;
end;

procedure TWdMain.EdC31Change(Sender: TObject);
begin
  Matrice_Test(3);
end;

procedure TWdMain.EdC41Click(Sender: TObject);
begin
  MT_Focus := 4;
end;

procedure TWdMain.EdC41Change(Sender: TObject);
begin
  Matrice_Test(4);
end;

procedure TWdMain.EdC51Click(Sender: TObject);
begin
  MT_Focus := 5;
end;

procedure TWdMain.EdC51Change(Sender: TObject);
begin
  Matrice_Test(5);
end;

procedure TWdMain.EdC12Click(Sender: TObject);
begin
  MT_Focus := 6;
end;

procedure TWdMain.EdC12Change(Sender: TObject);
begin
  Matrice_Test(6);
end;

procedure TWdMain.EdC22Click(Sender: TObject);
begin
  MT_Focus := 7;
end;

procedure TWdMain.EdC22Change(Sender: TObject);
begin
  Matrice_Test(7);
end;

procedure TWdMain.EdC32Click(Sender: TObject);
begin
  MT_Focus := 8;
end;

procedure TWdMain.EdC32Change(Sender: TObject);
begin
  Matrice_Test(8);
end;

procedure TWdMain.EdC42Click(Sender: TObject);
begin
  MT_Focus := 9;
end;

procedure TWdMain.EdC42Change(Sender: TObject);
begin
  Matrice_Test(9);
end;

procedure TWdMain.EdC52Click(Sender: TObject);
begin
  MT_Focus := 10;
end;

procedure TWdMain.EdC52Change(Sender: TObject);
begin
  Matrice_Test(10);
end;

procedure TWdMain.EdC13Click(Sender: TObject);
begin
  MT_Focus := 11;
end;

procedure TWdMain.EdC13Change(Sender: TObject);
begin
  Matrice_Test(11);
end;

procedure TWdMain.EdC23Click(Sender: TObject);
begin
  MT_Focus := 12;
end;

procedure TWdMain.EdC23Change(Sender: TObject);
begin
  Matrice_Test(12);
end;

procedure TWdMain.EdC33Click(Sender: TObject);
begin
  MT_Focus := 13;
end;

procedure TWdMain.EdC33Change(Sender: TObject);
begin
  Matrice_Test(13);
end;

procedure TWdMain.EdC43Click(Sender: TObject);
begin
  MT_Focus := 14;
end;

procedure TWdMain.EdC43Change(Sender: TObject);
begin
  Matrice_Test(14);
end;

procedure TWdMain.EdC53Click(Sender: TObject);
begin
  MT_Focus := 15;
end;

procedure TWdMain.EdC53Change(Sender: TObject);
begin
  Matrice_Test(15);
end;

procedure TWdMain.EdC14Click(Sender: TObject);
begin
  MT_Focus := 16;
end;

procedure TWdMain.EdC14Change(Sender: TObject);
begin
  Matrice_Test(16);
end;

procedure TWdMain.EdC24Click(Sender: TObject);
begin
  MT_Focus := 17;
end;

procedure TWdMain.EdC24Change(Sender: TObject);
begin
  Matrice_Test(17);
end;

procedure TWdMain.EdC34Click(Sender: TObject);
begin
  MT_Focus := 18;
end;

procedure TWdMain.EdC34Change(Sender: TObject);
begin
  Matrice_Test(18);
end;

procedure TWdMain.EdC44Click(Sender: TObject);
begin
  MT_Focus := 19;
end;

procedure TWdMain.EdC44Change(Sender: TObject);
begin
  Matrice_Test(19);
end;

procedure TWdMain.EdC54Click(Sender: TObject);
begin
  MT_Focus := 20;
end;

procedure TWdMain.EdC54Change(Sender: TObject);
begin
  Matrice_Test(20);
end;

procedure TWdMain.EdC15Click(Sender: TObject);
begin
  MT_Focus := 21;
end;

procedure TWdMain.EdC15Change(Sender: TObject);
begin
  Matrice_Test(21);
end;

procedure TWdMain.EdC25Click(Sender: TObject);
begin
  MT_Focus := 22;
end;

procedure TWdMain.EdC25Change(Sender: TObject);
begin
  Matrice_Test(22);
end;

procedure TWdMain.EdC35Click(Sender: TObject);
begin
  MT_Focus := 23;
end;

procedure TWdMain.EdC35Change(Sender: TObject);
begin
  Matrice_Test(23);
end;

procedure TWdMain.EdC45Click(Sender: TObject);
begin
  MT_Focus := 24;
end;

procedure TWdMain.EdC45Change(Sender: TObject);
begin
  Matrice_Test(24);
end;

procedure TWdMain.EdC55Click(Sender: TObject);
begin
  MT_Focus := 25;
end;

procedure TWdMain.EdC55Change(Sender: TObject);
begin
  Matrice_Test(25);
end;

procedure TWdMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Stop := True;
  Ini_Sauve;
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  Randomize;
  WdMain.Width := WinMaxX_;
  WdMain.Height := WinMaxY_;
  //IniFile
  WdAide.CheckAide.Checked := False;
  Ini_Lire;
  //Ouvrir et Sauver
  DirOuvrir := ExtractFilePath(Application.ExeName);
  if DirOuvrir[Length(DirOuvrir)] <> '\' then
    DirOuvrir := DirOuvrir + '\';
  DirSauver := DirOuvrir;
  Sauve_Nb := 2;
  //Image
  Img_Nom := 'Oiseau.jpg';
  Edit1.Text := Img_Nom;
  //Luminence
  //Img_Efface;
  PaLa.Caption := IntToStr(Img1.Width);
  PaHa.Caption := IntToStr(Img1.Height);
  //Traitement Init.
  Traitement_Init;
  //HSL_Total(5);
  Loader(False);
  Wait_Init;
  //Timer
  Timer1.Enabled := True;
  //Suppr. des pixels isolés
  SupIso := 1000;
  //Contraste
  //Facteur : F = 259(C+255) / 255(259-C)
  //R2=F(R1-128)+128
  //Mettre un fichier INI
end;

end.
